from ppms import ppms

from csrpc.utils import access
from ppms.constants import *

from ppms.communication import extract_serialized_data

FILE_SCRIPT = """import open_editor

from System.Windows.Forms import MessageBox

open_editor.PythonFile('''{filename_base64}''', '''{script_base64}''',
                        {ddi_dt_id}, {key_val}, {di}, r'''{editor}''',
                        r'''{key_base64}''')"""

FILE_SCRIPT_SUBCLASS = """import open_editor

open_editor.PythonSubclassFile('''{filename_base64}''', '''{script_base64}''',
                                  r'''{permpath}''', r'''{editor}''',
                                  r'''{key_base64}''')"""


def save_file_python(py_script, dt, key_val, di):
    script = extract_serialized_data(py_script)
    key_val = [key_val]
    rec = ppms.search_record(dt, key_val, [di], True)
    if rec:
        di = rec.get_di_by_id(di)
        current_val = di.get_value()

        if current_val != script:
            assert di.set_value(script) == 0 and rec.save(), 'Could not save python code for object ' + str(
                key_val[0]) + ' - too long?'
    return


def save_file_python_subclass(py_script, path):
    script = extract_serialized_data(py_script, 'utf-8')

    with open(path, 'w', encoding='utf-8') as f:
        f.write(script)
    return


def open_editor(filename_base64, script_base64, ddi_dt_id, key_val, di, editor='notepad', key_base64=None):
    if access.service_is_available('editor'):
        if isinstance(key_val, int):
            key_val = str(key_val)
        elif isinstance(key_val, str):
            key_val = key_val.replace("'", "").replace('"', '')
        else:
            key_val = str(key_val).replace("'", "").replace('"', '').replace('[', '').replace(']', '')

        remote_editor = access.remote_service('editor')
        remote_editor.open_editor(filename_base64, script_base64, ddi_dt_id, key_val, di, editor, key_base64,
                                  save_file_python)
    else:
        file_script = FILE_SCRIPT.format(**locals())
        ppms.client_exec(file_script)


def open_editor_subclass(filename_base64, script_base64, permpath, editor='notepad', key_base64=None):
    if access.service_is_available('editor'):
        remote_editor = access.remote_service('editor')
        remote_editor.open_editor(filename_base64, script_base64, permpath, editor, key_base64,
                                  save_file_python_subclass)
    else:
        file_script = FILE_SCRIPT_SUBCLASS.format(**locals())
        ppms.client_exec(file_script)
