import rpyc
from ppms import ppms
from ppms import ppms_cu


class WorkflowBarHandler(rpyc.Service):
    def exposed_focus_df(self, val):

        val = val

        inv_obj = ppms.get_focused_module()

        open_mods = ppms_cu.Access(inv_obj).get_all_open_modules()
        pr_process_module = ppms_cu.Helper.get_global_setting("pr_process_module").alpha120.get_value()
        val = val.replace("_", "")

        # focus pr_process_module

        if pr_process_module in open_mods.keys():
            mod_obj = open_mods[pr_process_module]
            mod_obj.focus()

        recs = []
        da_names = ["phase_finished_child", "steps_current", "steps_delivered"]

        for da_name in da_names:
            if hasattr(mod_obj, da_name):
                recs += mod_obj.get_da(da_name).get_records()

        counter = 0
        for rec in recs:
            pointer = rec.phase.get_text_value()
            if pointer == val and counter == 0:
                counter = 1
                rec.scroll_to()
                if hasattr(rec.get_parent(), 'phase_name'):
                    rec.get_parent().phase_name.focus()
        return