﻿#!/usr/bin/env python

#
# Generated Sun Jun  6 20:09:40 2010 by generateDS.py version 1.20g.
#

import sys
import getopt
#from string import lower as str_lower
from xml.dom import minidom
from xml.dom import Node

#
# User methods
#
# Calls to the methods in these classes are generated by generateDS.py.
# You can replace these methods by re-implementing the following class
#   in a module named generatedssuper.py.

try:
    from generatedssuper import GeneratedsSuper
except ImportError as exp:

    class GeneratedsSuper(object):
        def format_string(self, input_data, input_name=''):
            return input_data
        def format_integer(self, input_data, input_name=''):
            return '%d' % input_data
        def format_float(self, input_data, input_name=''):
            return '%f' % input_data
        def format_double(self, input_data, input_name=''):
            return '%e' % input_data
        def format_boolean(self, input_data, input_name=''):
            return '%s' % input_data


#
# If you have installed IPython you can uncomment and use the following.
# IPython is available from http://ipython.scipy.org/.
#

## from IPython.Shell import IPShellEmbed
## args = ''
## ipshell = IPShellEmbed(args,
##     banner = 'Dropping into IPython',
##     exit_msg = 'Leaving Interpreter, back to program.')

# Then use the following line where and when you want to drop into the
# IPython shell:
#    ipshell('<some message> -- Entering ipshell.\nHit Ctrl-D to exit')

#
# Globals
#

ExternalEncoding = 'utf8'

#
# Support/utility functions.
#

def showIndent(outfile, level):
    for idx in range(level):
        outfile.write('    ')

def quote_xml(inStr):
    s1 = (isinstance(inStr, str) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    
    # Microsoft Project does not like umlauts
    s1 = s1.replace('Ä', '&#196;')
    s1 = s1.replace('Ö', '&#214;')
    s1 = s1.replace('Ü', '&#220;')
    s1 = s1.replace('ä', '&#228;')
    s1 = s1.replace('ö', '&#246;')
    s1 = s1.replace('ü', '&#252;')
    s1 = s1.replace('ß', '&#223;')
    
    return s1

def quote_attrib(inStr):
    s1 = (isinstance(inStr, str) and inStr or
          '%s' % inStr)
    s1 = s1.replace('&', '&amp;')
    s1 = s1.replace('<', '&lt;')
    s1 = s1.replace('>', '&gt;')
    if '"' in s1:
        if "'" in s1:
            s1 = '"%s"' % s1.replace('"', "&quot;")
        else:
            s1 = "'%s'" % s1
    else:
        s1 = '"%s"' % s1
    return s1

def quote_python(inStr):
    s1 = inStr
    if s1.find("'") == -1:
        if s1.find('\n') == -1:
            return "'%s'" % s1
        else:
            return "'''%s'''" % s1
    else:
        if s1.find('"') != -1:
            s1 = s1.replace('"', '\\"')
        if s1.find('\n') == -1:
            return '"%s"' % s1
        else:
            return '"""%s"""' % s1


class MixedContainer:
    # Constants for category:
    CategoryNone = 0
    CategoryText = 1
    CategorySimple = 2
    CategoryComplex = 3
    # Constants for content_type:
    TypeNone = 0
    TypeText = 1
    TypeString = 2
    TypeInteger = 3
    TypeFloat = 4
    TypeDecimal = 5
    TypeDouble = 6
    TypeBoolean = 7
    def __init__(self, category, content_type, name, value):
        self.category = category
        self.content_type = content_type
        self.name = name
        self.value = value
    def getCategory(self):
        return self.category
    def getContenttype(self, content_type):
        return self.content_type
    def getValue(self):
        return self.value
    def getName(self):
        return self.name
    def export(self, outfile, level, name, namespace):
        if self.category == MixedContainer.CategoryText:
            outfile.write(self.value)
        elif self.category == MixedContainer.CategorySimple:
            self.exportSimple(outfile, level, name)
        else:    # category == MixedContainer.CategoryComplex
            self.value.export(outfile, level, namespace,name)
    def exportSimple(self, outfile, level, name):
        if self.content_type == MixedContainer.TypeString:
            outfile.write('<%s>%s</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeInteger or \
                self.content_type == MixedContainer.TypeBoolean:
            outfile.write('<%s>%d</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeFloat or \
                self.content_type == MixedContainer.TypeDecimal:
            outfile.write('<%s>%f</%s>' % (self.name, self.value, self.name))
        elif self.content_type == MixedContainer.TypeDouble:
            outfile.write('<%s>%g</%s>' % (self.name, self.value, self.name))
    def exportLiteral(self, outfile, level, name):
        if self.category == MixedContainer.CategoryText:
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        elif self.category == MixedContainer.CategorySimple:
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s", "%s"),\n' % \
                (self.category, self.content_type, self.name, self.value))
        else:    # category == MixedContainer.CategoryComplex
            showIndent(outfile, level)
            outfile.write('model_.MixedContainer(%d, %d, "%s",\n' % \
                (self.category, self.content_type, self.name,))
            self.value.exportLiteral(outfile, level + 1)
            showIndent(outfile, level)
            outfile.write(')\n')


class MemberSpec_(object):
    def __init__(self, name='', data_type='', container=0):
        self.name = name
        self.data_type = data_type
        self.container = container
    def set_name(self, name): self.name = name
    def get_name(self): return self.name
    def set_data_type(self, data_type): self.data_type = data_type
    def get_data_type_chain(self): return self.data_type
    def get_data_type(self):
        if isinstance(self.data_type, list):
            if len(self.data_type) > 0:
                return self.data_type[-1]
            else:
                return 'xs:string'
        else:
            return self.data_type
    def set_container(self, container): self.container = container
    def get_container(self): return self.container

def _cast(typ, value):
    if typ is None or value is None:
        return value
    return typ(value)

#
# Data representation classes.
#

class TimephasedDataType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Type=None, UID=None, Start=None, Finish=None, Unit=None, Value=None):
        self.Type = Type
        self.UID = UID
        self.Start = Start
        self.Finish = Finish
        self.Unit = Unit
        self.Value = Value
    def factory(*args_, **kwargs_):
        if TimephasedDataType.subclass:
            return TimephasedDataType.subclass(*args_, **kwargs_)
        else:
            return TimephasedDataType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def get_Start(self): return self.Start
    def set_Start(self, Start): self.Start = Start
    def get_Finish(self): return self.Finish
    def set_Finish(self, Finish): self.Finish = Finish
    def get_Unit(self): return self.Unit
    def set_Unit(self, Unit): self.Unit = Unit
    def validate_Unit(self, value):
        # Validate type Unit, a restriction on xsd:integer.
        pass
    def get_Value(self): return self.Value
    def set_Value(self, Value): self.Value = Value
    def export(self, outfile, level, namespace_='', name_='TimephasedDataType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='TimephasedDataType')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='TimephasedDataType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='TimephasedDataType'):
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('<%sStart>%s</%sStart>\n' % (namespace_, self.format_string(quote_xml(self.Start), input_name='Start'), namespace_))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinish>%s</%sFinish>\n' % (namespace_, self.format_string(quote_xml(self.Finish), input_name='Finish'), namespace_))
        if self.Unit is not None:
            showIndent(outfile, level)
            outfile.write('<%sUnit>%s</%sUnit>\n' % (namespace_, self.format_string(quote_xml(self.Unit), input_name='Unit'), namespace_))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('<%sValue>%s</%sValue>\n' % (namespace_, self.format_string(quote_xml(self.Value), input_name='Value'), namespace_))
    def hasContent_(self):
        if (
            self.Type is not None or
            self.UID is not None or
            self.Start is not None or
            self.Finish is not None or
            self.Unit is not None or
            self.Value is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='TimephasedDataType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('Start=%s,\n' % quote_python(self.Start))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('Finish=%s,\n' % quote_python(self.Finish))
        if self.Unit is not None:
            showIndent(outfile, level)
            outfile.write('Unit=%s,\n' % quote_python(self.Unit))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('Value=%s,\n' % quote_python(self.Value))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Start':
            Start_ = ''
            for text__content_ in child_.childNodes:
                Start_ += text__content_.nodeValue
            self.Start = Start_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Finish':
            Finish_ = ''
            for text__content_ in child_.childNodes:
                Finish_ += text__content_.nodeValue
            self.Finish = Finish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Unit':
            Unit_ = ''
            for text__content_ in child_.childNodes:
                Unit_ += text__content_.nodeValue
            self.Unit = Unit_
            self.validate_Unit(self.Unit)    # validate type Unit
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Value':
            Value_ = ''
            for text__content_ in child_.childNodes:
                Value_ += text__content_.nodeValue
            self.Value = Value_
# end class TimephasedDataType


class Type(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Type.subclass:
            return Type.subclass(*args_, **kwargs_)
        else:
            return Type(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Type', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Type')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Type'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Type'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Type'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Type


class Unit(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Unit.subclass:
            return Unit.subclass(*args_, **kwargs_)
        else:
            return Unit(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Unit', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Unit')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Unit'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Unit'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Unit'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Unit


class Project(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, UID=None, Name=None, Title=None, Subject=None, Category=None, Company=None, Manager=None, Author=None, CreationDate=None, Revision=None, LastSaved=None, ScheduleFromStart='true', StartDate=None, FinishDate=None, FYStartDate=None, CriticalSlackLimit=None, CurrencyDigits=None, CurrencySymbol=None, CurrencySymbolPosition=None, CalendarUID=None, DefaultStartTime=None, DefaultFinishTime=None, MinutesPerDay=None, MinutesPerWeek=None, DaysPerMonth=None, DefaultTaskType='1', DefaultFixedCostAccrual=None, DefaultStandardRate=None, DefaultOvertimeRate=None, DurationFormat=None, WorkFormat=None, EditableActualCosts='false', HonorConstraints='true', EarnedValueMethod=None, InsertedProjectsLikeSummary='true', MultipleCriticalPaths='false', NewTasksEffortDriven='true', NewTasksEstimated='true', SplitsInProgressTasks='true', SpreadActualCost='true', SpreadPercentComplete='false', TaskUpdatesResource=None, FiscalYearStart=None, WeekStartDay=None, MoveCompletedEndsBack='false', MoveRemainingStartsBack='false', MoveRemainingStartsForward='false', MoveCompletedEndsForward='false', BaselineForEarnedValue=None, AutoAddNewResourcesAndTasks='true', StatusDate=None, CurrentDate=None, MicrosoftProjectServerURL=None, Autolink=None, NewTaskStartDate=None, DefaultTaskEVMethod=None, ProjectExternallyEdited=None, ExtendedCreationDate=None, ActualsInSync=None, RemoveFileProperties=None, AdminProject=None, OutlineCodes=None, WBSMasks=None, ExtendedAttributes=None, Calendars=None, Tasks=None, Resources=None, Assignments=None):
        self.UID = UID
        self.Name = Name
        self.Title = Title
        self.Subject = Subject
        self.Category = Category
        self.Company = Company
        self.Manager = Manager
        self.Author = Author
        self.CreationDate = CreationDate
        self.Revision = Revision
        self.LastSaved = LastSaved
        self.ScheduleFromStart = ScheduleFromStart
        self.StartDate = StartDate
        self.FinishDate = FinishDate
        self.FYStartDate = FYStartDate
        self.CriticalSlackLimit = CriticalSlackLimit
        self.CurrencyDigits = CurrencyDigits
        self.CurrencySymbol = CurrencySymbol
        self.CurrencySymbolPosition = CurrencySymbolPosition
        self.CalendarUID = CalendarUID
        self.DefaultStartTime = DefaultStartTime
        self.DefaultFinishTime = DefaultFinishTime
        self.MinutesPerDay = MinutesPerDay
        self.MinutesPerWeek = MinutesPerWeek
        self.DaysPerMonth = DaysPerMonth
        self.DefaultTaskType = DefaultTaskType
        self.DefaultFixedCostAccrual = DefaultFixedCostAccrual
        self.DefaultStandardRate = DefaultStandardRate
        self.DefaultOvertimeRate = DefaultOvertimeRate
        self.DurationFormat = DurationFormat
        self.WorkFormat = WorkFormat
        self.EditableActualCosts = EditableActualCosts
        self.HonorConstraints = HonorConstraints
        self.EarnedValueMethod = EarnedValueMethod
        self.InsertedProjectsLikeSummary = InsertedProjectsLikeSummary
        self.MultipleCriticalPaths = MultipleCriticalPaths
        self.NewTasksEffortDriven = NewTasksEffortDriven
        self.NewTasksEstimated = NewTasksEstimated
        self.SplitsInProgressTasks = SplitsInProgressTasks
        self.SpreadActualCost = SpreadActualCost
        self.SpreadPercentComplete = SpreadPercentComplete
        self.TaskUpdatesResource = TaskUpdatesResource
        self.FiscalYearStart = FiscalYearStart
        self.WeekStartDay = WeekStartDay
        self.MoveCompletedEndsBack = MoveCompletedEndsBack
        self.MoveRemainingStartsBack = MoveRemainingStartsBack
        self.MoveRemainingStartsForward = MoveRemainingStartsForward
        self.MoveCompletedEndsForward = MoveCompletedEndsForward
        self.BaselineForEarnedValue = BaselineForEarnedValue
        self.AutoAddNewResourcesAndTasks = AutoAddNewResourcesAndTasks
        self.StatusDate = StatusDate
        self.CurrentDate = CurrentDate
        self.MicrosoftProjectServerURL = MicrosoftProjectServerURL
        self.Autolink = Autolink
        self.NewTaskStartDate = NewTaskStartDate
        self.DefaultTaskEVMethod = DefaultTaskEVMethod
        self.ProjectExternallyEdited = ProjectExternallyEdited
        self.ExtendedCreationDate = ExtendedCreationDate
        self.ActualsInSync = ActualsInSync
        self.RemoveFileProperties = RemoveFileProperties
        self.AdminProject = AdminProject
        self.OutlineCodes = OutlineCodes
        self.WBSMasks = WBSMasks
        self.ExtendedAttributes = ExtendedAttributes
        self.Calendars = Calendars
        self.Tasks = Tasks
        self.Resources = Resources
        self.Assignments = Assignments
    def factory(*args_, **kwargs_):
        if Project.subclass:
            return Project.subclass(*args_, **kwargs_)
        else:
            return Project(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def validate_UID(self, value):
        # Validate type UID, a restriction on xsd:string.
        pass
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def validate_Name(self, value):
        # Validate type Name, a restriction on xsd:string.
        pass
    def get_Title(self): return self.Title
    def set_Title(self, Title): self.Title = Title
    def validate_Title(self, value):
        # Validate type Title, a restriction on xsd:string.
        pass
    def get_Subject(self): return self.Subject
    def set_Subject(self, Subject): self.Subject = Subject
    def validate_Subject(self, value):
        # Validate type Subject, a restriction on xsd:string.
        pass
    def get_Category(self): return self.Category
    def set_Category(self, Category): self.Category = Category
    def validate_Category(self, value):
        # Validate type Category, a restriction on xsd:string.
        pass
    def get_Company(self): return self.Company
    def set_Company(self, Company): self.Company = Company
    def validate_Company(self, value):
        # Validate type Company, a restriction on xsd:string.
        pass
    def get_Manager(self): return self.Manager
    def set_Manager(self, Manager): self.Manager = Manager
    def validate_Manager(self, value):
        # Validate type Manager, a restriction on xsd:string.
        pass
    def get_Author(self): return self.Author
    def set_Author(self, Author): self.Author = Author
    def validate_Author(self, value):
        # Validate type Author, a restriction on xsd:string.
        pass
    def get_CreationDate(self): return self.CreationDate
    def set_CreationDate(self, CreationDate): self.CreationDate = CreationDate
    def get_Revision(self): return self.Revision
    def set_Revision(self, Revision): self.Revision = Revision
    def get_LastSaved(self): return self.LastSaved
    def set_LastSaved(self, LastSaved): self.LastSaved = LastSaved
    def get_ScheduleFromStart(self): return self.ScheduleFromStart
    def set_ScheduleFromStart(self, ScheduleFromStart): self.ScheduleFromStart = ScheduleFromStart
    def get_StartDate(self): return self.StartDate
    def set_StartDate(self, StartDate): self.StartDate = StartDate
    def get_FinishDate(self): return self.FinishDate
    def set_FinishDate(self, FinishDate): self.FinishDate = FinishDate
    def get_FYStartDate(self): return self.FYStartDate
    def set_FYStartDate(self, FYStartDate): self.FYStartDate = FYStartDate
    def validate_FYStartDate(self, value):
        # Validate type FYStartDate, a restriction on xsd:integer.
        pass
    def get_CriticalSlackLimit(self): return self.CriticalSlackLimit
    def set_CriticalSlackLimit(self, CriticalSlackLimit): self.CriticalSlackLimit = CriticalSlackLimit
    def get_CurrencyDigits(self): return self.CurrencyDigits
    def set_CurrencyDigits(self, CurrencyDigits): self.CurrencyDigits = CurrencyDigits
    def get_CurrencySymbol(self): return self.CurrencySymbol
    def set_CurrencySymbol(self, CurrencySymbol): self.CurrencySymbol = CurrencySymbol
    def validate_CurrencySymbol(self, value):
        # Validate type CurrencySymbol, a restriction on xsd:string.
        pass
    def get_CurrencySymbolPosition(self): return self.CurrencySymbolPosition
    def set_CurrencySymbolPosition(self, CurrencySymbolPosition): self.CurrencySymbolPosition = CurrencySymbolPosition
    def validate_CurrencySymbolPosition(self, value):
        # Validate type CurrencySymbolPosition, a restriction on xsd:integer.
        pass
    def get_CalendarUID(self): return self.CalendarUID
    def set_CalendarUID(self, CalendarUID): self.CalendarUID = CalendarUID
    def get_DefaultStartTime(self): return self.DefaultStartTime
    def set_DefaultStartTime(self, DefaultStartTime): self.DefaultStartTime = DefaultStartTime
    def get_DefaultFinishTime(self): return self.DefaultFinishTime
    def set_DefaultFinishTime(self, DefaultFinishTime): self.DefaultFinishTime = DefaultFinishTime
    def get_MinutesPerDay(self): return self.MinutesPerDay
    def set_MinutesPerDay(self, MinutesPerDay): self.MinutesPerDay = MinutesPerDay
    def get_MinutesPerWeek(self): return self.MinutesPerWeek
    def set_MinutesPerWeek(self, MinutesPerWeek): self.MinutesPerWeek = MinutesPerWeek
    def get_DaysPerMonth(self): return self.DaysPerMonth
    def set_DaysPerMonth(self, DaysPerMonth): self.DaysPerMonth = DaysPerMonth
    def get_DefaultTaskType(self): return self.DefaultTaskType
    def set_DefaultTaskType(self, DefaultTaskType): self.DefaultTaskType = DefaultTaskType
    def validate_DefaultTaskType(self, value):
        # Validate type DefaultTaskType, a restriction on xsd:integer.
        pass
    def get_DefaultFixedCostAccrual(self): return self.DefaultFixedCostAccrual
    def set_DefaultFixedCostAccrual(self, DefaultFixedCostAccrual): self.DefaultFixedCostAccrual = DefaultFixedCostAccrual
    def validate_DefaultFixedCostAccrual(self, value):
        # Validate type DefaultFixedCostAccrual, a restriction on xsd:integer.
        pass
    def get_DefaultStandardRate(self): return self.DefaultStandardRate
    def set_DefaultStandardRate(self, DefaultStandardRate): self.DefaultStandardRate = DefaultStandardRate
    def get_DefaultOvertimeRate(self): return self.DefaultOvertimeRate
    def set_DefaultOvertimeRate(self, DefaultOvertimeRate): self.DefaultOvertimeRate = DefaultOvertimeRate
    def get_DurationFormat(self): return self.DurationFormat
    def set_DurationFormat(self, DurationFormat): self.DurationFormat = DurationFormat
    def validate_DurationFormat(self, value):
        # Validate type DurationFormat, a restriction on xsd:integer.
        pass
    def get_WorkFormat(self): return self.WorkFormat
    def set_WorkFormat(self, WorkFormat): self.WorkFormat = WorkFormat
    def validate_WorkFormat(self, value):
        # Validate type WorkFormat, a restriction on xsd:integer.
        pass
    def get_EditableActualCosts(self): return self.EditableActualCosts
    def set_EditableActualCosts(self, EditableActualCosts): self.EditableActualCosts = EditableActualCosts
    def get_HonorConstraints(self): return self.HonorConstraints
    def set_HonorConstraints(self, HonorConstraints): self.HonorConstraints = HonorConstraints
    def get_EarnedValueMethod(self): return self.EarnedValueMethod
    def set_EarnedValueMethod(self, EarnedValueMethod): self.EarnedValueMethod = EarnedValueMethod
    def validate_EarnedValueMethod(self, value):
        # Validate type EarnedValueMethod, a restriction on xsd:integer.
        pass
    def get_InsertedProjectsLikeSummary(self): return self.InsertedProjectsLikeSummary
    def set_InsertedProjectsLikeSummary(self, InsertedProjectsLikeSummary): self.InsertedProjectsLikeSummary = InsertedProjectsLikeSummary
    def get_MultipleCriticalPaths(self): return self.MultipleCriticalPaths
    def set_MultipleCriticalPaths(self, MultipleCriticalPaths): self.MultipleCriticalPaths = MultipleCriticalPaths
    def get_NewTasksEffortDriven(self): return self.NewTasksEffortDriven
    def set_NewTasksEffortDriven(self, NewTasksEffortDriven): self.NewTasksEffortDriven = NewTasksEffortDriven
    def get_NewTasksEstimated(self): return self.NewTasksEstimated
    def set_NewTasksEstimated(self, NewTasksEstimated): self.NewTasksEstimated = NewTasksEstimated
    def get_SplitsInProgressTasks(self): return self.SplitsInProgressTasks
    def set_SplitsInProgressTasks(self, SplitsInProgressTasks): self.SplitsInProgressTasks = SplitsInProgressTasks
    def get_SpreadActualCost(self): return self.SpreadActualCost
    def set_SpreadActualCost(self, SpreadActualCost): self.SpreadActualCost = SpreadActualCost
    def get_SpreadPercentComplete(self): return self.SpreadPercentComplete
    def set_SpreadPercentComplete(self, SpreadPercentComplete): self.SpreadPercentComplete = SpreadPercentComplete
    def get_TaskUpdatesResource(self): return self.TaskUpdatesResource
    def set_TaskUpdatesResource(self, TaskUpdatesResource): self.TaskUpdatesResource = TaskUpdatesResource
    def get_FiscalYearStart(self): return self.FiscalYearStart
    def set_FiscalYearStart(self, FiscalYearStart): self.FiscalYearStart = FiscalYearStart
    def get_WeekStartDay(self): return self.WeekStartDay
    def set_WeekStartDay(self, WeekStartDay): self.WeekStartDay = WeekStartDay
    def validate_WeekStartDay(self, value):
        # Validate type WeekStartDay, a restriction on xsd:integer.
        pass
    def get_MoveCompletedEndsBack(self): return self.MoveCompletedEndsBack
    def set_MoveCompletedEndsBack(self, MoveCompletedEndsBack): self.MoveCompletedEndsBack = MoveCompletedEndsBack
    def get_MoveRemainingStartsBack(self): return self.MoveRemainingStartsBack
    def set_MoveRemainingStartsBack(self, MoveRemainingStartsBack): self.MoveRemainingStartsBack = MoveRemainingStartsBack
    def get_MoveRemainingStartsForward(self): return self.MoveRemainingStartsForward
    def set_MoveRemainingStartsForward(self, MoveRemainingStartsForward): self.MoveRemainingStartsForward = MoveRemainingStartsForward
    def get_MoveCompletedEndsForward(self): return self.MoveCompletedEndsForward
    def set_MoveCompletedEndsForward(self, MoveCompletedEndsForward): self.MoveCompletedEndsForward = MoveCompletedEndsForward
    def get_BaselineForEarnedValue(self): return self.BaselineForEarnedValue
    def set_BaselineForEarnedValue(self, BaselineForEarnedValue): self.BaselineForEarnedValue = BaselineForEarnedValue
    def validate_BaselineForEarnedValue(self, value):
        # Validate type BaselineForEarnedValue, a restriction on xsd:integer.
        pass
    def get_AutoAddNewResourcesAndTasks(self): return self.AutoAddNewResourcesAndTasks
    def set_AutoAddNewResourcesAndTasks(self, AutoAddNewResourcesAndTasks): self.AutoAddNewResourcesAndTasks = AutoAddNewResourcesAndTasks
    def get_StatusDate(self): return self.StatusDate
    def set_StatusDate(self, StatusDate): self.StatusDate = StatusDate
    def get_CurrentDate(self): return self.CurrentDate
    def set_CurrentDate(self, CurrentDate): self.CurrentDate = CurrentDate
    def get_MicrosoftProjectServerURL(self): return self.MicrosoftProjectServerURL
    def set_MicrosoftProjectServerURL(self, MicrosoftProjectServerURL): self.MicrosoftProjectServerURL = MicrosoftProjectServerURL
    def get_Autolink(self): return self.Autolink
    def set_Autolink(self, Autolink): self.Autolink = Autolink
    def get_NewTaskStartDate(self): return self.NewTaskStartDate
    def set_NewTaskStartDate(self, NewTaskStartDate): self.NewTaskStartDate = NewTaskStartDate
    def validate_NewTaskStartDate(self, value):
        # Validate type NewTaskStartDate, a restriction on xsd:integer.
        pass
    def get_DefaultTaskEVMethod(self): return self.DefaultTaskEVMethod
    def set_DefaultTaskEVMethod(self, DefaultTaskEVMethod): self.DefaultTaskEVMethod = DefaultTaskEVMethod
    def validate_DefaultTaskEVMethod(self, value):
        # Validate type DefaultTaskEVMethod, a restriction on xsd:integer.
        pass
    def get_ProjectExternallyEdited(self): return self.ProjectExternallyEdited
    def set_ProjectExternallyEdited(self, ProjectExternallyEdited): self.ProjectExternallyEdited = ProjectExternallyEdited
    def get_ExtendedCreationDate(self): return self.ExtendedCreationDate
    def set_ExtendedCreationDate(self, ExtendedCreationDate): self.ExtendedCreationDate = ExtendedCreationDate
    def get_ActualsInSync(self): return self.ActualsInSync
    def set_ActualsInSync(self, ActualsInSync): self.ActualsInSync = ActualsInSync
    def get_RemoveFileProperties(self): return self.RemoveFileProperties
    def set_RemoveFileProperties(self, RemoveFileProperties): self.RemoveFileProperties = RemoveFileProperties
    def get_AdminProject(self): return self.AdminProject
    def set_AdminProject(self, AdminProject): self.AdminProject = AdminProject
    def get_OutlineCodes(self): return self.OutlineCodes
    def set_OutlineCodes(self, OutlineCodes): self.OutlineCodes = OutlineCodes
    def get_WBSMasks(self): return self.WBSMasks
    def set_WBSMasks(self, WBSMasks): self.WBSMasks = WBSMasks
    def get_ExtendedAttributes(self): return self.ExtendedAttributes
    def set_ExtendedAttributes(self, ExtendedAttributes): self.ExtendedAttributes = ExtendedAttributes
    def get_Calendars(self): return self.Calendars
    def set_Calendars(self, Calendars): self.Calendars = Calendars
    def get_Tasks(self): return self.Tasks
    def set_Tasks(self, Tasks): self.Tasks = Tasks
    def get_Resources(self): return self.Resources
    def set_Resources(self, Resources): self.Resources = Resources
    def get_Assignments(self): return self.Assignments
    def set_Assignments(self, Assignments): self.Assignments = Assignments
    def export(self, outfile, level, namespace_='', name_='Project', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Project')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Project'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Project'):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('<%sName>%s</%sName>\n' % (namespace_, self.format_string(quote_xml(self.Name), input_name='Name'), namespace_))
        if self.Title is not None:
            showIndent(outfile, level)
            outfile.write('<%sTitle>%s</%sTitle>\n' % (namespace_, self.format_string(quote_xml(self.Title), input_name='Title'), namespace_))
        if self.Subject is not None:
            showIndent(outfile, level)
            outfile.write('<%sSubject>%s</%sSubject>\n' % (namespace_, self.format_string(quote_xml(self.Subject), input_name='Subject'), namespace_))
        if self.Category is not None:
            showIndent(outfile, level)
            outfile.write('<%sCategory>%s</%sCategory>\n' % (namespace_, self.format_string(quote_xml(self.Category), input_name='Category'), namespace_))
        if self.Company is not None:
            showIndent(outfile, level)
            outfile.write('<%sCompany>%s</%sCompany>\n' % (namespace_, self.format_string(quote_xml(self.Company), input_name='Company'), namespace_))
        if self.Manager is not None:
            showIndent(outfile, level)
            outfile.write('<%sManager>%s</%sManager>\n' % (namespace_, self.format_string(quote_xml(self.Manager), input_name='Manager'), namespace_))
        if self.Author is not None:
            showIndent(outfile, level)
            outfile.write('<%sAuthor>%s</%sAuthor>\n' % (namespace_, self.format_string(quote_xml(self.Author), input_name='Author'), namespace_))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sCreationDate>%s</%sCreationDate>\n' % (namespace_, self.format_string(quote_xml(self.CreationDate), input_name='CreationDate'), namespace_))
        if self.Revision is not None:
            showIndent(outfile, level)
            outfile.write('<%sRevision>%s</%sRevision>\n' % (namespace_, self.format_string(quote_xml(self.Revision), input_name='Revision'), namespace_))
        if self.LastSaved is not None:
            showIndent(outfile, level)
            outfile.write('<%sLastSaved>%s</%sLastSaved>\n' % (namespace_, self.format_string(quote_xml(self.LastSaved), input_name='LastSaved'), namespace_))
        if self.ScheduleFromStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sScheduleFromStart>%s</%sScheduleFromStart>\n' % (namespace_, self.format_string(quote_xml(self.ScheduleFromStart), input_name='ScheduleFromStart'), namespace_))
        if self.StartDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sStartDate>%s</%sStartDate>\n' % (namespace_, self.format_string(quote_xml(self.StartDate), input_name='StartDate'), namespace_))
        if self.FinishDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinishDate>%s</%sFinishDate>\n' % (namespace_, self.format_string(quote_xml(self.FinishDate), input_name='FinishDate'), namespace_))
        if self.FYStartDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sFYStartDate>%s</%sFYStartDate>\n' % (namespace_, self.format_string(quote_xml(self.FYStartDate), input_name='FYStartDate'), namespace_))
        if self.CriticalSlackLimit is not None:
            showIndent(outfile, level)
            outfile.write('<%sCriticalSlackLimit>%s</%sCriticalSlackLimit>\n' % (namespace_, self.format_string(quote_xml(self.CriticalSlackLimit), input_name='CriticalSlackLimit'), namespace_))
        if self.CurrencyDigits is not None:
            showIndent(outfile, level)
            outfile.write('<%sCurrencyDigits>%s</%sCurrencyDigits>\n' % (namespace_, self.format_string(quote_xml(self.CurrencyDigits), input_name='CurrencyDigits'), namespace_))
        if self.CurrencySymbol is not None:
            showIndent(outfile, level)
            outfile.write('<%sCurrencySymbol>%s</%sCurrencySymbol>\n' % (namespace_, self.format_string(quote_xml(self.CurrencySymbol), input_name='CurrencySymbol'), namespace_))
        if self.CurrencySymbolPosition is not None:
            showIndent(outfile, level)
            outfile.write('<%sCurrencySymbolPosition>%s</%sCurrencySymbolPosition>\n' % (namespace_, self.format_string(quote_xml(self.CurrencySymbolPosition), input_name='CurrencySymbolPosition'), namespace_))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sCalendarUID>%s</%sCalendarUID>\n' % (namespace_, self.format_string(quote_xml(self.CalendarUID), input_name='CalendarUID'), namespace_))
        if self.DefaultStartTime is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultStartTime>%s</%sDefaultStartTime>\n' % (namespace_, self.format_string(quote_xml(self.DefaultStartTime), input_name='DefaultStartTime'), namespace_))
        if self.DefaultFinishTime is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultFinishTime>%s</%sDefaultFinishTime>\n' % (namespace_, self.format_string(quote_xml(self.DefaultFinishTime), input_name='DefaultFinishTime'), namespace_))
        if self.MinutesPerDay is not None:
            showIndent(outfile, level)
            outfile.write('<%sMinutesPerDay>%s</%sMinutesPerDay>\n' % (namespace_, self.format_string(quote_xml(self.MinutesPerDay), input_name='MinutesPerDay'), namespace_))
        if self.MinutesPerWeek is not None:
            showIndent(outfile, level)
            outfile.write('<%sMinutesPerWeek>%s</%sMinutesPerWeek>\n' % (namespace_, self.format_string(quote_xml(self.MinutesPerWeek), input_name='MinutesPerWeek'), namespace_))
        if self.DaysPerMonth is not None:
            showIndent(outfile, level)
            outfile.write('<%sDaysPerMonth>%s</%sDaysPerMonth>\n' % (namespace_, self.format_string(quote_xml(self.DaysPerMonth), input_name='DaysPerMonth'), namespace_))
        if self.DefaultTaskType is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultTaskType>%s</%sDefaultTaskType>\n' % (namespace_, self.format_string(quote_xml(self.DefaultTaskType), input_name='DefaultTaskType'), namespace_))
        if self.DefaultFixedCostAccrual is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultFixedCostAccrual>%s</%sDefaultFixedCostAccrual>\n' % (namespace_, self.format_string(quote_xml(self.DefaultFixedCostAccrual), input_name='DefaultFixedCostAccrual'), namespace_))
        if self.DefaultStandardRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultStandardRate>%s</%sDefaultStandardRate>\n' % (namespace_, self.format_string(quote_xml(self.DefaultStandardRate), input_name='DefaultStandardRate'), namespace_))
        if self.DefaultOvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultOvertimeRate>%s</%sDefaultOvertimeRate>\n' % (namespace_, self.format_string(quote_xml(self.DefaultOvertimeRate), input_name='DefaultOvertimeRate'), namespace_))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sDurationFormat>%s</%sDurationFormat>\n' % (namespace_, self.format_string(quote_xml(self.DurationFormat), input_name='DurationFormat'), namespace_))
        if self.WorkFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkFormat>%s</%sWorkFormat>\n' % (namespace_, self.format_string(quote_xml(self.WorkFormat), input_name='WorkFormat'), namespace_))
        if self.EditableActualCosts is not None:
            showIndent(outfile, level)
            outfile.write('<%sEditableActualCosts>%s</%sEditableActualCosts>\n' % (namespace_, self.format_string(quote_xml(self.EditableActualCosts), input_name='EditableActualCosts'), namespace_))
        if self.HonorConstraints is not None:
            showIndent(outfile, level)
            outfile.write('<%sHonorConstraints>%s</%sHonorConstraints>\n' % (namespace_, self.format_string(quote_xml(self.HonorConstraints), input_name='HonorConstraints'), namespace_))
        if self.EarnedValueMethod is not None:
            showIndent(outfile, level)
            outfile.write('<%sEarnedValueMethod>%s</%sEarnedValueMethod>\n' % (namespace_, self.format_string(quote_xml(self.EarnedValueMethod), input_name='EarnedValueMethod'), namespace_))
        if self.InsertedProjectsLikeSummary is not None:
            showIndent(outfile, level)
            outfile.write('<%sInsertedProjectsLikeSummary>%s</%sInsertedProjectsLikeSummary>\n' % (namespace_, self.format_string(quote_xml(self.InsertedProjectsLikeSummary), input_name='InsertedProjectsLikeSummary'), namespace_))
        if self.MultipleCriticalPaths is not None:
            showIndent(outfile, level)
            outfile.write('<%sMultipleCriticalPaths>%s</%sMultipleCriticalPaths>\n' % (namespace_, self.format_string(quote_xml(self.MultipleCriticalPaths), input_name='MultipleCriticalPaths'), namespace_))
        if self.NewTasksEffortDriven is not None:
            showIndent(outfile, level)
            outfile.write('<%sNewTasksEffortDriven>%s</%sNewTasksEffortDriven>\n' % (namespace_, self.format_string(quote_xml(self.NewTasksEffortDriven), input_name='NewTasksEffortDriven'), namespace_))
        if self.NewTasksEstimated is not None:
            showIndent(outfile, level)
            outfile.write('<%sNewTasksEstimated>%s</%sNewTasksEstimated>\n' % (namespace_, self.format_string(quote_xml(self.NewTasksEstimated), input_name='NewTasksEstimated'), namespace_))
        if self.SplitsInProgressTasks is not None:
            showIndent(outfile, level)
            outfile.write('<%sSplitsInProgressTasks>%s</%sSplitsInProgressTasks>\n' % (namespace_, self.format_string(quote_xml(self.SplitsInProgressTasks), input_name='SplitsInProgressTasks'), namespace_))
        if self.SpreadActualCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sSpreadActualCost>%s</%sSpreadActualCost>\n' % (namespace_, self.format_string(quote_xml(self.SpreadActualCost), input_name='SpreadActualCost'), namespace_))
        if self.SpreadPercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sSpreadPercentComplete>%s</%sSpreadPercentComplete>\n' % (namespace_, self.format_string(quote_xml(self.SpreadPercentComplete), input_name='SpreadPercentComplete'), namespace_))
        if self.TaskUpdatesResource is not None:
            showIndent(outfile, level)
            outfile.write('<%sTaskUpdatesResource>%s</%sTaskUpdatesResource>\n' % (namespace_, self.format_string(quote_xml(self.TaskUpdatesResource), input_name='TaskUpdatesResource'), namespace_))
        if self.FiscalYearStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sFiscalYearStart>%s</%sFiscalYearStart>\n' % (namespace_, self.format_string(quote_xml(self.FiscalYearStart), input_name='FiscalYearStart'), namespace_))
        if self.WeekStartDay is not None:
            showIndent(outfile, level)
            outfile.write('<%sWeekStartDay>%s</%sWeekStartDay>\n' % (namespace_, self.format_string(quote_xml(self.WeekStartDay), input_name='WeekStartDay'), namespace_))
        if self.MoveCompletedEndsBack is not None:
            showIndent(outfile, level)
            outfile.write('<%sMoveCompletedEndsBack>%s</%sMoveCompletedEndsBack>\n' % (namespace_, self.format_string(quote_xml(self.MoveCompletedEndsBack), input_name='MoveCompletedEndsBack'), namespace_))
        if self.MoveRemainingStartsBack is not None:
            showIndent(outfile, level)
            outfile.write('<%sMoveRemainingStartsBack>%s</%sMoveRemainingStartsBack>\n' % (namespace_, self.format_string(quote_xml(self.MoveRemainingStartsBack), input_name='MoveRemainingStartsBack'), namespace_))
        if self.MoveRemainingStartsForward is not None:
            showIndent(outfile, level)
            outfile.write('<%sMoveRemainingStartsForward>%s</%sMoveRemainingStartsForward>\n' % (namespace_, self.format_string(quote_xml(self.MoveRemainingStartsForward), input_name='MoveRemainingStartsForward'), namespace_))
        if self.MoveCompletedEndsForward is not None:
            showIndent(outfile, level)
            outfile.write('<%sMoveCompletedEndsForward>%s</%sMoveCompletedEndsForward>\n' % (namespace_, self.format_string(quote_xml(self.MoveCompletedEndsForward), input_name='MoveCompletedEndsForward'), namespace_))
        if self.BaselineForEarnedValue is not None:
            showIndent(outfile, level)
            outfile.write('<%sBaselineForEarnedValue>%s</%sBaselineForEarnedValue>\n' % (namespace_, self.format_string(quote_xml(self.BaselineForEarnedValue), input_name='BaselineForEarnedValue'), namespace_))
        if self.AutoAddNewResourcesAndTasks is not None:
            showIndent(outfile, level)
            outfile.write('<%sAutoAddNewResourcesAndTasks>%s</%sAutoAddNewResourcesAndTasks>\n' % (namespace_, self.format_string(quote_xml(self.AutoAddNewResourcesAndTasks), input_name='AutoAddNewResourcesAndTasks'), namespace_))
        if self.StatusDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sStatusDate>%s</%sStatusDate>\n' % (namespace_, self.format_string(quote_xml(self.StatusDate), input_name='StatusDate'), namespace_))
        if self.CurrentDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sCurrentDate>%s</%sCurrentDate>\n' % (namespace_, self.format_string(quote_xml(self.CurrentDate), input_name='CurrentDate'), namespace_))
        if self.MicrosoftProjectServerURL is not None:
            showIndent(outfile, level)
            outfile.write('<%sMicrosoftProjectServerURL>%s</%sMicrosoftProjectServerURL>\n' % (namespace_, self.format_string(quote_xml(self.MicrosoftProjectServerURL), input_name='MicrosoftProjectServerURL'), namespace_))
        if self.Autolink is not None:
            showIndent(outfile, level)
            outfile.write('<%sAutolink>%s</%sAutolink>\n' % (namespace_, self.format_string(quote_xml(self.Autolink), input_name='Autolink'), namespace_))
        if self.NewTaskStartDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sNewTaskStartDate>%s</%sNewTaskStartDate>\n' % (namespace_, self.format_string(quote_xml(self.NewTaskStartDate), input_name='NewTaskStartDate'), namespace_))
        if self.DefaultTaskEVMethod is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefaultTaskEVMethod>%s</%sDefaultTaskEVMethod>\n' % (namespace_, self.format_string(quote_xml(self.DefaultTaskEVMethod), input_name='DefaultTaskEVMethod'), namespace_))
        if self.ProjectExternallyEdited is not None:
            showIndent(outfile, level)
            outfile.write('<%sProjectExternallyEdited>%s</%sProjectExternallyEdited>\n' % (namespace_, self.format_string(quote_xml(self.ProjectExternallyEdited), input_name='ProjectExternallyEdited'), namespace_))
        if self.ExtendedCreationDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sExtendedCreationDate>%s</%sExtendedCreationDate>\n' % (namespace_, self.format_string(quote_xml(self.ExtendedCreationDate), input_name='ExtendedCreationDate'), namespace_))
        if self.ActualsInSync is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualsInSync>%s</%sActualsInSync>\n' % (namespace_, self.format_string(quote_xml(self.ActualsInSync), input_name='ActualsInSync'), namespace_))
        if self.RemoveFileProperties is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemoveFileProperties>%s</%sRemoveFileProperties>\n' % (namespace_, self.format_string(quote_xml(self.RemoveFileProperties), input_name='RemoveFileProperties'), namespace_))
        if self.AdminProject is not None:
            showIndent(outfile, level)
            outfile.write('<%sAdminProject>%s</%sAdminProject>\n' % (namespace_, self.format_string(quote_xml(self.AdminProject), input_name='AdminProject'), namespace_))
        if self.OutlineCodes:
            self.OutlineCodes.export(outfile, level, namespace_, name_='OutlineCodes')
        if self.WBSMasks:
            self.WBSMasks.export(outfile, level, namespace_, name_='WBSMasks')
        if self.ExtendedAttributes:
            self.ExtendedAttributes.export(outfile, level, namespace_, name_='ExtendedAttributes')
        if self.Calendars:
            self.Calendars.export(outfile, level, namespace_, name_='Calendars')
        if self.Tasks:
            self.Tasks.export(outfile, level, namespace_, name_='Tasks')
        if self.Resources:
            self.Resources.export(outfile, level, namespace_, name_='Resources')
        if self.Assignments:
            self.Assignments.export(outfile, level, namespace_, name_='Assignments')
    def hasContent_(self):
        if (
            self.UID is not None or
            self.Name is not None or
            self.Title is not None or
            self.Subject is not None or
            self.Category is not None or
            self.Company is not None or
            self.Manager is not None or
            self.Author is not None or
            self.CreationDate is not None or
            self.Revision is not None or
            self.LastSaved is not None or
            self.ScheduleFromStart is not None or
            self.StartDate is not None or
            self.FinishDate is not None or
            self.FYStartDate is not None or
            self.CriticalSlackLimit is not None or
            self.CurrencyDigits is not None or
            self.CurrencySymbol is not None or
            self.CurrencySymbolPosition is not None or
            self.CalendarUID is not None or
            self.DefaultStartTime is not None or
            self.DefaultFinishTime is not None or
            self.MinutesPerDay is not None or
            self.MinutesPerWeek is not None or
            self.DaysPerMonth is not None or
            self.DefaultTaskType is not None or
            self.DefaultFixedCostAccrual is not None or
            self.DefaultStandardRate is not None or
            self.DefaultOvertimeRate is not None or
            self.DurationFormat is not None or
            self.WorkFormat is not None or
            self.EditableActualCosts is not None or
            self.HonorConstraints is not None or
            self.EarnedValueMethod is not None or
            self.InsertedProjectsLikeSummary is not None or
            self.MultipleCriticalPaths is not None or
            self.NewTasksEffortDriven is not None or
            self.NewTasksEstimated is not None or
            self.SplitsInProgressTasks is not None or
            self.SpreadActualCost is not None or
            self.SpreadPercentComplete is not None or
            self.TaskUpdatesResource is not None or
            self.FiscalYearStart is not None or
            self.WeekStartDay is not None or
            self.MoveCompletedEndsBack is not None or
            self.MoveRemainingStartsBack is not None or
            self.MoveRemainingStartsForward is not None or
            self.MoveCompletedEndsForward is not None or
            self.BaselineForEarnedValue is not None or
            self.AutoAddNewResourcesAndTasks is not None or
            self.StatusDate is not None or
            self.CurrentDate is not None or
            self.MicrosoftProjectServerURL is not None or
            self.Autolink is not None or
            self.NewTaskStartDate is not None or
            self.DefaultTaskEVMethod is not None or
            self.ProjectExternallyEdited is not None or
            self.ExtendedCreationDate is not None or
            self.ActualsInSync is not None or
            self.RemoveFileProperties is not None or
            self.AdminProject is not None or
            self.OutlineCodes is not None or
            self.WBSMasks is not None or
            self.ExtendedAttributes is not None or
            self.Calendars is not None or
            self.Tasks is not None or
            self.Resources is not None or
            self.Assignments is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Project'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('Name=%s,\n' % quote_python(self.Name))
        if self.Title is not None:
            showIndent(outfile, level)
            outfile.write('Title=%s,\n' % quote_python(self.Title))
        if self.Subject is not None:
            showIndent(outfile, level)
            outfile.write('Subject=%s,\n' % quote_python(self.Subject))
        if self.Category is not None:
            showIndent(outfile, level)
            outfile.write('Category=%s,\n' % quote_python(self.Category))
        if self.Company is not None:
            showIndent(outfile, level)
            outfile.write('Company=%s,\n' % quote_python(self.Company))
        if self.Manager is not None:
            showIndent(outfile, level)
            outfile.write('Manager=%s,\n' % quote_python(self.Manager))
        if self.Author is not None:
            showIndent(outfile, level)
            outfile.write('Author=%s,\n' % quote_python(self.Author))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('CreationDate=%s,\n' % quote_python(self.CreationDate))
        if self.Revision is not None:
            showIndent(outfile, level)
            outfile.write('Revision=%s,\n' % quote_python(self.Revision))
        if self.LastSaved is not None:
            showIndent(outfile, level)
            outfile.write('LastSaved=%s,\n' % quote_python(self.LastSaved))
        if self.ScheduleFromStart is not None:
            showIndent(outfile, level)
            outfile.write('ScheduleFromStart=%s,\n' % quote_python(self.ScheduleFromStart))
        if self.StartDate is not None:
            showIndent(outfile, level)
            outfile.write('StartDate=%s,\n' % quote_python(self.StartDate))
        if self.FinishDate is not None:
            showIndent(outfile, level)
            outfile.write('FinishDate=%s,\n' % quote_python(self.FinishDate))
        if self.FYStartDate is not None:
            showIndent(outfile, level)
            outfile.write('FYStartDate=%s,\n' % quote_python(self.FYStartDate))
        if self.CriticalSlackLimit is not None:
            showIndent(outfile, level)
            outfile.write('CriticalSlackLimit=%s,\n' % quote_python(self.CriticalSlackLimit))
        if self.CurrencyDigits is not None:
            showIndent(outfile, level)
            outfile.write('CurrencyDigits=%s,\n' % quote_python(self.CurrencyDigits))
        if self.CurrencySymbol is not None:
            showIndent(outfile, level)
            outfile.write('CurrencySymbol=%s,\n' % quote_python(self.CurrencySymbol))
        if self.CurrencySymbolPosition is not None:
            showIndent(outfile, level)
            outfile.write('CurrencySymbolPosition=%s,\n' % quote_python(self.CurrencySymbolPosition))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('CalendarUID=%s,\n' % quote_python(self.CalendarUID))
        if self.DefaultStartTime is not None:
            showIndent(outfile, level)
            outfile.write('DefaultStartTime=%s,\n' % quote_python(self.DefaultStartTime))
        if self.DefaultFinishTime is not None:
            showIndent(outfile, level)
            outfile.write('DefaultFinishTime=%s,\n' % quote_python(self.DefaultFinishTime))
        if self.MinutesPerDay is not None:
            showIndent(outfile, level)
            outfile.write('MinutesPerDay=%s,\n' % quote_python(self.MinutesPerDay))
        if self.MinutesPerWeek is not None:
            showIndent(outfile, level)
            outfile.write('MinutesPerWeek=%s,\n' % quote_python(self.MinutesPerWeek))
        if self.DaysPerMonth is not None:
            showIndent(outfile, level)
            outfile.write('DaysPerMonth=%s,\n' % quote_python(self.DaysPerMonth))
        if self.DefaultTaskType is not None:
            showIndent(outfile, level)
            outfile.write('DefaultTaskType=%s,\n' % quote_python(self.DefaultTaskType))
        if self.DefaultFixedCostAccrual is not None:
            showIndent(outfile, level)
            outfile.write('DefaultFixedCostAccrual=%s,\n' % quote_python(self.DefaultFixedCostAccrual))
        if self.DefaultStandardRate is not None:
            showIndent(outfile, level)
            outfile.write('DefaultStandardRate=%s,\n' % quote_python(self.DefaultStandardRate))
        if self.DefaultOvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('DefaultOvertimeRate=%s,\n' % quote_python(self.DefaultOvertimeRate))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('DurationFormat=%s,\n' % quote_python(self.DurationFormat))
        if self.WorkFormat is not None:
            showIndent(outfile, level)
            outfile.write('WorkFormat=%s,\n' % quote_python(self.WorkFormat))
        if self.EditableActualCosts is not None:
            showIndent(outfile, level)
            outfile.write('EditableActualCosts=%s,\n' % quote_python(self.EditableActualCosts))
        if self.HonorConstraints is not None:
            showIndent(outfile, level)
            outfile.write('HonorConstraints=%s,\n' % quote_python(self.HonorConstraints))
        if self.EarnedValueMethod is not None:
            showIndent(outfile, level)
            outfile.write('EarnedValueMethod=%s,\n' % quote_python(self.EarnedValueMethod))
        if self.InsertedProjectsLikeSummary is not None:
            showIndent(outfile, level)
            outfile.write('InsertedProjectsLikeSummary=%s,\n' % quote_python(self.InsertedProjectsLikeSummary))
        if self.MultipleCriticalPaths is not None:
            showIndent(outfile, level)
            outfile.write('MultipleCriticalPaths=%s,\n' % quote_python(self.MultipleCriticalPaths))
        if self.NewTasksEffortDriven is not None:
            showIndent(outfile, level)
            outfile.write('NewTasksEffortDriven=%s,\n' % quote_python(self.NewTasksEffortDriven))
        if self.NewTasksEstimated is not None:
            showIndent(outfile, level)
            outfile.write('NewTasksEstimated=%s,\n' % quote_python(self.NewTasksEstimated))
        if self.SplitsInProgressTasks is not None:
            showIndent(outfile, level)
            outfile.write('SplitsInProgressTasks=%s,\n' % quote_python(self.SplitsInProgressTasks))
        if self.SpreadActualCost is not None:
            showIndent(outfile, level)
            outfile.write('SpreadActualCost=%s,\n' % quote_python(self.SpreadActualCost))
        if self.SpreadPercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('SpreadPercentComplete=%s,\n' % quote_python(self.SpreadPercentComplete))
        if self.TaskUpdatesResource is not None:
            showIndent(outfile, level)
            outfile.write('TaskUpdatesResource=%s,\n' % quote_python(self.TaskUpdatesResource))
        if self.FiscalYearStart is not None:
            showIndent(outfile, level)
            outfile.write('FiscalYearStart=%s,\n' % quote_python(self.FiscalYearStart))
        if self.WeekStartDay is not None:
            showIndent(outfile, level)
            outfile.write('WeekStartDay=%s,\n' % quote_python(self.WeekStartDay))
        if self.MoveCompletedEndsBack is not None:
            showIndent(outfile, level)
            outfile.write('MoveCompletedEndsBack=%s,\n' % quote_python(self.MoveCompletedEndsBack))
        if self.MoveRemainingStartsBack is not None:
            showIndent(outfile, level)
            outfile.write('MoveRemainingStartsBack=%s,\n' % quote_python(self.MoveRemainingStartsBack))
        if self.MoveRemainingStartsForward is not None:
            showIndent(outfile, level)
            outfile.write('MoveRemainingStartsForward=%s,\n' % quote_python(self.MoveRemainingStartsForward))
        if self.MoveCompletedEndsForward is not None:
            showIndent(outfile, level)
            outfile.write('MoveCompletedEndsForward=%s,\n' % quote_python(self.MoveCompletedEndsForward))
        if self.BaselineForEarnedValue is not None:
            showIndent(outfile, level)
            outfile.write('BaselineForEarnedValue=%s,\n' % quote_python(self.BaselineForEarnedValue))
        if self.AutoAddNewResourcesAndTasks is not None:
            showIndent(outfile, level)
            outfile.write('AutoAddNewResourcesAndTasks=%s,\n' % quote_python(self.AutoAddNewResourcesAndTasks))
        if self.StatusDate is not None:
            showIndent(outfile, level)
            outfile.write('StatusDate=%s,\n' % quote_python(self.StatusDate))
        if self.CurrentDate is not None:
            showIndent(outfile, level)
            outfile.write('CurrentDate=%s,\n' % quote_python(self.CurrentDate))
        if self.MicrosoftProjectServerURL is not None:
            showIndent(outfile, level)
            outfile.write('MicrosoftProjectServerURL=%s,\n' % quote_python(self.MicrosoftProjectServerURL))
        if self.Autolink is not None:
            showIndent(outfile, level)
            outfile.write('Autolink=%s,\n' % quote_python(self.Autolink))
        if self.NewTaskStartDate is not None:
            showIndent(outfile, level)
            outfile.write('NewTaskStartDate=%s,\n' % quote_python(self.NewTaskStartDate))
        if self.DefaultTaskEVMethod is not None:
            showIndent(outfile, level)
            outfile.write('DefaultTaskEVMethod=%s,\n' % quote_python(self.DefaultTaskEVMethod))
        if self.ProjectExternallyEdited is not None:
            showIndent(outfile, level)
            outfile.write('ProjectExternallyEdited=%s,\n' % quote_python(self.ProjectExternallyEdited))
        if self.ExtendedCreationDate is not None:
            showIndent(outfile, level)
            outfile.write('ExtendedCreationDate=%s,\n' % quote_python(self.ExtendedCreationDate))
        if self.ActualsInSync is not None:
            showIndent(outfile, level)
            outfile.write('ActualsInSync=%s,\n' % quote_python(self.ActualsInSync))
        if self.RemoveFileProperties is not None:
            showIndent(outfile, level)
            outfile.write('RemoveFileProperties=%s,\n' % quote_python(self.RemoveFileProperties))
        if self.AdminProject is not None:
            showIndent(outfile, level)
            outfile.write('AdminProject=%s,\n' % quote_python(self.AdminProject))
        if self.OutlineCodes is not None:
            showIndent(outfile, level)
            outfile.write('OutlineCodes=model_.OutlineCodes(\n')
            self.OutlineCodes.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.WBSMasks is not None:
            showIndent(outfile, level)
            outfile.write('WBSMasks=model_.WBSMasks(\n')
            self.WBSMasks.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.ExtendedAttributes is not None:
            showIndent(outfile, level)
            outfile.write('ExtendedAttributes=model_.ExtendedAttributes(\n')
            self.ExtendedAttributes.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Calendars is not None:
            showIndent(outfile, level)
            outfile.write('Calendars=model_.Calendars(\n')
            self.Calendars.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Tasks is not None:
            showIndent(outfile, level)
            outfile.write('Tasks=model_.Tasks(\n')
            self.Tasks.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Resources is not None:
            showIndent(outfile, level)
            outfile.write('Resources=model_.Resources(\n')
            self.Resources.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Assignments is not None:
            showIndent(outfile, level)
            outfile.write('Assignments=model_.Assignments(\n')
            self.Assignments.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
            self.validate_UID(self.UID)    # validate type UID
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Name':
            Name_ = ''
            for text__content_ in child_.childNodes:
                Name_ += text__content_.nodeValue
            self.Name = Name_
            self.validate_Name(self.Name)    # validate type Name
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Title':
            Title_ = ''
            for text__content_ in child_.childNodes:
                Title_ += text__content_.nodeValue
            self.Title = Title_
            self.validate_Title(self.Title)    # validate type Title
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Subject':
            Subject_ = ''
            for text__content_ in child_.childNodes:
                Subject_ += text__content_.nodeValue
            self.Subject = Subject_
            self.validate_Subject(self.Subject)    # validate type Subject
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Category':
            Category_ = ''
            for text__content_ in child_.childNodes:
                Category_ += text__content_.nodeValue
            self.Category = Category_
            self.validate_Category(self.Category)    # validate type Category
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Company':
            Company_ = ''
            for text__content_ in child_.childNodes:
                Company_ += text__content_.nodeValue
            self.Company = Company_
            self.validate_Company(self.Company)    # validate type Company
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Manager':
            Manager_ = ''
            for text__content_ in child_.childNodes:
                Manager_ += text__content_.nodeValue
            self.Manager = Manager_
            self.validate_Manager(self.Manager)    # validate type Manager
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Author':
            Author_ = ''
            for text__content_ in child_.childNodes:
                Author_ += text__content_.nodeValue
            self.Author = Author_
            self.validate_Author(self.Author)    # validate type Author
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CreationDate':
            CreationDate_ = ''
            for text__content_ in child_.childNodes:
                CreationDate_ += text__content_.nodeValue
            self.CreationDate = CreationDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Revision':
            Revision_ = ''
            for text__content_ in child_.childNodes:
                Revision_ += text__content_.nodeValue
            self.Revision = Revision_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LastSaved':
            LastSaved_ = ''
            for text__content_ in child_.childNodes:
                LastSaved_ += text__content_.nodeValue
            self.LastSaved = LastSaved_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ScheduleFromStart':
            ScheduleFromStart_ = ''
            for text__content_ in child_.childNodes:
                ScheduleFromStart_ += text__content_.nodeValue
            self.ScheduleFromStart = ScheduleFromStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StartDate':
            StartDate_ = ''
            for text__content_ in child_.childNodes:
                StartDate_ += text__content_.nodeValue
            self.StartDate = StartDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FinishDate':
            FinishDate_ = ''
            for text__content_ in child_.childNodes:
                FinishDate_ += text__content_.nodeValue
            self.FinishDate = FinishDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FYStartDate':
            FYStartDate_ = ''
            for text__content_ in child_.childNodes:
                FYStartDate_ += text__content_.nodeValue
            self.FYStartDate = FYStartDate_
            self.validate_FYStartDate(self.FYStartDate)    # validate type FYStartDate
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CriticalSlackLimit':
            CriticalSlackLimit_ = ''
            for text__content_ in child_.childNodes:
                CriticalSlackLimit_ += text__content_.nodeValue
            self.CriticalSlackLimit = CriticalSlackLimit_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CurrencyDigits':
            CurrencyDigits_ = ''
            for text__content_ in child_.childNodes:
                CurrencyDigits_ += text__content_.nodeValue
            self.CurrencyDigits = CurrencyDigits_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CurrencySymbol':
            CurrencySymbol_ = ''
            for text__content_ in child_.childNodes:
                CurrencySymbol_ += text__content_.nodeValue
            self.CurrencySymbol = CurrencySymbol_
            self.validate_CurrencySymbol(self.CurrencySymbol)    # validate type CurrencySymbol
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CurrencySymbolPosition':
            CurrencySymbolPosition_ = ''
            for text__content_ in child_.childNodes:
                CurrencySymbolPosition_ += text__content_.nodeValue
            self.CurrencySymbolPosition = CurrencySymbolPosition_
            self.validate_CurrencySymbolPosition(self.CurrencySymbolPosition)    # validate type CurrencySymbolPosition
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CalendarUID':
            CalendarUID_ = ''
            for text__content_ in child_.childNodes:
                CalendarUID_ += text__content_.nodeValue
            self.CalendarUID = CalendarUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultStartTime':
            DefaultStartTime_ = ''
            for text__content_ in child_.childNodes:
                DefaultStartTime_ += text__content_.nodeValue
            self.DefaultStartTime = DefaultStartTime_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultFinishTime':
            DefaultFinishTime_ = ''
            for text__content_ in child_.childNodes:
                DefaultFinishTime_ += text__content_.nodeValue
            self.DefaultFinishTime = DefaultFinishTime_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MinutesPerDay':
            MinutesPerDay_ = ''
            for text__content_ in child_.childNodes:
                MinutesPerDay_ += text__content_.nodeValue
            self.MinutesPerDay = MinutesPerDay_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MinutesPerWeek':
            MinutesPerWeek_ = ''
            for text__content_ in child_.childNodes:
                MinutesPerWeek_ += text__content_.nodeValue
            self.MinutesPerWeek = MinutesPerWeek_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DaysPerMonth':
            DaysPerMonth_ = ''
            for text__content_ in child_.childNodes:
                DaysPerMonth_ += text__content_.nodeValue
            self.DaysPerMonth = DaysPerMonth_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultTaskType':
            DefaultTaskType_ = ''
            for text__content_ in child_.childNodes:
                DefaultTaskType_ += text__content_.nodeValue
            self.DefaultTaskType = DefaultTaskType_
            self.validate_DefaultTaskType(self.DefaultTaskType)    # validate type DefaultTaskType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultFixedCostAccrual':
            DefaultFixedCostAccrual_ = ''
            for text__content_ in child_.childNodes:
                DefaultFixedCostAccrual_ += text__content_.nodeValue
            self.DefaultFixedCostAccrual = DefaultFixedCostAccrual_
            self.validate_DefaultFixedCostAccrual(self.DefaultFixedCostAccrual)    # validate type DefaultFixedCostAccrual
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultStandardRate':
            DefaultStandardRate_ = ''
            for text__content_ in child_.childNodes:
                DefaultStandardRate_ += text__content_.nodeValue
            self.DefaultStandardRate = DefaultStandardRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultOvertimeRate':
            DefaultOvertimeRate_ = ''
            for text__content_ in child_.childNodes:
                DefaultOvertimeRate_ += text__content_.nodeValue
            self.DefaultOvertimeRate = DefaultOvertimeRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DurationFormat':
            DurationFormat_ = ''
            for text__content_ in child_.childNodes:
                DurationFormat_ += text__content_.nodeValue
            self.DurationFormat = DurationFormat_
            self.validate_DurationFormat(self.DurationFormat)    # validate type DurationFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkFormat':
            WorkFormat_ = ''
            for text__content_ in child_.childNodes:
                WorkFormat_ += text__content_.nodeValue
            self.WorkFormat = WorkFormat_
            self.validate_WorkFormat(self.WorkFormat)    # validate type WorkFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EditableActualCosts':
            EditableActualCosts_ = ''
            for text__content_ in child_.childNodes:
                EditableActualCosts_ += text__content_.nodeValue
            self.EditableActualCosts = EditableActualCosts_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HonorConstraints':
            HonorConstraints_ = ''
            for text__content_ in child_.childNodes:
                HonorConstraints_ += text__content_.nodeValue
            self.HonorConstraints = HonorConstraints_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EarnedValueMethod':
            EarnedValueMethod_ = ''
            for text__content_ in child_.childNodes:
                EarnedValueMethod_ += text__content_.nodeValue
            self.EarnedValueMethod = EarnedValueMethod_
            self.validate_EarnedValueMethod(self.EarnedValueMethod)    # validate type EarnedValueMethod
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'InsertedProjectsLikeSummary':
            InsertedProjectsLikeSummary_ = ''
            for text__content_ in child_.childNodes:
                InsertedProjectsLikeSummary_ += text__content_.nodeValue
            self.InsertedProjectsLikeSummary = InsertedProjectsLikeSummary_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MultipleCriticalPaths':
            MultipleCriticalPaths_ = ''
            for text__content_ in child_.childNodes:
                MultipleCriticalPaths_ += text__content_.nodeValue
            self.MultipleCriticalPaths = MultipleCriticalPaths_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'NewTasksEffortDriven':
            NewTasksEffortDriven_ = ''
            for text__content_ in child_.childNodes:
                NewTasksEffortDriven_ += text__content_.nodeValue
            self.NewTasksEffortDriven = NewTasksEffortDriven_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'NewTasksEstimated':
            NewTasksEstimated_ = ''
            for text__content_ in child_.childNodes:
                NewTasksEstimated_ += text__content_.nodeValue
            self.NewTasksEstimated = NewTasksEstimated_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'SplitsInProgressTasks':
            SplitsInProgressTasks_ = ''
            for text__content_ in child_.childNodes:
                SplitsInProgressTasks_ += text__content_.nodeValue
            self.SplitsInProgressTasks = SplitsInProgressTasks_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'SpreadActualCost':
            SpreadActualCost_ = ''
            for text__content_ in child_.childNodes:
                SpreadActualCost_ += text__content_.nodeValue
            self.SpreadActualCost = SpreadActualCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'SpreadPercentComplete':
            SpreadPercentComplete_ = ''
            for text__content_ in child_.childNodes:
                SpreadPercentComplete_ += text__content_.nodeValue
            self.SpreadPercentComplete = SpreadPercentComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TaskUpdatesResource':
            TaskUpdatesResource_ = ''
            for text__content_ in child_.childNodes:
                TaskUpdatesResource_ += text__content_.nodeValue
            self.TaskUpdatesResource = TaskUpdatesResource_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FiscalYearStart':
            FiscalYearStart_ = ''
            for text__content_ in child_.childNodes:
                FiscalYearStart_ += text__content_.nodeValue
            self.FiscalYearStart = FiscalYearStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WeekStartDay':
            WeekStartDay_ = ''
            for text__content_ in child_.childNodes:
                WeekStartDay_ += text__content_.nodeValue
            self.WeekStartDay = WeekStartDay_
            self.validate_WeekStartDay(self.WeekStartDay)    # validate type WeekStartDay
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MoveCompletedEndsBack':
            MoveCompletedEndsBack_ = ''
            for text__content_ in child_.childNodes:
                MoveCompletedEndsBack_ += text__content_.nodeValue
            self.MoveCompletedEndsBack = MoveCompletedEndsBack_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MoveRemainingStartsBack':
            MoveRemainingStartsBack_ = ''
            for text__content_ in child_.childNodes:
                MoveRemainingStartsBack_ += text__content_.nodeValue
            self.MoveRemainingStartsBack = MoveRemainingStartsBack_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MoveRemainingStartsForward':
            MoveRemainingStartsForward_ = ''
            for text__content_ in child_.childNodes:
                MoveRemainingStartsForward_ += text__content_.nodeValue
            self.MoveRemainingStartsForward = MoveRemainingStartsForward_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MoveCompletedEndsForward':
            MoveCompletedEndsForward_ = ''
            for text__content_ in child_.childNodes:
                MoveCompletedEndsForward_ += text__content_.nodeValue
            self.MoveCompletedEndsForward = MoveCompletedEndsForward_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BaselineForEarnedValue':
            BaselineForEarnedValue_ = ''
            for text__content_ in child_.childNodes:
                BaselineForEarnedValue_ += text__content_.nodeValue
            self.BaselineForEarnedValue = BaselineForEarnedValue_
            self.validate_BaselineForEarnedValue(self.BaselineForEarnedValue)    # validate type BaselineForEarnedValue
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AutoAddNewResourcesAndTasks':
            AutoAddNewResourcesAndTasks_ = ''
            for text__content_ in child_.childNodes:
                AutoAddNewResourcesAndTasks_ += text__content_.nodeValue
            self.AutoAddNewResourcesAndTasks = AutoAddNewResourcesAndTasks_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StatusDate':
            StatusDate_ = ''
            for text__content_ in child_.childNodes:
                StatusDate_ += text__content_.nodeValue
            self.StatusDate = StatusDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CurrentDate':
            CurrentDate_ = ''
            for text__content_ in child_.childNodes:
                CurrentDate_ += text__content_.nodeValue
            self.CurrentDate = CurrentDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MicrosoftProjectServerURL':
            MicrosoftProjectServerURL_ = ''
            for text__content_ in child_.childNodes:
                MicrosoftProjectServerURL_ += text__content_.nodeValue
            self.MicrosoftProjectServerURL = MicrosoftProjectServerURL_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Autolink':
            Autolink_ = ''
            for text__content_ in child_.childNodes:
                Autolink_ += text__content_.nodeValue
            self.Autolink = Autolink_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'NewTaskStartDate':
            NewTaskStartDate_ = ''
            for text__content_ in child_.childNodes:
                NewTaskStartDate_ += text__content_.nodeValue
            self.NewTaskStartDate = NewTaskStartDate_
            self.validate_NewTaskStartDate(self.NewTaskStartDate)    # validate type NewTaskStartDate
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DefaultTaskEVMethod':
            DefaultTaskEVMethod_ = ''
            for text__content_ in child_.childNodes:
                DefaultTaskEVMethod_ += text__content_.nodeValue
            self.DefaultTaskEVMethod = DefaultTaskEVMethod_
            self.validate_DefaultTaskEVMethod(self.DefaultTaskEVMethod)    # validate type DefaultTaskEVMethod
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ProjectExternallyEdited':
            ProjectExternallyEdited_ = ''
            for text__content_ in child_.childNodes:
                ProjectExternallyEdited_ += text__content_.nodeValue
            self.ProjectExternallyEdited = ProjectExternallyEdited_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedCreationDate':
            ExtendedCreationDate_ = ''
            for text__content_ in child_.childNodes:
                ExtendedCreationDate_ += text__content_.nodeValue
            self.ExtendedCreationDate = ExtendedCreationDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualsInSync':
            ActualsInSync_ = ''
            for text__content_ in child_.childNodes:
                ActualsInSync_ += text__content_.nodeValue
            self.ActualsInSync = ActualsInSync_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemoveFileProperties':
            RemoveFileProperties_ = ''
            for text__content_ in child_.childNodes:
                RemoveFileProperties_ += text__content_.nodeValue
            self.RemoveFileProperties = RemoveFileProperties_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AdminProject':
            AdminProject_ = ''
            for text__content_ in child_.childNodes:
                AdminProject_ += text__content_.nodeValue
            self.AdminProject = AdminProject_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineCodes':
            obj_ = OutlineCodes.factory()
            obj_.build(child_)
            self.set_OutlineCodes(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WBSMasks':
            obj_ = WBSMasks.factory()
            obj_.build(child_)
            self.set_WBSMasks(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedAttributes':
            obj_ = ExtendedAttributes.factory()
            obj_.build(child_)
            self.set_ExtendedAttributes(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Calendars':
            obj_ = Calendars.factory()
            obj_.build(child_)
            self.set_Calendars(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Tasks':
            obj_ = Tasks.factory()
            obj_.build(child_)
            self.set_Tasks(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Resources':
            obj_ = Resources.factory()
            obj_.build(child_)
            self.set_Resources(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Assignments':
            obj_ = Assignments.factory()
            obj_.build(child_)
            self.set_Assignments(obj_)
# end class Project


class UID(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if UID.subclass:
            return UID.subclass(*args_, **kwargs_)
        else:
            return UID(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='UID', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='UID')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='UID'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='UID'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='UID'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class UID


class Name(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Name.subclass:
            return Name.subclass(*args_, **kwargs_)
        else:
            return Name(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Name', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Name')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Name'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Name'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Name'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Name


class Title(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Title.subclass:
            return Title.subclass(*args_, **kwargs_)
        else:
            return Title(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Title', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Title')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Title'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Title'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Title'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Title


class Subject(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Subject.subclass:
            return Subject.subclass(*args_, **kwargs_)
        else:
            return Subject(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Subject', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Subject')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Subject'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Subject'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Subject'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Subject


class Category(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Category.subclass:
            return Category.subclass(*args_, **kwargs_)
        else:
            return Category(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Category', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Category')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Category'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Category'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Category'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Category


class Company(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Company.subclass:
            return Company.subclass(*args_, **kwargs_)
        else:
            return Company(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Company', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Company')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Company'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Company'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Company'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Company


class Manager(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Manager.subclass:
            return Manager.subclass(*args_, **kwargs_)
        else:
            return Manager(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Manager', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Manager')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Manager'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Manager'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Manager'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Manager


class Author(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Author.subclass:
            return Author.subclass(*args_, **kwargs_)
        else:
            return Author(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Author', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Author')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Author'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Author'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Author'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Author


class FYStartDate(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if FYStartDate.subclass:
            return FYStartDate.subclass(*args_, **kwargs_)
        else:
            return FYStartDate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='FYStartDate', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='FYStartDate')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='FYStartDate'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='FYStartDate'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='FYStartDate'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class FYStartDate


class CurrencySymbol(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CurrencySymbol.subclass:
            return CurrencySymbol.subclass(*args_, **kwargs_)
        else:
            return CurrencySymbol(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='CurrencySymbol', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='CurrencySymbol')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='CurrencySymbol'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='CurrencySymbol'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='CurrencySymbol'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class CurrencySymbol


class CurrencySymbolPosition(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CurrencySymbolPosition.subclass:
            return CurrencySymbolPosition.subclass(*args_, **kwargs_)
        else:
            return CurrencySymbolPosition(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='CurrencySymbolPosition', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='CurrencySymbolPosition')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='CurrencySymbolPosition'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='CurrencySymbolPosition'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='CurrencySymbolPosition'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class CurrencySymbolPosition


class DefaultTaskType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DefaultTaskType.subclass:
            return DefaultTaskType.subclass(*args_, **kwargs_)
        else:
            return DefaultTaskType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DefaultTaskType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='DefaultTaskType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='DefaultTaskType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='DefaultTaskType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='DefaultTaskType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class DefaultTaskType


class DefaultFixedCostAccrual(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DefaultFixedCostAccrual.subclass:
            return DefaultFixedCostAccrual.subclass(*args_, **kwargs_)
        else:
            return DefaultFixedCostAccrual(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DefaultFixedCostAccrual', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='DefaultFixedCostAccrual')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='DefaultFixedCostAccrual'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='DefaultFixedCostAccrual'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='DefaultFixedCostAccrual'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class DefaultFixedCostAccrual


class DurationFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DurationFormat.subclass:
            return DurationFormat.subclass(*args_, **kwargs_)
        else:
            return DurationFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DurationFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='DurationFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='DurationFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='DurationFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='DurationFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class DurationFormat


class WorkFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if WorkFormat.subclass:
            return WorkFormat.subclass(*args_, **kwargs_)
        else:
            return WorkFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='WorkFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WorkFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WorkFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WorkFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WorkFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class WorkFormat


class EarnedValueMethod(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if EarnedValueMethod.subclass:
            return EarnedValueMethod.subclass(*args_, **kwargs_)
        else:
            return EarnedValueMethod(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='EarnedValueMethod', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='EarnedValueMethod')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='EarnedValueMethod'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='EarnedValueMethod'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='EarnedValueMethod'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class EarnedValueMethod


class WeekStartDay(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if WeekStartDay.subclass:
            return WeekStartDay.subclass(*args_, **kwargs_)
        else:
            return WeekStartDay(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='WeekStartDay', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WeekStartDay')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WeekStartDay'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WeekStartDay'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WeekStartDay'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class WeekStartDay


class BaselineForEarnedValue(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BaselineForEarnedValue.subclass:
            return BaselineForEarnedValue.subclass(*args_, **kwargs_)
        else:
            return BaselineForEarnedValue(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='BaselineForEarnedValue', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='BaselineForEarnedValue')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='BaselineForEarnedValue'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='BaselineForEarnedValue'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='BaselineForEarnedValue'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class BaselineForEarnedValue


class NewTaskStartDate(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if NewTaskStartDate.subclass:
            return NewTaskStartDate.subclass(*args_, **kwargs_)
        else:
            return NewTaskStartDate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='NewTaskStartDate', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='NewTaskStartDate')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='NewTaskStartDate'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='NewTaskStartDate'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='NewTaskStartDate'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class NewTaskStartDate


class DefaultTaskEVMethod(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DefaultTaskEVMethod.subclass:
            return DefaultTaskEVMethod.subclass(*args_, **kwargs_)
        else:
            return DefaultTaskEVMethod(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DefaultTaskEVMethod', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='DefaultTaskEVMethod')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='DefaultTaskEVMethod'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='DefaultTaskEVMethod'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='DefaultTaskEVMethod'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class DefaultTaskEVMethod


class OutlineCodes(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, OutlineCode=None):
        if OutlineCode is None:
            self.OutlineCode = []
        else:
            self.OutlineCode = OutlineCode
    def factory(*args_, **kwargs_):
        if OutlineCodes.subclass:
            return OutlineCodes.subclass(*args_, **kwargs_)
        else:
            return OutlineCodes(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_OutlineCode(self): return self.OutlineCode
    def set_OutlineCode(self, OutlineCode): self.OutlineCode = OutlineCode
    def add_OutlineCode(self, value): self.OutlineCode.append(value)
    def insert_OutlineCode(self, index, value): self.OutlineCode[index] = value
    def export(self, outfile, level, namespace_='', name_='OutlineCodes', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='OutlineCodes')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='OutlineCodes'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='OutlineCodes'):
        for OutlineCode_ in self.OutlineCode:
            OutlineCode_.export(outfile, level, namespace_, name_='OutlineCode')
    def hasContent_(self):
        if (
            self.OutlineCode
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='OutlineCodes'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('OutlineCode=[\n')
        level += 1
        for OutlineCode_ in self.OutlineCode:
            showIndent(outfile, level)
            outfile.write('model_.OutlineCode(\n')
            OutlineCode_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineCode':
            obj_ = OutlineCode.factory()
            obj_.build(child_)
            self.OutlineCode.append(obj_)
# end class OutlineCodes


class OutlineCode(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, FieldID=None, FieldName=None, Alias=None, PhoneticAlias=None, Values=None, Enterprise=None, EnterpriseOutlineCodeAlias=None, ResourceSubstitutionEnabled=None, LeafOnly=None, AllLevelsRequired=None, OnlyTableValuesAllowed=None, Masks=None):
        self.FieldID = FieldID
        self.FieldName = FieldName
        self.Alias = Alias
        self.PhoneticAlias = PhoneticAlias
        self.Values = Values
        self.Enterprise = Enterprise
        self.EnterpriseOutlineCodeAlias = EnterpriseOutlineCodeAlias
        self.ResourceSubstitutionEnabled = ResourceSubstitutionEnabled
        self.LeafOnly = LeafOnly
        self.AllLevelsRequired = AllLevelsRequired
        self.OnlyTableValuesAllowed = OnlyTableValuesAllowed
        self.Masks = Masks
    def factory(*args_, **kwargs_):
        if OutlineCode.subclass:
            return OutlineCode.subclass(*args_, **kwargs_)
        else:
            return OutlineCode(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FieldID(self): return self.FieldID
    def set_FieldID(self, FieldID): self.FieldID = FieldID
    def get_FieldName(self): return self.FieldName
    def set_FieldName(self, FieldName): self.FieldName = FieldName
    def get_Alias(self): return self.Alias
    def set_Alias(self, Alias): self.Alias = Alias
    def get_PhoneticAlias(self): return self.PhoneticAlias
    def set_PhoneticAlias(self, PhoneticAlias): self.PhoneticAlias = PhoneticAlias
    def get_Values(self): return self.Values
    def set_Values(self, Values): self.Values = Values
    def get_Enterprise(self): return self.Enterprise
    def set_Enterprise(self, Enterprise): self.Enterprise = Enterprise
    def get_EnterpriseOutlineCodeAlias(self): return self.EnterpriseOutlineCodeAlias
    def set_EnterpriseOutlineCodeAlias(self, EnterpriseOutlineCodeAlias): self.EnterpriseOutlineCodeAlias = EnterpriseOutlineCodeAlias
    def get_ResourceSubstitutionEnabled(self): return self.ResourceSubstitutionEnabled
    def set_ResourceSubstitutionEnabled(self, ResourceSubstitutionEnabled): self.ResourceSubstitutionEnabled = ResourceSubstitutionEnabled
    def get_LeafOnly(self): return self.LeafOnly
    def set_LeafOnly(self, LeafOnly): self.LeafOnly = LeafOnly
    def get_AllLevelsRequired(self): return self.AllLevelsRequired
    def set_AllLevelsRequired(self, AllLevelsRequired): self.AllLevelsRequired = AllLevelsRequired
    def get_OnlyTableValuesAllowed(self): return self.OnlyTableValuesAllowed
    def set_OnlyTableValuesAllowed(self, OnlyTableValuesAllowed): self.OnlyTableValuesAllowed = OnlyTableValuesAllowed
    def get_Masks(self): return self.Masks
    def set_Masks(self, Masks): self.Masks = Masks
    def export(self, outfile, level, namespace_='', name_='OutlineCode', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='OutlineCode')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='OutlineCode'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='OutlineCode'):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('<%sFieldID>%s</%sFieldID>\n' % (namespace_, self.format_string(quote_xml(self.FieldID), input_name='FieldID'), namespace_))
        if self.FieldName is not None:
            showIndent(outfile, level)
            outfile.write('<%sFieldName>%s</%sFieldName>\n' % (namespace_, self.format_string(quote_xml(self.FieldName), input_name='FieldName'), namespace_))
        if self.Alias is not None:
            showIndent(outfile, level)
            outfile.write('<%sAlias>%s</%sAlias>\n' % (namespace_, self.format_string(quote_xml(self.Alias), input_name='Alias'), namespace_))
        if self.PhoneticAlias is not None:
            showIndent(outfile, level)
            outfile.write('<%sPhoneticAlias>%s</%sPhoneticAlias>\n' % (namespace_, self.format_string(quote_xml(self.PhoneticAlias), input_name='PhoneticAlias'), namespace_))
        if self.Values:
            self.Values.export(outfile, level, namespace_, name_='Values')
        if self.Enterprise is not None:
            showIndent(outfile, level)
            outfile.write('<%sEnterprise>%s</%sEnterprise>\n' % (namespace_, self.format_string(quote_xml(self.Enterprise), input_name='Enterprise'), namespace_))
        if self.EnterpriseOutlineCodeAlias is not None:
            showIndent(outfile, level)
            outfile.write('<%sEnterpriseOutlineCodeAlias>%s</%sEnterpriseOutlineCodeAlias>\n' % (namespace_, self.format_string(quote_xml(self.EnterpriseOutlineCodeAlias), input_name='EnterpriseOutlineCodeAlias'), namespace_))
        if self.ResourceSubstitutionEnabled is not None:
            showIndent(outfile, level)
            outfile.write('<%sResourceSubstitutionEnabled>%s</%sResourceSubstitutionEnabled>\n' % (namespace_, self.format_string(quote_xml(self.ResourceSubstitutionEnabled), input_name='ResourceSubstitutionEnabled'), namespace_))
        if self.LeafOnly is not None:
            showIndent(outfile, level)
            outfile.write('<%sLeafOnly>%s</%sLeafOnly>\n' % (namespace_, self.format_string(quote_xml(self.LeafOnly), input_name='LeafOnly'), namespace_))
        if self.AllLevelsRequired is not None:
            showIndent(outfile, level)
            outfile.write('<%sAllLevelsRequired>%s</%sAllLevelsRequired>\n' % (namespace_, self.format_string(quote_xml(self.AllLevelsRequired), input_name='AllLevelsRequired'), namespace_))
        if self.OnlyTableValuesAllowed is not None:
            showIndent(outfile, level)
            outfile.write('<%sOnlyTableValuesAllowed>%s</%sOnlyTableValuesAllowed>\n' % (namespace_, self.format_string(quote_xml(self.OnlyTableValuesAllowed), input_name='OnlyTableValuesAllowed'), namespace_))
        if self.Masks:
            self.Masks.export(outfile, level, namespace_, name_='Masks')
    def hasContent_(self):
        if (
            self.FieldID is not None or
            self.FieldName is not None or
            self.Alias is not None or
            self.PhoneticAlias is not None or
            self.Values is not None or
            self.Enterprise is not None or
            self.EnterpriseOutlineCodeAlias is not None or
            self.ResourceSubstitutionEnabled is not None or
            self.LeafOnly is not None or
            self.AllLevelsRequired is not None or
            self.OnlyTableValuesAllowed is not None or
            self.Masks is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='OutlineCode'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('FieldID=%s,\n' % quote_python(self.FieldID))
        if self.FieldName is not None:
            showIndent(outfile, level)
            outfile.write('FieldName=%s,\n' % quote_python(self.FieldName))
        if self.Alias is not None:
            showIndent(outfile, level)
            outfile.write('Alias=%s,\n' % quote_python(self.Alias))
        if self.PhoneticAlias is not None:
            showIndent(outfile, level)
            outfile.write('PhoneticAlias=%s,\n' % quote_python(self.PhoneticAlias))
        if self.Values is not None:
            showIndent(outfile, level)
            outfile.write('Values=model_.Values(\n')
            self.Values.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Enterprise is not None:
            showIndent(outfile, level)
            outfile.write('Enterprise=%s,\n' % quote_python(self.Enterprise))
        if self.EnterpriseOutlineCodeAlias is not None:
            showIndent(outfile, level)
            outfile.write('EnterpriseOutlineCodeAlias=%s,\n' % quote_python(self.EnterpriseOutlineCodeAlias))
        if self.ResourceSubstitutionEnabled is not None:
            showIndent(outfile, level)
            outfile.write('ResourceSubstitutionEnabled=%s,\n' % quote_python(self.ResourceSubstitutionEnabled))
        if self.LeafOnly is not None:
            showIndent(outfile, level)
            outfile.write('LeafOnly=%s,\n' % quote_python(self.LeafOnly))
        if self.AllLevelsRequired is not None:
            showIndent(outfile, level)
            outfile.write('AllLevelsRequired=%s,\n' % quote_python(self.AllLevelsRequired))
        if self.OnlyTableValuesAllowed is not None:
            showIndent(outfile, level)
            outfile.write('OnlyTableValuesAllowed=%s,\n' % quote_python(self.OnlyTableValuesAllowed))
        if self.Masks is not None:
            showIndent(outfile, level)
            outfile.write('Masks=model_.Masks(\n')
            self.Masks.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FieldID':
            FieldID_ = ''
            for text__content_ in child_.childNodes:
                FieldID_ += text__content_.nodeValue
            self.FieldID = FieldID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FieldName':
            FieldName_ = ''
            for text__content_ in child_.childNodes:
                FieldName_ += text__content_.nodeValue
            self.FieldName = FieldName_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Alias':
            Alias_ = ''
            for text__content_ in child_.childNodes:
                Alias_ += text__content_.nodeValue
            self.Alias = Alias_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PhoneticAlias':
            PhoneticAlias_ = ''
            for text__content_ in child_.childNodes:
                PhoneticAlias_ += text__content_.nodeValue
            self.PhoneticAlias = PhoneticAlias_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Values':
            obj_ = Values.factory()
            obj_.build(child_)
            self.set_Values(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Enterprise':
            Enterprise_ = ''
            for text__content_ in child_.childNodes:
                Enterprise_ += text__content_.nodeValue
            self.Enterprise = Enterprise_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EnterpriseOutlineCodeAlias':
            EnterpriseOutlineCodeAlias_ = ''
            for text__content_ in child_.childNodes:
                EnterpriseOutlineCodeAlias_ += text__content_.nodeValue
            self.EnterpriseOutlineCodeAlias = EnterpriseOutlineCodeAlias_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ResourceSubstitutionEnabled':
            ResourceSubstitutionEnabled_ = ''
            for text__content_ in child_.childNodes:
                ResourceSubstitutionEnabled_ += text__content_.nodeValue
            self.ResourceSubstitutionEnabled = ResourceSubstitutionEnabled_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LeafOnly':
            LeafOnly_ = ''
            for text__content_ in child_.childNodes:
                LeafOnly_ += text__content_.nodeValue
            self.LeafOnly = LeafOnly_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AllLevelsRequired':
            AllLevelsRequired_ = ''
            for text__content_ in child_.childNodes:
                AllLevelsRequired_ += text__content_.nodeValue
            self.AllLevelsRequired = AllLevelsRequired_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OnlyTableValuesAllowed':
            OnlyTableValuesAllowed_ = ''
            for text__content_ in child_.childNodes:
                OnlyTableValuesAllowed_ += text__content_.nodeValue
            self.OnlyTableValuesAllowed = OnlyTableValuesAllowed_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Masks':
            obj_ = Masks.factory()
            obj_.build(child_)
            self.set_Masks(obj_)
# end class OutlineCode


class Values(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Value=None):
        self.Value = Value
    def factory(*args_, **kwargs_):
        if Values.subclass:
            return Values.subclass(*args_, **kwargs_)
        else:
            return Values(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Value(self): return self.Value
    def set_Value(self, Value): self.Value = Value
    def export(self, outfile, level, namespace_='', name_='Values', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Values')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Values'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Values'):
        if self.Value:
            self.Value.export(outfile, level, namespace_, name_='Value', )
    def hasContent_(self):
        if (
            self.Value is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Values'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('Value=model_.Value(\n')
            self.Value.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Value':
            obj_ = Value.factory()
            obj_.build(child_)
            self.set_Value(obj_)
# end class Values


class Value(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, ValueID=None, ParentValueID=None, Value=None, Description=None):
        self.ValueID = ValueID
        self.ParentValueID = ParentValueID
        self.Value = Value
        self.Description = Description
    def factory(*args_, **kwargs_):
        if Value.subclass:
            return Value.subclass(*args_, **kwargs_)
        else:
            return Value(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ValueID(self): return self.ValueID
    def set_ValueID(self, ValueID): self.ValueID = ValueID
    def get_ParentValueID(self): return self.ParentValueID
    def set_ParentValueID(self, ParentValueID): self.ParentValueID = ParentValueID
    def get_Value(self): return self.Value
    def set_Value(self, Value): self.Value = Value
    def get_Description(self): return self.Description
    def set_Description(self, Description): self.Description = Description
    def export(self, outfile, level, namespace_='', name_='Value', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Value')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Value'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Value'):
        if self.ValueID is not None:
            showIndent(outfile, level)
            outfile.write('<%sValueID>%s</%sValueID>\n' % (namespace_, self.format_string(quote_xml(self.ValueID), input_name='ValueID'), namespace_))
        if self.ParentValueID is not None:
            showIndent(outfile, level)
            outfile.write('<%sParentValueID>%s</%sParentValueID>\n' % (namespace_, self.format_string(quote_xml(self.ParentValueID), input_name='ParentValueID'), namespace_))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('<%sValue>%s</%sValue>\n' % (namespace_, self.format_string(quote_xml(self.Value), input_name='Value'), namespace_))
        if self.Description is not None:
            showIndent(outfile, level)
            outfile.write('<%sDescription>%s</%sDescription>\n' % (namespace_, self.format_string(quote_xml(self.Description), input_name='Description'), namespace_))
    def hasContent_(self):
        if (
            self.ValueID is not None or
            self.ParentValueID is not None or
            self.Value is not None or
            self.Description is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Value'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.ValueID is not None:
            showIndent(outfile, level)
            outfile.write('ValueID=%s,\n' % quote_python(self.ValueID))
        if self.ParentValueID is not None:
            showIndent(outfile, level)
            outfile.write('ParentValueID=%s,\n' % quote_python(self.ParentValueID))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('Value=%s,\n' % quote_python(self.Value))
        if self.Description is not None:
            showIndent(outfile, level)
            outfile.write('Description=%s,\n' % quote_python(self.Description))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ValueID':
            ValueID_ = ''
            for text__content_ in child_.childNodes:
                ValueID_ += text__content_.nodeValue
            self.ValueID = ValueID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ParentValueID':
            ParentValueID_ = ''
            for text__content_ in child_.childNodes:
                ParentValueID_ += text__content_.nodeValue
            self.ParentValueID = ParentValueID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Value':
            Value_ = ''
            for text__content_ in child_.childNodes:
                Value_ += text__content_.nodeValue
            self.Value = Value_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Description':
            Description_ = ''
            for text__content_ in child_.childNodes:
                Description_ += text__content_.nodeValue
            self.Description = Description_
# end class Value


class Masks(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Mask=None):
        if Mask is None:
            self.Mask = []
        else:
            self.Mask = Mask
    def factory(*args_, **kwargs_):
        if Masks.subclass:
            return Masks.subclass(*args_, **kwargs_)
        else:
            return Masks(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Mask(self): return self.Mask
    def set_Mask(self, Mask): self.Mask = Mask
    def add_Mask(self, value): self.Mask.append(value)
    def insert_Mask(self, index, value): self.Mask[index] = value
    def export(self, outfile, level, namespace_='', name_='Masks', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Masks')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Masks'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Masks'):
        for Mask_ in self.Mask:
            Mask_.export(outfile, level, namespace_, name_='Mask')
    def hasContent_(self):
        if (
            self.Mask
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Masks'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Mask=[\n')
        level += 1
        for Mask_ in self.Mask:
            showIndent(outfile, level)
            outfile.write('model_.Mask(\n')
            Mask_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Mask':
            obj_ = Mask.factory()
            obj_.build(child_)
            self.Mask.append(obj_)
# end class Masks


class Mask(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Level=None, Type=None, Length=None, Separator=None):
        self.Level = Level
        self.Type = Type
        self.Length = Length
        self.Separator = Separator
    def factory(*args_, **kwargs_):
        if Mask.subclass:
            return Mask.subclass(*args_, **kwargs_)
        else:
            return Mask(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Level(self): return self.Level
    def set_Level(self, Level): self.Level = Level
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_Length(self): return self.Length
    def set_Length(self, Length): self.Length = Length
    def get_Separator(self): return self.Separator
    def set_Separator(self, Separator): self.Separator = Separator
    def export(self, outfile, level, namespace_='', name_='Mask', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Mask')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Mask'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Mask'):
        if self.Level is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevel>%s</%sLevel>\n' % (namespace_, self.format_string(quote_xml(self.Level), input_name='Level'), namespace_))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.Length is not None:
            showIndent(outfile, level)
            outfile.write('<%sLength>%s</%sLength>\n' % (namespace_, self.format_string(quote_xml(self.Length), input_name='Length'), namespace_))
        if self.Separator is not None:
            showIndent(outfile, level)
            outfile.write('<%sSeparator>%s</%sSeparator>\n' % (namespace_, self.format_string(quote_xml(self.Separator), input_name='Separator'), namespace_))
    def hasContent_(self):
        if (
            self.Level is not None or
            self.Type is not None or
            self.Length is not None or
            self.Separator is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Mask'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Level is not None:
            showIndent(outfile, level)
            outfile.write('Level=%s,\n' % quote_python(self.Level))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.Length is not None:
            showIndent(outfile, level)
            outfile.write('Length=%s,\n' % quote_python(self.Length))
        if self.Separator is not None:
            showIndent(outfile, level)
            outfile.write('Separator=%s,\n' % quote_python(self.Separator))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Level':
            Level_ = ''
            for text__content_ in child_.childNodes:
                Level_ += text__content_.nodeValue
            self.Level = Level_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Length':
            Length_ = ''
            for text__content_ in child_.childNodes:
                Length_ += text__content_.nodeValue
            self.Length = Length_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Separator':
            Separator_ = ''
            for text__content_ in child_.childNodes:
                Separator_ += text__content_.nodeValue
            self.Separator = Separator_
# end class Mask


class WBSMasks(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, VerifyUniqueCodes='false', GenerateCodes='false', Prefix=None, WBSMask=None):
        self.VerifyUniqueCodes = VerifyUniqueCodes
        self.GenerateCodes = GenerateCodes
        self.Prefix = Prefix
        if WBSMask is None:
            self.WBSMask = []
        else:
            self.WBSMask = WBSMask
    def factory(*args_, **kwargs_):
        if WBSMasks.subclass:
            return WBSMasks.subclass(*args_, **kwargs_)
        else:
            return WBSMasks(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_VerifyUniqueCodes(self): return self.VerifyUniqueCodes
    def set_VerifyUniqueCodes(self, VerifyUniqueCodes): self.VerifyUniqueCodes = VerifyUniqueCodes
    def get_GenerateCodes(self): return self.GenerateCodes
    def set_GenerateCodes(self, GenerateCodes): self.GenerateCodes = GenerateCodes
    def get_Prefix(self): return self.Prefix
    def set_Prefix(self, Prefix): self.Prefix = Prefix
    def validate_Prefix(self, value):
        # Validate type Prefix, a restriction on xsd:string.
        pass
    def get_WBSMask(self): return self.WBSMask
    def set_WBSMask(self, WBSMask): self.WBSMask = WBSMask
    def add_WBSMask(self, value): self.WBSMask.append(value)
    def insert_WBSMask(self, index, value): self.WBSMask[index] = value
    def export(self, outfile, level, namespace_='', name_='WBSMasks', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WBSMasks')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WBSMasks'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WBSMasks'):
        if self.VerifyUniqueCodes is not None:
            showIndent(outfile, level)
            outfile.write('<%sVerifyUniqueCodes>%s</%sVerifyUniqueCodes>\n' % (namespace_, self.format_string(quote_xml(self.VerifyUniqueCodes), input_name='VerifyUniqueCodes'), namespace_))
        if self.GenerateCodes is not None:
            showIndent(outfile, level)
            outfile.write('<%sGenerateCodes>%s</%sGenerateCodes>\n' % (namespace_, self.format_string(quote_xml(self.GenerateCodes), input_name='GenerateCodes'), namespace_))
        if self.Prefix is not None:
            showIndent(outfile, level)
            outfile.write('<%sPrefix>%s</%sPrefix>\n' % (namespace_, self.format_string(quote_xml(self.Prefix), input_name='Prefix'), namespace_))
        for WBSMask_ in self.WBSMask:
            WBSMask_.export(outfile, level, namespace_, name_='WBSMask')
    def hasContent_(self):
        if (
            self.VerifyUniqueCodes is not None or
            self.GenerateCodes is not None or
            self.Prefix is not None or
            self.WBSMask
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WBSMasks'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.VerifyUniqueCodes is not None:
            showIndent(outfile, level)
            outfile.write('VerifyUniqueCodes=%s,\n' % quote_python(self.VerifyUniqueCodes))
        if self.GenerateCodes is not None:
            showIndent(outfile, level)
            outfile.write('GenerateCodes=%s,\n' % quote_python(self.GenerateCodes))
        if self.Prefix is not None:
            showIndent(outfile, level)
            outfile.write('Prefix=%s,\n' % quote_python(self.Prefix))
        showIndent(outfile, level)
        outfile.write('WBSMask=[\n')
        level += 1
        for WBSMask_ in self.WBSMask:
            showIndent(outfile, level)
            outfile.write('model_.WBSMask(\n')
            WBSMask_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'VerifyUniqueCodes':
            VerifyUniqueCodes_ = ''
            for text__content_ in child_.childNodes:
                VerifyUniqueCodes_ += text__content_.nodeValue
            self.VerifyUniqueCodes = VerifyUniqueCodes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'GenerateCodes':
            GenerateCodes_ = ''
            for text__content_ in child_.childNodes:
                GenerateCodes_ += text__content_.nodeValue
            self.GenerateCodes = GenerateCodes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Prefix':
            Prefix_ = ''
            for text__content_ in child_.childNodes:
                Prefix_ += text__content_.nodeValue
            self.Prefix = Prefix_
            self.validate_Prefix(self.Prefix)    # validate type Prefix
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WBSMask':
            obj_ = WBSMask.factory()
            obj_.build(child_)
            self.WBSMask.append(obj_)
# end class WBSMasks


class Prefix(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Prefix.subclass:
            return Prefix.subclass(*args_, **kwargs_)
        else:
            return Prefix(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Prefix', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Prefix')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Prefix'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Prefix'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Prefix'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Prefix


class WBSMask(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Level=None, Type=None, Length=None, Separator=None):
        self.Level = Level
        self.Type = Type
        self.Length = Length
        self.Separator = Separator
    def factory(*args_, **kwargs_):
        if WBSMask.subclass:
            return WBSMask.subclass(*args_, **kwargs_)
        else:
            return WBSMask(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Level(self): return self.Level
    def set_Level(self, Level): self.Level = Level
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_Length(self): return self.Length
    def set_Length(self, Length): self.Length = Length
    def get_Separator(self): return self.Separator
    def set_Separator(self, Separator): self.Separator = Separator
    def export(self, outfile, level, namespace_='', name_='WBSMask', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WBSMask')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WBSMask'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WBSMask'):
        if self.Level is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevel>%s</%sLevel>\n' % (namespace_, self.format_string(quote_xml(self.Level), input_name='Level'), namespace_))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.Length is not None:
            showIndent(outfile, level)
            outfile.write('<%sLength>%s</%sLength>\n' % (namespace_, self.format_string(quote_xml(self.Length), input_name='Length'), namespace_))
        if self.Separator is not None:
            showIndent(outfile, level)
            outfile.write('<%sSeparator>%s</%sSeparator>\n' % (namespace_, self.format_string(quote_xml(self.Separator), input_name='Separator'), namespace_))
    def hasContent_(self):
        if (
            self.Level is not None or
            self.Type is not None or
            self.Length is not None or
            self.Separator is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WBSMask'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.Level is not None:
            showIndent(outfile, level)
            outfile.write('Level=%s,\n' % quote_python(self.Level))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.Length is not None:
            showIndent(outfile, level)
            outfile.write('Length=%s,\n' % quote_python(self.Length))
        if self.Separator is not None:
            showIndent(outfile, level)
            outfile.write('Separator=%s,\n' % quote_python(self.Separator))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Level':
            Level_ = ''
            for text__content_ in child_.childNodes:
                Level_ += text__content_.nodeValue
            self.Level = Level_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Length':
            Length_ = ''
            for text__content_ in child_.childNodes:
                Length_ += text__content_.nodeValue
            self.Length = Length_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Separator':
            Separator_ = ''
            for text__content_ in child_.childNodes:
                Separator_ += text__content_.nodeValue
            self.Separator = Separator_
# end class WBSMask


class ExtendedAttributes(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, ExtendedAttribute=None):
        if ExtendedAttribute is None:
            self.ExtendedAttribute = []
        else:
            self.ExtendedAttribute = ExtendedAttribute
    def factory(*args_, **kwargs_):
        if ExtendedAttributes.subclass:
            return ExtendedAttributes.subclass(*args_, **kwargs_)
        else:
            return ExtendedAttributes(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_ExtendedAttribute(self): return self.ExtendedAttribute
    def set_ExtendedAttribute(self, ExtendedAttribute): self.ExtendedAttribute = ExtendedAttribute
    def add_ExtendedAttribute(self, value): self.ExtendedAttribute.append(value)
    def insert_ExtendedAttribute(self, index, value): self.ExtendedAttribute[index] = value
    def export(self, outfile, level, namespace_='', name_='ExtendedAttributes', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ExtendedAttributes')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ExtendedAttributes'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ExtendedAttributes'):
        for ExtendedAttribute_ in self.ExtendedAttribute:
            ExtendedAttribute_.export(outfile, level, namespace_, name_='ExtendedAttribute')
    def hasContent_(self):
        if (
            self.ExtendedAttribute
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ExtendedAttributes'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('ExtendedAttribute=[\n')
        level += 1
        for ExtendedAttribute_ in self.ExtendedAttribute:
            showIndent(outfile, level)
            outfile.write('model_.ExtendedAttribute(\n')
            ExtendedAttribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedAttribute':
            obj_ = ExtendedAttribute.factory()
            obj_.build(child_)
            self.ExtendedAttribute.append(obj_)
# end class ExtendedAttributes


class ExtendedAttribute(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, FieldID=None, FieldName=None, Alias=None, PhoneticAlias=None, RollupType=None, CalculationType=None, Formula=None, RestrictValues=None, ValuelistSortOrder=None, AppendNewValues=None, Default=None, ValueList=None):
        self.FieldID = FieldID
        self.FieldName = FieldName
        self.Alias = Alias
        self.PhoneticAlias = PhoneticAlias
        self.RollupType = RollupType
        self.CalculationType = CalculationType
        self.Formula = Formula
        self.RestrictValues = RestrictValues
        self.ValuelistSortOrder = ValuelistSortOrder
        self.AppendNewValues = AppendNewValues
        self.Default = Default
        self.ValueList = ValueList
    def factory(*args_, **kwargs_):
        if ExtendedAttribute.subclass:
            return ExtendedAttribute.subclass(*args_, **kwargs_)
        else:
            return ExtendedAttribute(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FieldID(self): return self.FieldID
    def set_FieldID(self, FieldID): self.FieldID = FieldID
    def get_FieldName(self): return self.FieldName
    def set_FieldName(self, FieldName): self.FieldName = FieldName
    def get_Alias(self): return self.Alias
    def set_Alias(self, Alias): self.Alias = Alias
    def validate_Alias(self, value):
        # Validate type Alias, a restriction on xsd:string.
        pass
    def get_PhoneticAlias(self): return self.PhoneticAlias
    def set_PhoneticAlias(self, PhoneticAlias): self.PhoneticAlias = PhoneticAlias
    def validate_PhoneticAlias(self, value):
        # Validate type PhoneticAlias, a restriction on xsd:string.
        pass
    def get_RollupType(self): return self.RollupType
    def set_RollupType(self, RollupType): self.RollupType = RollupType
    def validate_RollupType(self, value):
        # Validate type RollupType, a restriction on xsd:integer.
        pass
    def get_CalculationType(self): return self.CalculationType
    def set_CalculationType(self, CalculationType): self.CalculationType = CalculationType
    def validate_CalculationType(self, value):
        # Validate type CalculationType, a restriction on xsd:integer.
        pass
    def get_Formula(self): return self.Formula
    def set_Formula(self, Formula): self.Formula = Formula
    def get_RestrictValues(self): return self.RestrictValues
    def set_RestrictValues(self, RestrictValues): self.RestrictValues = RestrictValues
    def get_ValuelistSortOrder(self): return self.ValuelistSortOrder
    def set_ValuelistSortOrder(self, ValuelistSortOrder): self.ValuelistSortOrder = ValuelistSortOrder
    def validate_ValuelistSortOrder(self, value):
        # Validate type ValuelistSortOrder, a restriction on xsd:integer.
        pass
    def get_AppendNewValues(self): return self.AppendNewValues
    def set_AppendNewValues(self, AppendNewValues): self.AppendNewValues = AppendNewValues
    def get_Default(self): return self.Default
    def set_Default(self, Default): self.Default = Default
    def get_ValueList(self): return self.ValueList
    def set_ValueList(self, ValueList): self.ValueList = ValueList
    def export(self, outfile, level, namespace_='', name_='ExtendedAttribute', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ExtendedAttribute')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ExtendedAttribute'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ExtendedAttribute'):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('<%sFieldID>%s</%sFieldID>\n' % (namespace_, self.format_string(quote_xml(self.FieldID), input_name='FieldID'), namespace_))
        if self.FieldName is not None:
            showIndent(outfile, level)
            outfile.write('<%sFieldName>%s</%sFieldName>\n' % (namespace_, self.format_string(quote_xml(self.FieldName), input_name='FieldName'), namespace_))
        if self.Alias is not None:
            showIndent(outfile, level)
            outfile.write('<%sAlias>%s</%sAlias>\n' % (namespace_, self.format_string(quote_xml(self.Alias), input_name='Alias'), namespace_))
        if self.PhoneticAlias is not None:
            showIndent(outfile, level)
            outfile.write('<%sPhoneticAlias>%s</%sPhoneticAlias>\n' % (namespace_, self.format_string(quote_xml(self.PhoneticAlias), input_name='PhoneticAlias'), namespace_))
        if self.RollupType is not None:
            showIndent(outfile, level)
            outfile.write('<%sRollupType>%s</%sRollupType>\n' % (namespace_, self.format_string(quote_xml(self.RollupType), input_name='RollupType'), namespace_))
        if self.CalculationType is not None:
            showIndent(outfile, level)
            outfile.write('<%sCalculationType>%s</%sCalculationType>\n' % (namespace_, self.format_string(quote_xml(self.CalculationType), input_name='CalculationType'), namespace_))
        if self.Formula is not None:
            showIndent(outfile, level)
            outfile.write('<%sFormula>%s</%sFormula>\n' % (namespace_, self.format_string(quote_xml(self.Formula), input_name='Formula'), namespace_))
        if self.RestrictValues is not None:
            showIndent(outfile, level)
            outfile.write('<%sRestrictValues>%s</%sRestrictValues>\n' % (namespace_, self.format_string(quote_xml(self.RestrictValues), input_name='RestrictValues'), namespace_))
        if self.ValuelistSortOrder is not None:
            showIndent(outfile, level)
            outfile.write('<%sValuelistSortOrder>%s</%sValuelistSortOrder>\n' % (namespace_, self.format_string(quote_xml(self.ValuelistSortOrder), input_name='ValuelistSortOrder'), namespace_))
        if self.AppendNewValues is not None:
            showIndent(outfile, level)
            outfile.write('<%sAppendNewValues>%s</%sAppendNewValues>\n' % (namespace_, self.format_string(quote_xml(self.AppendNewValues), input_name='AppendNewValues'), namespace_))
        if self.Default is not None:
            showIndent(outfile, level)
            outfile.write('<%sDefault>%s</%sDefault>\n' % (namespace_, self.format_string(quote_xml(self.Default), input_name='Default'), namespace_))
        if self.ValueList:
            self.ValueList.export(outfile, level, namespace_, name_='ValueList')
    def hasContent_(self):
        if (
            self.FieldID is not None or
            self.FieldName is not None or
            self.Alias is not None or
            self.PhoneticAlias is not None or
            self.RollupType is not None or
            self.CalculationType is not None or
            self.Formula is not None or
            self.RestrictValues is not None or
            self.ValuelistSortOrder is not None or
            self.AppendNewValues is not None or
            self.Default is not None or
            self.ValueList is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ExtendedAttribute'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('FieldID=%s,\n' % quote_python(self.FieldID))
        if self.FieldName is not None:
            showIndent(outfile, level)
            outfile.write('FieldName=%s,\n' % quote_python(self.FieldName))
        if self.Alias is not None:
            showIndent(outfile, level)
            outfile.write('Alias=%s,\n' % quote_python(self.Alias))
        if self.PhoneticAlias is not None:
            showIndent(outfile, level)
            outfile.write('PhoneticAlias=%s,\n' % quote_python(self.PhoneticAlias))
        if self.RollupType is not None:
            showIndent(outfile, level)
            outfile.write('RollupType=%s,\n' % quote_python(self.RollupType))
        if self.CalculationType is not None:
            showIndent(outfile, level)
            outfile.write('CalculationType=%s,\n' % quote_python(self.CalculationType))
        if self.Formula is not None:
            showIndent(outfile, level)
            outfile.write('Formula=%s,\n' % quote_python(self.Formula))
        if self.RestrictValues is not None:
            showIndent(outfile, level)
            outfile.write('RestrictValues=%s,\n' % quote_python(self.RestrictValues))
        if self.ValuelistSortOrder is not None:
            showIndent(outfile, level)
            outfile.write('ValuelistSortOrder=%s,\n' % quote_python(self.ValuelistSortOrder))
        if self.AppendNewValues is not None:
            showIndent(outfile, level)
            outfile.write('AppendNewValues=%s,\n' % quote_python(self.AppendNewValues))
        if self.Default is not None:
            showIndent(outfile, level)
            outfile.write('Default=%s,\n' % quote_python(self.Default))
        if self.ValueList is not None:
            showIndent(outfile, level)
            outfile.write('ValueList=model_.ValueList(\n')
            self.ValueList.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FieldID':
            FieldID_ = ''
            for text__content_ in child_.childNodes:
                FieldID_ += text__content_.nodeValue
            self.FieldID = FieldID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FieldName':
            FieldName_ = ''
            for text__content_ in child_.childNodes:
                FieldName_ += text__content_.nodeValue
            self.FieldName = FieldName_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Alias':
            Alias_ = ''
            for text__content_ in child_.childNodes:
                Alias_ += text__content_.nodeValue
            self.Alias = Alias_
            self.validate_Alias(self.Alias)    # validate type Alias
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PhoneticAlias':
            PhoneticAlias_ = ''
            for text__content_ in child_.childNodes:
                PhoneticAlias_ += text__content_.nodeValue
            self.PhoneticAlias = PhoneticAlias_
            self.validate_PhoneticAlias(self.PhoneticAlias)    # validate type PhoneticAlias
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RollupType':
            RollupType_ = ''
            for text__content_ in child_.childNodes:
                RollupType_ += text__content_.nodeValue
            self.RollupType = RollupType_
            self.validate_RollupType(self.RollupType)    # validate type RollupType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CalculationType':
            CalculationType_ = ''
            for text__content_ in child_.childNodes:
                CalculationType_ += text__content_.nodeValue
            self.CalculationType = CalculationType_
            self.validate_CalculationType(self.CalculationType)    # validate type CalculationType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Formula':
            Formula_ = ''
            for text__content_ in child_.childNodes:
                Formula_ += text__content_.nodeValue
            self.Formula = Formula_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RestrictValues':
            RestrictValues_ = ''
            for text__content_ in child_.childNodes:
                RestrictValues_ += text__content_.nodeValue
            self.RestrictValues = RestrictValues_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ValuelistSortOrder':
            ValuelistSortOrder_ = ''
            for text__content_ in child_.childNodes:
                ValuelistSortOrder_ += text__content_.nodeValue
            self.ValuelistSortOrder = ValuelistSortOrder_
            self.validate_ValuelistSortOrder(self.ValuelistSortOrder)    # validate type ValuelistSortOrder
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AppendNewValues':
            AppendNewValues_ = ''
            for text__content_ in child_.childNodes:
                AppendNewValues_ += text__content_.nodeValue
            self.AppendNewValues = AppendNewValues_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Default':
            Default_ = ''
            for text__content_ in child_.childNodes:
                Default_ += text__content_.nodeValue
            self.Default = Default_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ValueList':
            obj_ = ValueList.factory()
            obj_.build(child_)
            self.set_ValueList(obj_)
# end class ExtendedAttribute


class Alias(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Alias.subclass:
            return Alias.subclass(*args_, **kwargs_)
        else:
            return Alias(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Alias', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Alias')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Alias'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Alias'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Alias'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Alias


class PhoneticAlias(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if PhoneticAlias.subclass:
            return PhoneticAlias.subclass(*args_, **kwargs_)
        else:
            return PhoneticAlias(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='PhoneticAlias', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='PhoneticAlias')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='PhoneticAlias'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='PhoneticAlias'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='PhoneticAlias'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class PhoneticAlias


class RollupType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if RollupType.subclass:
            return RollupType.subclass(*args_, **kwargs_)
        else:
            return RollupType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='RollupType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='RollupType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='RollupType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='RollupType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='RollupType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class RollupType


class CalculationType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CalculationType.subclass:
            return CalculationType.subclass(*args_, **kwargs_)
        else:
            return CalculationType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='CalculationType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='CalculationType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='CalculationType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='CalculationType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='CalculationType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class CalculationType


class ValuelistSortOrder(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ValuelistSortOrder.subclass:
            return ValuelistSortOrder.subclass(*args_, **kwargs_)
        else:
            return ValuelistSortOrder(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ValuelistSortOrder', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ValuelistSortOrder')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ValuelistSortOrder'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ValuelistSortOrder'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ValuelistSortOrder'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class ValuelistSortOrder


class ValueList(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Value=None):
        if Value is None:
            self.Value = []
        else:
            self.Value = Value
    def factory(*args_, **kwargs_):
        if ValueList.subclass:
            return ValueList.subclass(*args_, **kwargs_)
        else:
            return ValueList(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Value(self): return self.Value
    def set_Value(self, Value): self.Value = Value
    def add_Value(self, value): self.Value.append(value)
    def insert_Value(self, index, value): self.Value[index] = value
    def export(self, outfile, level, namespace_='', name_='ValueList', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ValueList')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ValueList'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ValueList'):
        for Value_ in self.Value:
            Value_.export(outfile, level, namespace_, name_='Value')
    def hasContent_(self):
        if (
            self.Value
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ValueList'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Value=[\n')
        level += 1
        for Value_ in self.Value:
            showIndent(outfile, level)
            outfile.write('model_.Value(\n')
            Value_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Value':
            obj_ = Value.factory()
            obj_.build(child_)
            self.Value.append(obj_)
# end class ValueList


class Calendars(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Calendar=None):
        if Calendar is None:
            self.Calendar = []
        else:
            self.Calendar = Calendar
    def factory(*args_, **kwargs_):
        if Calendars.subclass:
            return Calendars.subclass(*args_, **kwargs_)
        else:
            return Calendars(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Calendar(self): return self.Calendar
    def set_Calendar(self, Calendar): self.Calendar = Calendar
    def add_Calendar(self, value): self.Calendar.append(value)
    def insert_Calendar(self, index, value): self.Calendar[index] = value
    def export(self, outfile, level, namespace_='', name_='Calendars', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Calendars')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Calendars'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Calendars'):
        for Calendar_ in self.Calendar:
            Calendar_.export(outfile, level, namespace_, name_='Calendar')
    def hasContent_(self):
        if (
            self.Calendar
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Calendars'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Calendar=[\n')
        level += 1
        for Calendar_ in self.Calendar:
            showIndent(outfile, level)
            outfile.write('model_.Calendar(\n')
            Calendar_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Calendar':
            obj_ = Calendar.factory()
            obj_.build(child_)
            self.Calendar.append(obj_)
# end class Calendars


class Calendar(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, UID=None, Name=None, IsBaseCalendar=None, BaseCalendarUID=None, WeekDays=None):
        self.UID = UID
        self.Name = Name
        self.IsBaseCalendar = IsBaseCalendar
        self.BaseCalendarUID = BaseCalendarUID
        self.WeekDays = WeekDays
    def factory(*args_, **kwargs_):
        if Calendar.subclass:
            return Calendar.subclass(*args_, **kwargs_)
        else:
            return Calendar(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def validate_Name(self, value):
        # Validate type Name, a restriction on xsd:string.
        pass
    def get_IsBaseCalendar(self): return self.IsBaseCalendar
    def set_IsBaseCalendar(self, IsBaseCalendar): self.IsBaseCalendar = IsBaseCalendar
    def get_BaseCalendarUID(self): return self.BaseCalendarUID
    def set_BaseCalendarUID(self, BaseCalendarUID): self.BaseCalendarUID = BaseCalendarUID
    def get_WeekDays(self): return self.WeekDays
    def set_WeekDays(self, WeekDays): self.WeekDays = WeekDays
    def export(self, outfile, level, namespace_='', name_='Calendar', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Calendar')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Calendar'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Calendar'):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('<%sName>%s</%sName>\n' % (namespace_, self.format_string(quote_xml(self.Name), input_name='Name'), namespace_))
        if self.IsBaseCalendar is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsBaseCalendar>%s</%sIsBaseCalendar>\n' % (namespace_, self.format_string(quote_xml(self.IsBaseCalendar), input_name='IsBaseCalendar'), namespace_))
        if self.BaseCalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sBaseCalendarUID>%s</%sBaseCalendarUID>\n' % (namespace_, self.format_string(quote_xml(self.BaseCalendarUID), input_name='BaseCalendarUID'), namespace_))
        if self.WeekDays:
            self.WeekDays.export(outfile, level, namespace_, name_='WeekDays')
    def hasContent_(self):
        if (
            self.UID is not None or
            self.Name is not None or
            self.IsBaseCalendar is not None or
            self.BaseCalendarUID is not None or
            self.WeekDays is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Calendar'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('Name=%s,\n' % quote_python(self.Name))
        if self.IsBaseCalendar is not None:
            showIndent(outfile, level)
            outfile.write('IsBaseCalendar=%s,\n' % quote_python(self.IsBaseCalendar))
        if self.BaseCalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('BaseCalendarUID=%s,\n' % quote_python(self.BaseCalendarUID))
        if self.WeekDays is not None:
            showIndent(outfile, level)
            outfile.write('WeekDays=model_.WeekDays(\n')
            self.WeekDays.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Name':
            Name_ = ''
            for text__content_ in child_.childNodes:
                Name_ += text__content_.nodeValue
            self.Name = Name_
            self.validate_Name(self.Name)    # validate type Name
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsBaseCalendar':
            IsBaseCalendar_ = ''
            for text__content_ in child_.childNodes:
                IsBaseCalendar_ += text__content_.nodeValue
            self.IsBaseCalendar = IsBaseCalendar_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BaseCalendarUID':
            BaseCalendarUID_ = ''
            for text__content_ in child_.childNodes:
                BaseCalendarUID_ += text__content_.nodeValue
            self.BaseCalendarUID = BaseCalendarUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WeekDays':
            obj_ = WeekDays.factory()
            obj_.build(child_)
            self.set_WeekDays(obj_)
# end class Calendar


class WeekDays(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, WeekDay=None):
        if WeekDay is None:
            self.WeekDay = []
        else:
            self.WeekDay = WeekDay
    def factory(*args_, **kwargs_):
        if WeekDays.subclass:
            return WeekDays.subclass(*args_, **kwargs_)
        else:
            return WeekDays(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_WeekDay(self): return self.WeekDay
    def set_WeekDay(self, WeekDay): self.WeekDay = WeekDay
    def add_WeekDay(self, value): self.WeekDay.append(value)
    def insert_WeekDay(self, index, value): self.WeekDay[index] = value
    def export(self, outfile, level, namespace_='', name_='WeekDays', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WeekDays')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WeekDays'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WeekDays'):
        for WeekDay_ in self.WeekDay:
            WeekDay_.export(outfile, level, namespace_, name_='WeekDay')
    def hasContent_(self):
        if (
            self.WeekDay
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WeekDays'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('WeekDay=[\n')
        level += 1
        for WeekDay_ in self.WeekDay:
            showIndent(outfile, level)
            outfile.write('model_.WeekDay(\n')
            WeekDay_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WeekDay':
            obj_ = WeekDay.factory()
            obj_.build(child_)
            self.WeekDay.append(obj_)
# end class WeekDays


class WeekDay(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, DayType=None, DayWorking=None, TimePeriod=None, WorkingTimes=None):
        self.DayType = DayType
        self.DayWorking = DayWorking
        self.TimePeriod = TimePeriod
        self.WorkingTimes = WorkingTimes
    def factory(*args_, **kwargs_):
        if WeekDay.subclass:
            return WeekDay.subclass(*args_, **kwargs_)
        else:
            return WeekDay(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_DayType(self): return self.DayType
    def set_DayType(self, DayType): self.DayType = DayType
    def validate_DayType(self, value):
        # Validate type DayType, a restriction on xsd:integer.
        pass
    def get_DayWorking(self): return self.DayWorking
    def set_DayWorking(self, DayWorking): self.DayWorking = DayWorking
    def get_TimePeriod(self): return self.TimePeriod
    def set_TimePeriod(self, TimePeriod): self.TimePeriod = TimePeriod
    def get_WorkingTimes(self): return self.WorkingTimes
    def set_WorkingTimes(self, WorkingTimes): self.WorkingTimes = WorkingTimes
    def export(self, outfile, level, namespace_='', name_='WeekDay', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WeekDay')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WeekDay'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WeekDay'):
        if self.DayType is not None:
            showIndent(outfile, level)
            outfile.write('<%sDayType>%s</%sDayType>\n' % (namespace_, self.format_string(quote_xml(self.DayType), input_name='DayType'), namespace_))
        if self.DayWorking is not None:
            showIndent(outfile, level)
            outfile.write('<%sDayWorking>%s</%sDayWorking>\n' % (namespace_, self.format_string(quote_xml(self.DayWorking), input_name='DayWorking'), namespace_))
        if self.TimePeriod:
            self.TimePeriod.export(outfile, level, namespace_, name_='TimePeriod')
        if self.WorkingTimes:
            self.WorkingTimes.export(outfile, level, namespace_, name_='WorkingTimes')
    def hasContent_(self):
        if (
            self.DayType is not None or
            self.DayWorking is not None or
            self.TimePeriod is not None or
            self.WorkingTimes is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WeekDay'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.DayType is not None:
            showIndent(outfile, level)
            outfile.write('DayType=%s,\n' % quote_python(self.DayType))
        if self.DayWorking is not None:
            showIndent(outfile, level)
            outfile.write('DayWorking=%s,\n' % quote_python(self.DayWorking))
        if self.TimePeriod is not None:
            showIndent(outfile, level)
            outfile.write('TimePeriod=model_.TimePeriod(\n')
            self.TimePeriod.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.WorkingTimes is not None:
            showIndent(outfile, level)
            outfile.write('WorkingTimes=model_.WorkingTimes(\n')
            self.WorkingTimes.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DayType':
            DayType_ = ''
            for text__content_ in child_.childNodes:
                DayType_ += text__content_.nodeValue
            self.DayType = DayType_
            self.validate_DayType(self.DayType)    # validate type DayType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DayWorking':
            DayWorking_ = ''
            for text__content_ in child_.childNodes:
                DayWorking_ += text__content_.nodeValue
            self.DayWorking = DayWorking_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TimePeriod':
            obj_ = TimePeriod.factory()
            obj_.build(child_)
            self.set_TimePeriod(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkingTimes':
            obj_ = WorkingTimes.factory()
            obj_.build(child_)
            self.set_WorkingTimes(obj_)
# end class WeekDay


class DayType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if DayType.subclass:
            return DayType.subclass(*args_, **kwargs_)
        else:
            return DayType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='DayType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='DayType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='DayType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='DayType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='DayType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class DayType


class TimePeriod(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, FromDate=None, ToDate=None):
        self.FromDate = FromDate
        self.ToDate = ToDate
    def factory(*args_, **kwargs_):
        if TimePeriod.subclass:
            return TimePeriod.subclass(*args_, **kwargs_)
        else:
            return TimePeriod(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FromDate(self): return self.FromDate
    def set_FromDate(self, FromDate): self.FromDate = FromDate
    def get_ToDate(self): return self.ToDate
    def set_ToDate(self, ToDate): self.ToDate = ToDate
    def export(self, outfile, level, namespace_='', name_='TimePeriod', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='TimePeriod')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='TimePeriod'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='TimePeriod'):
        if self.FromDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sFromDate>%s</%sFromDate>\n' % (namespace_, self.format_string(quote_xml(self.FromDate), input_name='FromDate'), namespace_))
        if self.ToDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sToDate>%s</%sToDate>\n' % (namespace_, self.format_string(quote_xml(self.ToDate), input_name='ToDate'), namespace_))
    def hasContent_(self):
        if (
            self.FromDate is not None or
            self.ToDate is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='TimePeriod'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FromDate is not None:
            showIndent(outfile, level)
            outfile.write('FromDate=%s,\n' % quote_python(self.FromDate))
        if self.ToDate is not None:
            showIndent(outfile, level)
            outfile.write('ToDate=%s,\n' % quote_python(self.ToDate))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FromDate':
            FromDate_ = ''
            for text__content_ in child_.childNodes:
                FromDate_ += text__content_.nodeValue
            self.FromDate = FromDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ToDate':
            ToDate_ = ''
            for text__content_ in child_.childNodes:
                ToDate_ += text__content_.nodeValue
            self.ToDate = ToDate_
# end class TimePeriod


class WorkingTimes(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, WorkingTime=None):
        if WorkingTime is None:
            self.WorkingTime = []
        else:
            self.WorkingTime = WorkingTime
    def factory(*args_, **kwargs_):
        if WorkingTimes.subclass:
            return WorkingTimes.subclass(*args_, **kwargs_)
        else:
            return WorkingTimes(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_WorkingTime(self): return self.WorkingTime
    def set_WorkingTime(self, WorkingTime): self.WorkingTime = WorkingTime
    def add_WorkingTime(self, value): self.WorkingTime.append(value)
    def insert_WorkingTime(self, index, value): self.WorkingTime[index] = value
    def export(self, outfile, level, namespace_='', name_='WorkingTimes', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WorkingTimes')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WorkingTimes'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WorkingTimes'):
        for WorkingTime_ in self.WorkingTime:
            WorkingTime_.export(outfile, level, namespace_, name_='WorkingTime')
    def hasContent_(self):
        if (
            self.WorkingTime
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WorkingTimes'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('WorkingTime=[\n')
        level += 1
        for WorkingTime_ in self.WorkingTime:
            showIndent(outfile, level)
            outfile.write('model_.WorkingTime(\n')
            WorkingTime_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkingTime':
            obj_ = WorkingTime.factory()
            obj_.build(child_)
            self.WorkingTime.append(obj_)
# end class WorkingTimes


class WorkingTime(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, FromTime=None, ToTime=None):
        self.FromTime = FromTime
        self.ToTime = ToTime
    def factory(*args_, **kwargs_):
        if WorkingTime.subclass:
            return WorkingTime.subclass(*args_, **kwargs_)
        else:
            return WorkingTime(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_FromTime(self): return self.FromTime
    def set_FromTime(self, FromTime): self.FromTime = FromTime
    def get_ToTime(self): return self.ToTime
    def set_ToTime(self, ToTime): self.ToTime = ToTime
    def export(self, outfile, level, namespace_='', name_='WorkingTime', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WorkingTime')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WorkingTime'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WorkingTime'):
        if self.FromTime is not None:
            showIndent(outfile, level)
            outfile.write('<%sFromTime>%s</%sFromTime>\n' % (namespace_, self.format_string(quote_xml(self.FromTime), input_name='FromTime'), namespace_))
        if self.ToTime is not None:
            showIndent(outfile, level)
            outfile.write('<%sToTime>%s</%sToTime>\n' % (namespace_, self.format_string(quote_xml(self.ToTime), input_name='ToTime'), namespace_))
    def hasContent_(self):
        if (
            self.FromTime is not None or
            self.ToTime is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WorkingTime'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FromTime is not None:
            showIndent(outfile, level)
            outfile.write('FromTime=%s,\n' % quote_python(self.FromTime))
        if self.ToTime is not None:
            showIndent(outfile, level)
            outfile.write('ToTime=%s,\n' % quote_python(self.ToTime))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FromTime':
            FromTime_ = ''
            for text__content_ in child_.childNodes:
                FromTime_ += text__content_.nodeValue
            self.FromTime = FromTime_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ToTime':
            ToTime_ = ''
            for text__content_ in child_.childNodes:
                ToTime_ += text__content_.nodeValue
            self.ToTime = ToTime_
# end class WorkingTime


class Tasks(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Task=None):
        if Task is None:
            self.Task = []
        else:
            self.Task = Task
    def factory(*args_, **kwargs_):
        if Tasks.subclass:
            return Tasks.subclass(*args_, **kwargs_)
        else:
            return Tasks(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Task(self): return self.Task
    def set_Task(self, Task): self.Task = Task
    def add_Task(self, value): self.Task.append(value)
    def insert_Task(self, index, value): self.Task[index] = value
    def export(self, outfile, level, namespace_='', name_='Tasks', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Tasks')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Tasks'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Tasks'):
        for Task_ in self.Task:
            Task_.export(outfile, level, namespace_, name_='Task')
    def hasContent_(self):
        if (
            self.Task
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Tasks'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Task=[\n')
        level += 1
        for Task_ in self.Task:
            showIndent(outfile, level)
            outfile.write('model_.Task(\n')
            Task_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Task':
            obj_ = Task.factory()
            obj_.build(child_)
            self.Task.append(obj_)
# end class Tasks

# You'll not find that one in the original spec... There
# is a name conflict (ExtendedAttribute nodes in Task and 
# Project/ExtendedAttributes), which generateDS seems not to be
# able to handle. Thus manually written part.

class ExtendedAttributeInstance(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, FieldID=None, Value=None):
        self.FieldID = FieldID
        self.Value = Value

    def factory(*args_, **kwargs_):
        if ExtendedAttributeInstance.subclass:
            return ExtendedAttributeInstance.subclass(*args_, **kwargs_)
        else:
            return ExtendedAttributeInstance(*args_, **kwargs_)
    factory = staticmethod(factory)
    
    def get_FieldID(self): return self.FieldID
    def set_FieldID(self, FieldID): self.FieldID = FieldID
    def get_Value(self): return self.Value
    def set_Value(self, Value): self.Value = Value

    def export(self, outfile, level, namespace_='', name_='ExtendedAttribute', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ExtendedAttribute')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ExtendedAttribute'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ExtendedAttribute'):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('<%sFieldID>%s</%sFieldID>\n' % (namespace_, self.format_string(quote_xml(self.FieldID), input_name='FieldID'), namespace_))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('<%sValue>%s</%sValue>\n' % (namespace_, self.format_string(quote_xml(self.Value), input_name='Value'), namespace_))

    def hasContent_(self):
        if (
            self.FieldID is not None or
            self.Value is not None
            ):
            return True
        else:
            return False

    def exportLiteral(self, outfile, level, name_='ExtendedAttribute'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.FieldID is not None:
            showIndent(outfile, level)
            outfile.write('FieldID=%s,\n' % quote_python(self.FieldID))
        if self.Value is not None:
            showIndent(outfile, level)
            outfile.write('Value=%s,\n' % quote_python(self.Value))

    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FieldID':
            FieldID_ = ''
            for text__content_ in child_.childNodes:
                FieldID_ += text__content_.nodeValue
            self.FieldID = FieldID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Value':
            Value_ = ''
            for text__content_ in child_.childNodes:
                Value_ += text__content_.nodeValue
            self.Value = Value_
#end class ExtendedAttributeInstance

class Task(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, UID=None, ID=None, Name=None, Type=None, IsNull=None, CreateDate=None, Contact=None, WBS=None, WBSLevel=None, OutlineNumber=None, OutlineLevel=None, Priority=None, Start=None, Finish=None, Duration=None, DurationFormat=None, Work=None, Stop=None, Resume=None, ResumeValid=None, EffortDriven=None, Recurring=None, OverAllocated=None, Estimated=None, Milestone=None, Summary=None, Critical=None, IsSubproject=None, IsSubprojectReadOnly=None, SubprojectName=None, ExternalTask=None, ExternalTaskProject=None, EarlyStart=None, EarlyFinish=None, LateStart=None, LateFinish=None, StartVariance=None, FinishVariance=None, WorkVariance=None, FreeSlack=None, TotalSlack=None, FixedCost=None, FixedCostAccrual=None, PercentComplete=None, PercentWorkComplete=None, Cost=None, OvertimeCost=None, OvertimeWork=None, ActualStart=None, ActualFinish=None, ActualDuration=None, ActualCost=None, ActualOvertimeCost=None, ActualWork=None, ActualOvertimeWork=None, RegularWork=None, RemainingDuration=None, RemainingCost=None, RemainingWork=None, RemainingOvertimeCost=None, RemainingOvertimeWork=None, ACWP=None, CV=None, ConstraintType=None, CalendarUID=None, ConstraintDate=None, Deadline=None, LevelAssignments=None, LevelingCanSplit=None, LevelingDelay=None, LevelingDelayFormat=None, PreLeveledStart=None, PreLeveledFinish=None, Hyperlink=None, HyperlinkAddress=None, HyperlinkSubAddress=None, IgnoreResourceCalendar=None, Notes=None, HideBar=None, Rollup=None, BCWS=None, BCWP=None, PhysicalPercentComplete=None, EarnedValueMethod=None, PredecessorLink=None, ActualWorkProtected=None, ActualOvertimeWorkProtected=None, ExtendedAttribute=None, Baseline=None, OutlineCode=None, TimephasedData=None):
        self.UID = UID
        self.ID = ID
        self.Name = Name
        self.Type = Type
        self.IsNull = IsNull
        self.CreateDate = CreateDate
        self.Contact = Contact
        self.WBS = WBS
        self.WBSLevel = WBSLevel
        self.OutlineNumber = OutlineNumber
        self.OutlineLevel = OutlineLevel
        self.Priority = Priority
        self.Start = Start
        self.Finish = Finish
        self.Duration = Duration
        self.DurationFormat = DurationFormat
        self.Work = Work
        self.Stop = Stop
        self.Resume = Resume
        self.ResumeValid = ResumeValid
        self.EffortDriven = EffortDriven
        self.Recurring = Recurring
        self.OverAllocated = OverAllocated
        self.Estimated = Estimated
        self.Milestone = Milestone
        self.Summary = Summary
        self.Critical = Critical
        self.IsSubproject = IsSubproject
        self.IsSubprojectReadOnly = IsSubprojectReadOnly
        self.SubprojectName = SubprojectName
        self.ExternalTask = ExternalTask
        self.ExternalTaskProject = ExternalTaskProject
        self.EarlyStart = EarlyStart
        self.EarlyFinish = EarlyFinish
        self.LateStart = LateStart
        self.LateFinish = LateFinish
        self.StartVariance = StartVariance
        self.FinishVariance = FinishVariance
        self.WorkVariance = WorkVariance
        self.FreeSlack = FreeSlack
        self.TotalSlack = TotalSlack
        self.FixedCost = FixedCost
        self.FixedCostAccrual = FixedCostAccrual
        self.PercentComplete = PercentComplete
        self.PercentWorkComplete = PercentWorkComplete
        self.Cost = Cost
        self.OvertimeCost = OvertimeCost
        self.OvertimeWork = OvertimeWork
        self.ActualStart = ActualStart
        self.ActualFinish = ActualFinish
        self.ActualDuration = ActualDuration
        self.ActualCost = ActualCost
        self.ActualOvertimeCost = ActualOvertimeCost
        self.ActualWork = ActualWork
        self.ActualOvertimeWork = ActualOvertimeWork
        self.RegularWork = RegularWork
        self.RemainingDuration = RemainingDuration
        self.RemainingCost = RemainingCost
        self.RemainingWork = RemainingWork
        self.RemainingOvertimeCost = RemainingOvertimeCost
        self.RemainingOvertimeWork = RemainingOvertimeWork
        self.ACWP = ACWP
        self.CV = CV
        self.ConstraintType = ConstraintType
        self.CalendarUID = CalendarUID
        self.ConstraintDate = ConstraintDate
        self.Deadline = Deadline
        self.LevelAssignments = LevelAssignments
        self.LevelingCanSplit = LevelingCanSplit
        self.LevelingDelay = LevelingDelay
        self.LevelingDelayFormat = LevelingDelayFormat
        self.PreLeveledStart = PreLeveledStart
        self.PreLeveledFinish = PreLeveledFinish
        self.Hyperlink = Hyperlink
        self.HyperlinkAddress = HyperlinkAddress
        self.HyperlinkSubAddress = HyperlinkSubAddress
        self.IgnoreResourceCalendar = IgnoreResourceCalendar
        self.Notes = Notes
        self.HideBar = HideBar
        self.Rollup = Rollup
        self.BCWS = BCWS
        self.BCWP = BCWP
        self.PhysicalPercentComplete = PhysicalPercentComplete
        self.EarnedValueMethod = EarnedValueMethod
        if PredecessorLink is None:
            self.PredecessorLink = []
        else:
            self.PredecessorLink = PredecessorLink
        self.ActualWorkProtected = ActualWorkProtected
        self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
        if ExtendedAttribute is None:
            self.ExtendedAttribute = []
        else:
            self.ExtendedAttribute = ExtendedAttribute
        if Baseline is None:
            self.Baseline = []
        else:
            self.Baseline = Baseline
        if OutlineCode is None:
            self.OutlineCode = []
        else:
            self.OutlineCode = OutlineCode
        if TimephasedData is None:
            self.TimephasedData = []
        else:
            self.TimephasedData = TimephasedData
    def factory(*args_, **kwargs_):
        if Task.subclass:
            return Task.subclass(*args_, **kwargs_)
        else:
            return Task(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def validate_Name(self, value):
        # Validate type Name, a restriction on xsd:string.
        pass
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_IsNull(self): return self.IsNull
    def set_IsNull(self, IsNull): self.IsNull = IsNull
    def get_CreateDate(self): return self.CreateDate
    def set_CreateDate(self, CreateDate): self.CreateDate = CreateDate
    def get_Contact(self): return self.Contact
    def set_Contact(self, Contact): self.Contact = Contact
    def validate_Contact(self, value):
        # Validate type Contact, a restriction on xsd:string.
        pass
    def get_WBS(self): return self.WBS
    def set_WBS(self, WBS): self.WBS = WBS
    def get_WBSLevel(self): return self.WBSLevel
    def set_WBSLevel(self, WBSLevel): self.WBSLevel = WBSLevel
    def get_OutlineNumber(self): return self.OutlineNumber
    def set_OutlineNumber(self, OutlineNumber): self.OutlineNumber = OutlineNumber
    def validate_OutlineNumber(self, value):
        # Validate type OutlineNumber, a restriction on xsd:string.
        pass
    def get_OutlineLevel(self): return self.OutlineLevel
    def set_OutlineLevel(self, OutlineLevel): self.OutlineLevel = OutlineLevel
    def get_Priority(self): return self.Priority
    def set_Priority(self, Priority): self.Priority = Priority
    def get_Start(self): return self.Start
    def set_Start(self, Start): self.Start = Start
    def get_Finish(self): return self.Finish
    def set_Finish(self, Finish): self.Finish = Finish
    def get_Duration(self): return self.Duration
    def set_Duration(self, Duration): self.Duration = Duration
    def get_DurationFormat(self): return self.DurationFormat
    def set_DurationFormat(self, DurationFormat): self.DurationFormat = DurationFormat
    def validate_DurationFormat(self, value):
        # Validate type DurationFormat, a restriction on xsd:integer.
        pass
    def get_Work(self): return self.Work
    def set_Work(self, Work): self.Work = Work
    def get_Stop(self): return self.Stop
    def set_Stop(self, Stop): self.Stop = Stop
    def get_Resume(self): return self.Resume
    def set_Resume(self, Resume): self.Resume = Resume
    def get_ResumeValid(self): return self.ResumeValid
    def set_ResumeValid(self, ResumeValid): self.ResumeValid = ResumeValid
    def get_EffortDriven(self): return self.EffortDriven
    def set_EffortDriven(self, EffortDriven): self.EffortDriven = EffortDriven
    def get_Recurring(self): return self.Recurring
    def set_Recurring(self, Recurring): self.Recurring = Recurring
    def get_OverAllocated(self): return self.OverAllocated
    def set_OverAllocated(self, OverAllocated): self.OverAllocated = OverAllocated
    def get_Estimated(self): return self.Estimated
    def set_Estimated(self, Estimated): self.Estimated = Estimated
    def get_Milestone(self): return self.Milestone
    def set_Milestone(self, Milestone): self.Milestone = Milestone
    def get_Summary(self): return self.Summary
    def set_Summary(self, Summary): self.Summary = Summary
    def get_Critical(self): return self.Critical
    def set_Critical(self, Critical): self.Critical = Critical
    def get_IsSubproject(self): return self.IsSubproject
    def set_IsSubproject(self, IsSubproject): self.IsSubproject = IsSubproject
    def get_IsSubprojectReadOnly(self): return self.IsSubprojectReadOnly
    def set_IsSubprojectReadOnly(self, IsSubprojectReadOnly): self.IsSubprojectReadOnly = IsSubprojectReadOnly
    def get_SubprojectName(self): return self.SubprojectName
    def set_SubprojectName(self, SubprojectName): self.SubprojectName = SubprojectName
    def validate_SubprojectName(self, value):
        # Validate type SubprojectName, a restriction on xsd:string.
        pass
    def get_ExternalTask(self): return self.ExternalTask
    def set_ExternalTask(self, ExternalTask): self.ExternalTask = ExternalTask
    def get_ExternalTaskProject(self): return self.ExternalTaskProject
    def set_ExternalTaskProject(self, ExternalTaskProject): self.ExternalTaskProject = ExternalTaskProject
    def validate_ExternalTaskProject(self, value):
        # Validate type ExternalTaskProject, a restriction on xsd:string.
        pass
    def get_EarlyStart(self): return self.EarlyStart
    def set_EarlyStart(self, EarlyStart): self.EarlyStart = EarlyStart
    def get_EarlyFinish(self): return self.EarlyFinish
    def set_EarlyFinish(self, EarlyFinish): self.EarlyFinish = EarlyFinish
    def get_LateStart(self): return self.LateStart
    def set_LateStart(self, LateStart): self.LateStart = LateStart
    def get_LateFinish(self): return self.LateFinish
    def set_LateFinish(self, LateFinish): self.LateFinish = LateFinish
    def get_StartVariance(self): return self.StartVariance
    def set_StartVariance(self, StartVariance): self.StartVariance = StartVariance
    def get_FinishVariance(self): return self.FinishVariance
    def set_FinishVariance(self, FinishVariance): self.FinishVariance = FinishVariance
    def get_WorkVariance(self): return self.WorkVariance
    def set_WorkVariance(self, WorkVariance): self.WorkVariance = WorkVariance
    def get_FreeSlack(self): return self.FreeSlack
    def set_FreeSlack(self, FreeSlack): self.FreeSlack = FreeSlack
    def get_TotalSlack(self): return self.TotalSlack
    def set_TotalSlack(self, TotalSlack): self.TotalSlack = TotalSlack
    def get_FixedCost(self): return self.FixedCost
    def set_FixedCost(self, FixedCost): self.FixedCost = FixedCost
    def get_FixedCostAccrual(self): return self.FixedCostAccrual
    def set_FixedCostAccrual(self, FixedCostAccrual): self.FixedCostAccrual = FixedCostAccrual
    def validate_FixedCostAccrual(self, value):
        # Validate type FixedCostAccrual, a restriction on xsd:string.
        pass
    def get_PercentComplete(self): return self.PercentComplete
    def set_PercentComplete(self, PercentComplete): self.PercentComplete = PercentComplete
    def get_PercentWorkComplete(self): return self.PercentWorkComplete
    def set_PercentWorkComplete(self, PercentWorkComplete): self.PercentWorkComplete = PercentWorkComplete
    def get_Cost(self): return self.Cost
    def set_Cost(self, Cost): self.Cost = Cost
    def get_OvertimeCost(self): return self.OvertimeCost
    def set_OvertimeCost(self, OvertimeCost): self.OvertimeCost = OvertimeCost
    def get_OvertimeWork(self): return self.OvertimeWork
    def set_OvertimeWork(self, OvertimeWork): self.OvertimeWork = OvertimeWork
    def get_ActualStart(self): return self.ActualStart
    def set_ActualStart(self, ActualStart): self.ActualStart = ActualStart
    def get_ActualFinish(self): return self.ActualFinish
    def set_ActualFinish(self, ActualFinish): self.ActualFinish = ActualFinish
    def get_ActualDuration(self): return self.ActualDuration
    def set_ActualDuration(self, ActualDuration): self.ActualDuration = ActualDuration
    def get_ActualCost(self): return self.ActualCost
    def set_ActualCost(self, ActualCost): self.ActualCost = ActualCost
    def get_ActualOvertimeCost(self): return self.ActualOvertimeCost
    def set_ActualOvertimeCost(self, ActualOvertimeCost): self.ActualOvertimeCost = ActualOvertimeCost
    def get_ActualWork(self): return self.ActualWork
    def set_ActualWork(self, ActualWork): self.ActualWork = ActualWork
    def get_ActualOvertimeWork(self): return self.ActualOvertimeWork
    def set_ActualOvertimeWork(self, ActualOvertimeWork): self.ActualOvertimeWork = ActualOvertimeWork
    def get_RegularWork(self): return self.RegularWork
    def set_RegularWork(self, RegularWork): self.RegularWork = RegularWork
    def get_RemainingDuration(self): return self.RemainingDuration
    def set_RemainingDuration(self, RemainingDuration): self.RemainingDuration = RemainingDuration
    def get_RemainingCost(self): return self.RemainingCost
    def set_RemainingCost(self, RemainingCost): self.RemainingCost = RemainingCost
    def get_RemainingWork(self): return self.RemainingWork
    def set_RemainingWork(self, RemainingWork): self.RemainingWork = RemainingWork
    def get_RemainingOvertimeCost(self): return self.RemainingOvertimeCost
    def set_RemainingOvertimeCost(self, RemainingOvertimeCost): self.RemainingOvertimeCost = RemainingOvertimeCost
    def get_RemainingOvertimeWork(self): return self.RemainingOvertimeWork
    def set_RemainingOvertimeWork(self, RemainingOvertimeWork): self.RemainingOvertimeWork = RemainingOvertimeWork
    def get_ACWP(self): return self.ACWP
    def set_ACWP(self, ACWP): self.ACWP = ACWP
    def get_CV(self): return self.CV
    def set_CV(self, CV): self.CV = CV
    def get_ConstraintType(self): return self.ConstraintType
    def set_ConstraintType(self, ConstraintType): self.ConstraintType = ConstraintType
    def validate_ConstraintType(self, value):
        # Validate type ConstraintType, a restriction on xsd:integer.
        pass
    def get_CalendarUID(self): return self.CalendarUID
    def set_CalendarUID(self, CalendarUID): self.CalendarUID = CalendarUID
    def get_ConstraintDate(self): return self.ConstraintDate
    def set_ConstraintDate(self, ConstraintDate): self.ConstraintDate = ConstraintDate
    def get_Deadline(self): return self.Deadline
    def set_Deadline(self, Deadline): self.Deadline = Deadline
    def get_LevelAssignments(self): return self.LevelAssignments
    def set_LevelAssignments(self, LevelAssignments): self.LevelAssignments = LevelAssignments
    def get_LevelingCanSplit(self): return self.LevelingCanSplit
    def set_LevelingCanSplit(self, LevelingCanSplit): self.LevelingCanSplit = LevelingCanSplit
    def get_LevelingDelay(self): return self.LevelingDelay
    def set_LevelingDelay(self, LevelingDelay): self.LevelingDelay = LevelingDelay
    def get_LevelingDelayFormat(self): return self.LevelingDelayFormat
    def set_LevelingDelayFormat(self, LevelingDelayFormat): self.LevelingDelayFormat = LevelingDelayFormat
    def validate_LevelingDelayFormat(self, value):
        # Validate type LevelingDelayFormat, a restriction on xsd:integer.
        pass
    def get_PreLeveledStart(self): return self.PreLeveledStart
    def set_PreLeveledStart(self, PreLeveledStart): self.PreLeveledStart = PreLeveledStart
    def get_PreLeveledFinish(self): return self.PreLeveledFinish
    def set_PreLeveledFinish(self, PreLeveledFinish): self.PreLeveledFinish = PreLeveledFinish
    def get_Hyperlink(self): return self.Hyperlink
    def set_Hyperlink(self, Hyperlink): self.Hyperlink = Hyperlink
    def validate_Hyperlink(self, value):
        # Validate type Hyperlink, a restriction on xsd:string.
        pass
    def get_HyperlinkAddress(self): return self.HyperlinkAddress
    def set_HyperlinkAddress(self, HyperlinkAddress): self.HyperlinkAddress = HyperlinkAddress
    def validate_HyperlinkAddress(self, value):
        # Validate type HyperlinkAddress, a restriction on xsd:string.
        pass
    def get_HyperlinkSubAddress(self): return self.HyperlinkSubAddress
    def set_HyperlinkSubAddress(self, HyperlinkSubAddress): self.HyperlinkSubAddress = HyperlinkSubAddress
    def validate_HyperlinkSubAddress(self, value):
        # Validate type HyperlinkSubAddress, a restriction on xsd:string.
        pass
    def get_IgnoreResourceCalendar(self): return self.IgnoreResourceCalendar
    def set_IgnoreResourceCalendar(self, IgnoreResourceCalendar): self.IgnoreResourceCalendar = IgnoreResourceCalendar
    def get_Notes(self): return self.Notes
    def set_Notes(self, Notes): self.Notes = Notes
    def get_HideBar(self): return self.HideBar
    def set_HideBar(self, HideBar): self.HideBar = HideBar
    def get_Rollup(self): return self.Rollup
    def set_Rollup(self, Rollup): self.Rollup = Rollup
    def get_BCWS(self): return self.BCWS
    def set_BCWS(self, BCWS): self.BCWS = BCWS
    def get_BCWP(self): return self.BCWP
    def set_BCWP(self, BCWP): self.BCWP = BCWP
    def get_PhysicalPercentComplete(self): return self.PhysicalPercentComplete
    def set_PhysicalPercentComplete(self, PhysicalPercentComplete): self.PhysicalPercentComplete = PhysicalPercentComplete
    def get_EarnedValueMethod(self): return self.EarnedValueMethod
    def set_EarnedValueMethod(self, EarnedValueMethod): self.EarnedValueMethod = EarnedValueMethod
    def validate_EarnedValueMethod(self, value):
        # Validate type EarnedValueMethod, a restriction on xsd:integer.
        pass
    def get_PredecessorLink(self): return self.PredecessorLink
    def set_PredecessorLink(self, PredecessorLink): self.PredecessorLink = PredecessorLink
    def add_PredecessorLink(self, value): self.PredecessorLink.append(value)
    def insert_PredecessorLink(self, index, value): self.PredecessorLink[index] = value
    def get_ActualWorkProtected(self): return self.ActualWorkProtected
    def set_ActualWorkProtected(self, ActualWorkProtected): self.ActualWorkProtected = ActualWorkProtected
    def get_ActualOvertimeWorkProtected(self): return self.ActualOvertimeWorkProtected
    def set_ActualOvertimeWorkProtected(self, ActualOvertimeWorkProtected): self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
    def get_ExtendedAttribute(self): return self.ExtendedAttribute
    def set_ExtendedAttribute(self, ExtendedAttribute): self.ExtendedAttribute = ExtendedAttribute
    def add_ExtendedAttribute(self, value): self.ExtendedAttribute.append(value)
    def insert_ExtendedAttribute(self, index, value): self.ExtendedAttribute[index] = value
    def get_Baseline(self): return self.Baseline
    def set_Baseline(self, Baseline): self.Baseline = Baseline
    def add_Baseline(self, value): self.Baseline.append(value)
    def insert_Baseline(self, index, value): self.Baseline[index] = value
    def get_OutlineCode(self): return self.OutlineCode
    def set_OutlineCode(self, OutlineCode): self.OutlineCode = OutlineCode
    def add_OutlineCode(self, value): self.OutlineCode.append(value)
    def insert_OutlineCode(self, index, value): self.OutlineCode[index] = value
    def get_TimephasedData(self): return self.TimephasedData
    def set_TimephasedData(self, TimephasedData): self.TimephasedData = TimephasedData
    def add_TimephasedData(self, value): self.TimephasedData.append(value)
    def insert_TimephasedData(self, index, value): self.TimephasedData[index] = value
    def export(self, outfile, level, namespace_='', name_='Task', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Task')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Task'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Task'):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.ID is not None:
            showIndent(outfile, level)
            outfile.write('<%sID>%s</%sID>\n' % (namespace_, self.format_string(quote_xml(self.ID), input_name='ID'), namespace_))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('<%sName>%s</%sName>\n' % (namespace_, self.format_string(quote_xml(self.Name), input_name='Name'), namespace_))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.IsNull is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsNull>%s</%sIsNull>\n' % (namespace_, self.format_string(quote_xml(self.IsNull), input_name='IsNull'), namespace_))
        if self.CreateDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sCreateDate>%s</%sCreateDate>\n' % (namespace_, self.format_string(quote_xml(self.CreateDate), input_name='CreateDate'), namespace_))
        if self.Contact is not None:
            showIndent(outfile, level)
            outfile.write('<%sContact>%s</%sContact>\n' % (namespace_, self.format_string(quote_xml(self.Contact), input_name='Contact'), namespace_))
        if self.WBS is not None:
            showIndent(outfile, level)
            outfile.write('<%sWBS>%s</%sWBS>\n' % (namespace_, self.format_string(quote_xml(self.WBS), input_name='WBS'), namespace_))
        if self.WBSLevel is not None:
            showIndent(outfile, level)
            outfile.write('<%sWBSLevel>%s</%sWBSLevel>\n' % (namespace_, self.format_string(quote_xml(self.WBSLevel), input_name='WBSLevel'), namespace_))
        if self.OutlineNumber is not None:
            showIndent(outfile, level)
            outfile.write('<%sOutlineNumber>%s</%sOutlineNumber>\n' % (namespace_, self.format_string(quote_xml(self.OutlineNumber), input_name='OutlineNumber'), namespace_))
        if self.OutlineLevel is not None:
            showIndent(outfile, level)
            outfile.write('<%sOutlineLevel>%s</%sOutlineLevel>\n' % (namespace_, self.format_string(quote_xml(self.OutlineLevel), input_name='OutlineLevel'), namespace_))
        if self.Priority is not None:
            showIndent(outfile, level)
            outfile.write('<%sPriority>%s</%sPriority>\n' % (namespace_, self.format_string(quote_xml(self.Priority), input_name='Priority'), namespace_))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('<%sStart>%s</%sStart>\n' % (namespace_, self.format_string(quote_xml(self.Start), input_name='Start'), namespace_))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinish>%s</%sFinish>\n' % (namespace_, self.format_string(quote_xml(self.Finish), input_name='Finish'), namespace_))
        if self.Duration is not None:
            showIndent(outfile, level)
            outfile.write('<%sDuration>%s</%sDuration>\n' % (namespace_, self.format_string(quote_xml(self.Duration), input_name='Duration'), namespace_))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sDurationFormat>%s</%sDurationFormat>\n' % (namespace_, self.format_string(quote_xml(self.DurationFormat), input_name='DurationFormat'), namespace_))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('<%sWork>%s</%sWork>\n' % (namespace_, self.format_string(quote_xml(self.Work), input_name='Work'), namespace_))
        if self.Stop is not None:
            showIndent(outfile, level)
            outfile.write('<%sStop>%s</%sStop>\n' % (namespace_, self.format_string(quote_xml(self.Stop), input_name='Stop'), namespace_))
        if self.Resume is not None:
            showIndent(outfile, level)
            outfile.write('<%sResume>%s</%sResume>\n' % (namespace_, self.format_string(quote_xml(self.Resume), input_name='Resume'), namespace_))
        if self.ResumeValid is not None:
            showIndent(outfile, level)
            outfile.write('<%sResumeValid>%s</%sResumeValid>\n' % (namespace_, self.format_string(quote_xml(self.ResumeValid), input_name='ResumeValid'), namespace_))
        if self.EffortDriven is not None:
            showIndent(outfile, level)
            outfile.write('<%sEffortDriven>%s</%sEffortDriven>\n' % (namespace_, self.format_string(quote_xml(self.EffortDriven), input_name='EffortDriven'), namespace_))
        if self.Recurring is not None:
            showIndent(outfile, level)
            outfile.write('<%sRecurring>%s</%sRecurring>\n' % (namespace_, self.format_string(quote_xml(self.Recurring), input_name='Recurring'), namespace_))
        if self.OverAllocated is not None:
            showIndent(outfile, level)
            outfile.write('<%sOverAllocated>%s</%sOverAllocated>\n' % (namespace_, self.format_string(quote_xml(self.OverAllocated), input_name='OverAllocated'), namespace_))
        if self.Estimated is not None:
            showIndent(outfile, level)
            outfile.write('<%sEstimated>%s</%sEstimated>\n' % (namespace_, self.format_string(quote_xml(self.Estimated), input_name='Estimated'), namespace_))
        if self.Milestone is not None:
            showIndent(outfile, level)
            outfile.write('<%sMilestone>%s</%sMilestone>\n' % (namespace_, self.format_string(quote_xml(self.Milestone), input_name='Milestone'), namespace_))
        if self.Summary is not None:
            showIndent(outfile, level)
            outfile.write('<%sSummary>%s</%sSummary>\n' % (namespace_, self.format_string(quote_xml(self.Summary), input_name='Summary'), namespace_))
        if self.Critical is not None:
            showIndent(outfile, level)
            outfile.write('<%sCritical>%s</%sCritical>\n' % (namespace_, self.format_string(quote_xml(self.Critical), input_name='Critical'), namespace_))
        if self.IsSubproject is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsSubproject>%s</%sIsSubproject>\n' % (namespace_, self.format_string(quote_xml(self.IsSubproject), input_name='IsSubproject'), namespace_))
        if self.IsSubprojectReadOnly is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsSubprojectReadOnly>%s</%sIsSubprojectReadOnly>\n' % (namespace_, self.format_string(quote_xml(self.IsSubprojectReadOnly), input_name='IsSubprojectReadOnly'), namespace_))
        if self.SubprojectName is not None:
            showIndent(outfile, level)
            outfile.write('<%sSubprojectName>%s</%sSubprojectName>\n' % (namespace_, self.format_string(quote_xml(self.SubprojectName), input_name='SubprojectName'), namespace_))
        if self.ExternalTask is not None:
            showIndent(outfile, level)
            outfile.write('<%sExternalTask>%s</%sExternalTask>\n' % (namespace_, self.format_string(quote_xml(self.ExternalTask), input_name='ExternalTask'), namespace_))
        if self.ExternalTaskProject is not None:
            showIndent(outfile, level)
            outfile.write('<%sExternalTaskProject>%s</%sExternalTaskProject>\n' % (namespace_, self.format_string(quote_xml(self.ExternalTaskProject), input_name='ExternalTaskProject'), namespace_))
        if self.EarlyStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sEarlyStart>%s</%sEarlyStart>\n' % (namespace_, self.format_string(quote_xml(self.EarlyStart), input_name='EarlyStart'), namespace_))
        if self.EarlyFinish is not None:
            showIndent(outfile, level)
            outfile.write('<%sEarlyFinish>%s</%sEarlyFinish>\n' % (namespace_, self.format_string(quote_xml(self.EarlyFinish), input_name='EarlyFinish'), namespace_))
        if self.LateStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sLateStart>%s</%sLateStart>\n' % (namespace_, self.format_string(quote_xml(self.LateStart), input_name='LateStart'), namespace_))
        if self.LateFinish is not None:
            showIndent(outfile, level)
            outfile.write('<%sLateFinish>%s</%sLateFinish>\n' % (namespace_, self.format_string(quote_xml(self.LateFinish), input_name='LateFinish'), namespace_))
        if self.StartVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sStartVariance>%s</%sStartVariance>\n' % (namespace_, self.format_string(quote_xml(self.StartVariance), input_name='StartVariance'), namespace_))
        if self.FinishVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinishVariance>%s</%sFinishVariance>\n' % (namespace_, self.format_string(quote_xml(self.FinishVariance), input_name='FinishVariance'), namespace_))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkVariance>%s</%sWorkVariance>\n' % (namespace_, self.format_string(quote_xml(self.WorkVariance), input_name='WorkVariance'), namespace_))
        if self.FreeSlack is not None:
            showIndent(outfile, level)
            outfile.write('<%sFreeSlack>%s</%sFreeSlack>\n' % (namespace_, self.format_string(quote_xml(self.FreeSlack), input_name='FreeSlack'), namespace_))
        if self.TotalSlack is not None:
            showIndent(outfile, level)
            outfile.write('<%sTotalSlack>%s</%sTotalSlack>\n' % (namespace_, self.format_string(quote_xml(self.TotalSlack), input_name='TotalSlack'), namespace_))
        if self.FixedCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sFixedCost>%s</%sFixedCost>\n' % (namespace_, self.format_string(quote_xml(self.FixedCost), input_name='FixedCost'), namespace_))
        if self.FixedCostAccrual is not None:
            showIndent(outfile, level)
            outfile.write('<%sFixedCostAccrual>%s</%sFixedCostAccrual>\n' % (namespace_, self.format_string(quote_xml(self.FixedCostAccrual), input_name='FixedCostAccrual'), namespace_))
        if self.PercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sPercentComplete>%s</%sPercentComplete>\n' % (namespace_, self.format_string(quote_xml(self.PercentComplete), input_name='PercentComplete'), namespace_))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sPercentWorkComplete>%s</%sPercentWorkComplete>\n' % (namespace_, self.format_string(quote_xml(self.PercentWorkComplete), input_name='PercentWorkComplete'), namespace_))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('<%sCost>%s</%sCost>\n' % (namespace_, self.format_string(quote_xml(self.Cost), input_name='Cost'), namespace_))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeCost>%s</%sOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeCost), input_name='OvertimeCost'), namespace_))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeWork>%s</%sOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeWork), input_name='OvertimeWork'), namespace_))
        if self.ActualStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualStart>%s</%sActualStart>\n' % (namespace_, self.format_string(quote_xml(self.ActualStart), input_name='ActualStart'), namespace_))
        if self.ActualFinish is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualFinish>%s</%sActualFinish>\n' % (namespace_, self.format_string(quote_xml(self.ActualFinish), input_name='ActualFinish'), namespace_))
        if self.ActualDuration is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualDuration>%s</%sActualDuration>\n' % (namespace_, self.format_string(quote_xml(self.ActualDuration), input_name='ActualDuration'), namespace_))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualCost>%s</%sActualCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualCost), input_name='ActualCost'), namespace_))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeCost>%s</%sActualOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeCost), input_name='ActualOvertimeCost'), namespace_))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWork>%s</%sActualWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualWork), input_name='ActualWork'), namespace_))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWork>%s</%sActualOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWork), input_name='ActualOvertimeWork'), namespace_))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRegularWork>%s</%sRegularWork>\n' % (namespace_, self.format_string(quote_xml(self.RegularWork), input_name='RegularWork'), namespace_))
        if self.RemainingDuration is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingDuration>%s</%sRemainingDuration>\n' % (namespace_, self.format_string(quote_xml(self.RemainingDuration), input_name='RemainingDuration'), namespace_))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingCost>%s</%sRemainingCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingCost), input_name='RemainingCost'), namespace_))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingWork>%s</%sRemainingWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingWork), input_name='RemainingWork'), namespace_))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeCost>%s</%sRemainingOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeCost), input_name='RemainingOvertimeCost'), namespace_))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeWork>%s</%sRemainingOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeWork), input_name='RemainingOvertimeWork'), namespace_))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sACWP>%s</%sACWP>\n' % (namespace_, self.format_string(quote_xml(self.ACWP), input_name='ACWP'), namespace_))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('<%sCV>%s</%sCV>\n' % (namespace_, self.format_string(quote_xml(self.CV), input_name='CV'), namespace_))
        if self.ConstraintType is not None:
            showIndent(outfile, level)
            outfile.write('<%sConstraintType>%s</%sConstraintType>\n' % (namespace_, self.format_string(quote_xml(self.ConstraintType), input_name='ConstraintType'), namespace_))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sCalendarUID>%s</%sCalendarUID>\n' % (namespace_, self.format_string(quote_xml(self.CalendarUID), input_name='CalendarUID'), namespace_))
        if self.ConstraintDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sConstraintDate>%s</%sConstraintDate>\n' % (namespace_, self.format_string(quote_xml(self.ConstraintDate), input_name='ConstraintDate'), namespace_))
        if self.Deadline is not None:
            showIndent(outfile, level)
            outfile.write('<%sDeadline>%s</%sDeadline>\n' % (namespace_, self.format_string(quote_xml(self.Deadline), input_name='Deadline'), namespace_))
        if self.LevelAssignments is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelAssignments>%s</%sLevelAssignments>\n' % (namespace_, self.format_string(quote_xml(self.LevelAssignments), input_name='LevelAssignments'), namespace_))
        if self.LevelingCanSplit is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelingCanSplit>%s</%sLevelingCanSplit>\n' % (namespace_, self.format_string(quote_xml(self.LevelingCanSplit), input_name='LevelingCanSplit'), namespace_))
        if self.LevelingDelay is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelingDelay>%s</%sLevelingDelay>\n' % (namespace_, self.format_string(quote_xml(self.LevelingDelay), input_name='LevelingDelay'), namespace_))
        if self.LevelingDelayFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelingDelayFormat>%s</%sLevelingDelayFormat>\n' % (namespace_, self.format_string(quote_xml(self.LevelingDelayFormat), input_name='LevelingDelayFormat'), namespace_))
        if self.PreLeveledStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sPreLeveledStart>%s</%sPreLeveledStart>\n' % (namespace_, self.format_string(quote_xml(self.PreLeveledStart), input_name='PreLeveledStart'), namespace_))
        if self.PreLeveledFinish is not None:
            showIndent(outfile, level)
            outfile.write('<%sPreLeveledFinish>%s</%sPreLeveledFinish>\n' % (namespace_, self.format_string(quote_xml(self.PreLeveledFinish), input_name='PreLeveledFinish'), namespace_))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlink>%s</%sHyperlink>\n' % (namespace_, self.format_string(quote_xml(self.Hyperlink), input_name='Hyperlink'), namespace_))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkAddress>%s</%sHyperlinkAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkAddress), input_name='HyperlinkAddress'), namespace_))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkSubAddress>%s</%sHyperlinkSubAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkSubAddress), input_name='HyperlinkSubAddress'), namespace_))
        if self.IgnoreResourceCalendar is not None:
            showIndent(outfile, level)
            outfile.write('<%sIgnoreResourceCalendar>%s</%sIgnoreResourceCalendar>\n' % (namespace_, self.format_string(quote_xml(self.IgnoreResourceCalendar), input_name='IgnoreResourceCalendar'), namespace_))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('<%sNotes>%s</%sNotes>\n' % (namespace_, self.format_string(quote_xml(self.Notes), input_name='Notes'), namespace_))
        if self.HideBar is not None:
            showIndent(outfile, level)
            outfile.write('<%sHideBar>%s</%sHideBar>\n' % (namespace_, self.format_string(quote_xml(self.HideBar), input_name='HideBar'), namespace_))
        if self.Rollup is not None:
            showIndent(outfile, level)
            outfile.write('<%sRollup>%s</%sRollup>\n' % (namespace_, self.format_string(quote_xml(self.Rollup), input_name='Rollup'), namespace_))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWS>%s</%sBCWS>\n' % (namespace_, self.format_string(quote_xml(self.BCWS), input_name='BCWS'), namespace_))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWP>%s</%sBCWP>\n' % (namespace_, self.format_string(quote_xml(self.BCWP), input_name='BCWP'), namespace_))
        if self.PhysicalPercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sPhysicalPercentComplete>%s</%sPhysicalPercentComplete>\n' % (namespace_, self.format_string(quote_xml(self.PhysicalPercentComplete), input_name='PhysicalPercentComplete'), namespace_))
        if self.EarnedValueMethod is not None:
            showIndent(outfile, level)
            outfile.write('<%sEarnedValueMethod>%s</%sEarnedValueMethod>\n' % (namespace_, self.format_string(quote_xml(self.EarnedValueMethod), input_name='EarnedValueMethod'), namespace_))
        for PredecessorLink_ in self.PredecessorLink:
            PredecessorLink_.export(outfile, level, namespace_, name_='PredecessorLink')
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWorkProtected>%s</%sActualWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualWorkProtected), input_name='ActualWorkProtected'), namespace_))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWorkProtected>%s</%sActualOvertimeWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWorkProtected), input_name='ActualOvertimeWorkProtected'), namespace_))
        for ExtendedAttribute_ in self.ExtendedAttribute:
            ExtendedAttribute_.export(outfile, level, namespace_, name_='ExtendedAttribute')
        for Baseline_ in self.Baseline:
            Baseline_.export(outfile, level, namespace_, name_='Baseline')
        for OutlineCode_ in self.OutlineCode:
            OutlineCode_.export(outfile, level, namespace_, name_='OutlineCode')
        for TimephasedData_ in self.TimephasedData:
            TimephasedData_.export(outfile, level, namespace_, name_='TimephasedData')
    def hasContent_(self):
        if (
            self.UID is not None or
            self.ID is not None or
            self.Name is not None or
            self.Type is not None or
            self.IsNull is not None or
            self.CreateDate is not None or
            self.Contact is not None or
            self.WBS is not None or
            self.WBSLevel is not None or
            self.OutlineNumber is not None or
            self.OutlineLevel is not None or
            self.Priority is not None or
            self.Start is not None or
            self.Finish is not None or
            self.Duration is not None or
            self.DurationFormat is not None or
            self.Work is not None or
            self.Stop is not None or
            self.Resume is not None or
            self.ResumeValid is not None or
            self.EffortDriven is not None or
            self.Recurring is not None or
            self.OverAllocated is not None or
            self.Estimated is not None or
            self.Milestone is not None or
            self.Summary is not None or
            self.Critical is not None or
            self.IsSubproject is not None or
            self.IsSubprojectReadOnly is not None or
            self.SubprojectName is not None or
            self.ExternalTask is not None or
            self.ExternalTaskProject is not None or
            self.EarlyStart is not None or
            self.EarlyFinish is not None or
            self.LateStart is not None or
            self.LateFinish is not None or
            self.StartVariance is not None or
            self.FinishVariance is not None or
            self.WorkVariance is not None or
            self.FreeSlack is not None or
            self.TotalSlack is not None or
            self.FixedCost is not None or
            self.FixedCostAccrual is not None or
            self.PercentComplete is not None or
            self.PercentWorkComplete is not None or
            self.Cost is not None or
            self.OvertimeCost is not None or
            self.OvertimeWork is not None or
            self.ActualStart is not None or
            self.ActualFinish is not None or
            self.ActualDuration is not None or
            self.ActualCost is not None or
            self.ActualOvertimeCost is not None or
            self.ActualWork is not None or
            self.ActualOvertimeWork is not None or
            self.RegularWork is not None or
            self.RemainingDuration is not None or
            self.RemainingCost is not None or
            self.RemainingWork is not None or
            self.RemainingOvertimeCost is not None or
            self.RemainingOvertimeWork is not None or
            self.ACWP is not None or
            self.CV is not None or
            self.ConstraintType is not None or
            self.CalendarUID is not None or
            self.ConstraintDate is not None or
            self.Deadline is not None or
            self.LevelAssignments is not None or
            self.LevelingCanSplit is not None or
            self.LevelingDelay is not None or
            self.LevelingDelayFormat is not None or
            self.PreLeveledStart is not None or
            self.PreLeveledFinish is not None or
            self.Hyperlink is not None or
            self.HyperlinkAddress is not None or
            self.HyperlinkSubAddress is not None or
            self.IgnoreResourceCalendar is not None or
            self.Notes is not None or
            self.HideBar is not None or
            self.Rollup is not None or
            self.BCWS is not None or
            self.BCWP is not None or
            self.PhysicalPercentComplete is not None or
            self.EarnedValueMethod is not None or
            self.PredecessorLink or
            self.ActualWorkProtected is not None or
            self.ActualOvertimeWorkProtected is not None or
            self.ExtendedAttribute or
            self.Baseline or
            self.OutlineCode or
            self.TimephasedData
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Task'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.ID is not None:
            showIndent(outfile, level)
            outfile.write('ID=%s,\n' % quote_python(self.ID))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('Name=%s,\n' % quote_python(self.Name))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.IsNull is not None:
            showIndent(outfile, level)
            outfile.write('IsNull=%s,\n' % quote_python(self.IsNull))
        if self.CreateDate is not None:
            showIndent(outfile, level)
            outfile.write('CreateDate=%s,\n' % quote_python(self.CreateDate))
        if self.Contact is not None:
            showIndent(outfile, level)
            outfile.write('Contact=%s,\n' % quote_python(self.Contact))
        if self.WBS is not None:
            showIndent(outfile, level)
            outfile.write('WBS=%s,\n' % quote_python(self.WBS))
        if self.WBSLevel is not None:
            showIndent(outfile, level)
            outfile.write('WBSLevel=%s,\n' % quote_python(self.WBSLevel))
        if self.OutlineNumber is not None:
            showIndent(outfile, level)
            outfile.write('OutlineNumber=%s,\n' % quote_python(self.OutlineNumber))
        if self.OutlineLevel is not None:
            showIndent(outfile, level)
            outfile.write('OutlineLevel=%s,\n' % quote_python(self.OutlineLevel))
        if self.Priority is not None:
            showIndent(outfile, level)
            outfile.write('Priority=%s,\n' % quote_python(self.Priority))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('Start=%s,\n' % quote_python(self.Start))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('Finish=%s,\n' % quote_python(self.Finish))
        if self.Duration is not None:
            showIndent(outfile, level)
            outfile.write('Duration=%s,\n' % quote_python(self.Duration))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('DurationFormat=%s,\n' % quote_python(self.DurationFormat))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('Work=%s,\n' % quote_python(self.Work))
        if self.Stop is not None:
            showIndent(outfile, level)
            outfile.write('Stop=%s,\n' % quote_python(self.Stop))
        if self.Resume is not None:
            showIndent(outfile, level)
            outfile.write('Resume=%s,\n' % quote_python(self.Resume))
        if self.ResumeValid is not None:
            showIndent(outfile, level)
            outfile.write('ResumeValid=%s,\n' % quote_python(self.ResumeValid))
        if self.EffortDriven is not None:
            showIndent(outfile, level)
            outfile.write('EffortDriven=%s,\n' % quote_python(self.EffortDriven))
        if self.Recurring is not None:
            showIndent(outfile, level)
            outfile.write('Recurring=%s,\n' % quote_python(self.Recurring))
        if self.OverAllocated is not None:
            showIndent(outfile, level)
            outfile.write('OverAllocated=%s,\n' % quote_python(self.OverAllocated))
        if self.Estimated is not None:
            showIndent(outfile, level)
            outfile.write('Estimated=%s,\n' % quote_python(self.Estimated))
        if self.Milestone is not None:
            showIndent(outfile, level)
            outfile.write('Milestone=%s,\n' % quote_python(self.Milestone))
        if self.Summary is not None:
            showIndent(outfile, level)
            outfile.write('Summary=%s,\n' % quote_python(self.Summary))
        if self.Critical is not None:
            showIndent(outfile, level)
            outfile.write('Critical=%s,\n' % quote_python(self.Critical))
        if self.IsSubproject is not None:
            showIndent(outfile, level)
            outfile.write('IsSubproject=%s,\n' % quote_python(self.IsSubproject))
        if self.IsSubprojectReadOnly is not None:
            showIndent(outfile, level)
            outfile.write('IsSubprojectReadOnly=%s,\n' % quote_python(self.IsSubprojectReadOnly))
        if self.SubprojectName is not None:
            showIndent(outfile, level)
            outfile.write('SubprojectName=%s,\n' % quote_python(self.SubprojectName))
        if self.ExternalTask is not None:
            showIndent(outfile, level)
            outfile.write('ExternalTask=%s,\n' % quote_python(self.ExternalTask))
        if self.ExternalTaskProject is not None:
            showIndent(outfile, level)
            outfile.write('ExternalTaskProject=%s,\n' % quote_python(self.ExternalTaskProject))
        if self.EarlyStart is not None:
            showIndent(outfile, level)
            outfile.write('EarlyStart=%s,\n' % quote_python(self.EarlyStart))
        if self.EarlyFinish is not None:
            showIndent(outfile, level)
            outfile.write('EarlyFinish=%s,\n' % quote_python(self.EarlyFinish))
        if self.LateStart is not None:
            showIndent(outfile, level)
            outfile.write('LateStart=%s,\n' % quote_python(self.LateStart))
        if self.LateFinish is not None:
            showIndent(outfile, level)
            outfile.write('LateFinish=%s,\n' % quote_python(self.LateFinish))
        if self.StartVariance is not None:
            showIndent(outfile, level)
            outfile.write('StartVariance=%s,\n' % quote_python(self.StartVariance))
        if self.FinishVariance is not None:
            showIndent(outfile, level)
            outfile.write('FinishVariance=%s,\n' % quote_python(self.FinishVariance))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('WorkVariance=%s,\n' % quote_python(self.WorkVariance))
        if self.FreeSlack is not None:
            showIndent(outfile, level)
            outfile.write('FreeSlack=%s,\n' % quote_python(self.FreeSlack))
        if self.TotalSlack is not None:
            showIndent(outfile, level)
            outfile.write('TotalSlack=%s,\n' % quote_python(self.TotalSlack))
        if self.FixedCost is not None:
            showIndent(outfile, level)
            outfile.write('FixedCost=%s,\n' % quote_python(self.FixedCost))
        if self.FixedCostAccrual is not None:
            showIndent(outfile, level)
            outfile.write('FixedCostAccrual=%s,\n' % quote_python(self.FixedCostAccrual))
        if self.PercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('PercentComplete=%s,\n' % quote_python(self.PercentComplete))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('PercentWorkComplete=%s,\n' % quote_python(self.PercentWorkComplete))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('Cost=%s,\n' % quote_python(self.Cost))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeCost=%s,\n' % quote_python(self.OvertimeCost))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeWork=%s,\n' % quote_python(self.OvertimeWork))
        if self.ActualStart is not None:
            showIndent(outfile, level)
            outfile.write('ActualStart=%s,\n' % quote_python(self.ActualStart))
        if self.ActualFinish is not None:
            showIndent(outfile, level)
            outfile.write('ActualFinish=%s,\n' % quote_python(self.ActualFinish))
        if self.ActualDuration is not None:
            showIndent(outfile, level)
            outfile.write('ActualDuration=%s,\n' % quote_python(self.ActualDuration))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualCost=%s,\n' % quote_python(self.ActualCost))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeCost=%s,\n' % quote_python(self.ActualOvertimeCost))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualWork=%s,\n' % quote_python(self.ActualWork))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWork=%s,\n' % quote_python(self.ActualOvertimeWork))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('RegularWork=%s,\n' % quote_python(self.RegularWork))
        if self.RemainingDuration is not None:
            showIndent(outfile, level)
            outfile.write('RemainingDuration=%s,\n' % quote_python(self.RemainingDuration))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingCost=%s,\n' % quote_python(self.RemainingCost))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingWork=%s,\n' % quote_python(self.RemainingWork))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeCost=%s,\n' % quote_python(self.RemainingOvertimeCost))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeWork=%s,\n' % quote_python(self.RemainingOvertimeWork))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('ACWP=%s,\n' % quote_python(self.ACWP))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('CV=%s,\n' % quote_python(self.CV))
        if self.ConstraintType is not None:
            showIndent(outfile, level)
            outfile.write('ConstraintType=%s,\n' % quote_python(self.ConstraintType))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('CalendarUID=%s,\n' % quote_python(self.CalendarUID))
        if self.ConstraintDate is not None:
            showIndent(outfile, level)
            outfile.write('ConstraintDate=%s,\n' % quote_python(self.ConstraintDate))
        if self.Deadline is not None:
            showIndent(outfile, level)
            outfile.write('Deadline=%s,\n' % quote_python(self.Deadline))
        if self.LevelAssignments is not None:
            showIndent(outfile, level)
            outfile.write('LevelAssignments=%s,\n' % quote_python(self.LevelAssignments))
        if self.LevelingCanSplit is not None:
            showIndent(outfile, level)
            outfile.write('LevelingCanSplit=%s,\n' % quote_python(self.LevelingCanSplit))
        if self.LevelingDelay is not None:
            showIndent(outfile, level)
            outfile.write('LevelingDelay=%s,\n' % quote_python(self.LevelingDelay))
        if self.LevelingDelayFormat is not None:
            showIndent(outfile, level)
            outfile.write('LevelingDelayFormat=%s,\n' % quote_python(self.LevelingDelayFormat))
        if self.PreLeveledStart is not None:
            showIndent(outfile, level)
            outfile.write('PreLeveledStart=%s,\n' % quote_python(self.PreLeveledStart))
        if self.PreLeveledFinish is not None:
            showIndent(outfile, level)
            outfile.write('PreLeveledFinish=%s,\n' % quote_python(self.PreLeveledFinish))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('Hyperlink=%s,\n' % quote_python(self.Hyperlink))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkAddress=%s,\n' % quote_python(self.HyperlinkAddress))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkSubAddress=%s,\n' % quote_python(self.HyperlinkSubAddress))
        if self.IgnoreResourceCalendar is not None:
            showIndent(outfile, level)
            outfile.write('IgnoreResourceCalendar=%s,\n' % quote_python(self.IgnoreResourceCalendar))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('Notes=%s,\n' % quote_python(self.Notes))
        if self.HideBar is not None:
            showIndent(outfile, level)
            outfile.write('HideBar=%s,\n' % quote_python(self.HideBar))
        if self.Rollup is not None:
            showIndent(outfile, level)
            outfile.write('Rollup=%s,\n' % quote_python(self.Rollup))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('BCWS=%s,\n' % quote_python(self.BCWS))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('BCWP=%s,\n' % quote_python(self.BCWP))
        if self.PhysicalPercentComplete is not None:
            showIndent(outfile, level)
            outfile.write('PhysicalPercentComplete=%s,\n' % quote_python(self.PhysicalPercentComplete))
        if self.EarnedValueMethod is not None:
            showIndent(outfile, level)
            outfile.write('EarnedValueMethod=%s,\n' % quote_python(self.EarnedValueMethod))
        showIndent(outfile, level)
        outfile.write('PredecessorLink=[\n')
        level += 1
        for PredecessorLink_ in self.PredecessorLink:
            showIndent(outfile, level)
            outfile.write('model_.PredecessorLink(\n')
            PredecessorLink_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualWorkProtected=%s,\n' % quote_python(self.ActualWorkProtected))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWorkProtected=%s,\n' % quote_python(self.ActualOvertimeWorkProtected))
        showIndent(outfile, level)
        outfile.write('ExtendedAttribute=[\n')
        level += 1
        for ExtendedAttribute_ in self.ExtendedAttribute:
            showIndent(outfile, level)
            outfile.write('model_.ExtendedAttribute(\n')
            ExtendedAttribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Baseline=[\n')
        level += 1
        for Baseline_ in self.Baseline:
            showIndent(outfile, level)
            outfile.write('model_.Baseline(\n')
            Baseline_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('OutlineCode=[\n')
        level += 1
        for OutlineCode_ in self.OutlineCode:
            showIndent(outfile, level)
            outfile.write('model_.OutlineCode(\n')
            OutlineCode_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('TimephasedData=[\n')
        level += 1
        for TimephasedData_ in self.TimephasedData:
            showIndent(outfile, level)
            outfile.write('model_.TimephasedDataType(\n')
            TimephasedData_.exportLiteral(outfile, level, name_='TimephasedDataType')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ID':
            ID_ = ''
            for text__content_ in child_.childNodes:
                ID_ += text__content_.nodeValue
            self.ID = ID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Name':
            Name_ = ''
            for text__content_ in child_.childNodes:
                Name_ += text__content_.nodeValue
            self.Name = Name_
            self.validate_Name(self.Name)    # validate type Name
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsNull':
            IsNull_ = ''
            for text__content_ in child_.childNodes:
                IsNull_ += text__content_.nodeValue
            self.IsNull = IsNull_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CreateDate':
            CreateDate_ = ''
            for text__content_ in child_.childNodes:
                CreateDate_ += text__content_.nodeValue
            self.CreateDate = CreateDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Contact':
            Contact_ = ''
            for text__content_ in child_.childNodes:
                Contact_ += text__content_.nodeValue
            self.Contact = Contact_
            self.validate_Contact(self.Contact)    # validate type Contact
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WBS':
            WBS_ = ''
            for text__content_ in child_.childNodes:
                WBS_ += text__content_.nodeValue
            self.WBS = WBS_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WBSLevel':
            WBSLevel_ = ''
            for text__content_ in child_.childNodes:
                WBSLevel_ += text__content_.nodeValue
            self.WBSLevel = WBSLevel_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineNumber':
            OutlineNumber_ = ''
            for text__content_ in child_.childNodes:
                OutlineNumber_ += text__content_.nodeValue
            self.OutlineNumber = OutlineNumber_
            self.validate_OutlineNumber(self.OutlineNumber)    # validate type OutlineNumber
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineLevel':
            OutlineLevel_ = ''
            for text__content_ in child_.childNodes:
                OutlineLevel_ += text__content_.nodeValue
            self.OutlineLevel = OutlineLevel_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Priority':
            Priority_ = ''
            for text__content_ in child_.childNodes:
                Priority_ += text__content_.nodeValue
            self.Priority = Priority_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Start':
            Start_ = ''
            for text__content_ in child_.childNodes:
                Start_ += text__content_.nodeValue
            self.Start = Start_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Finish':
            Finish_ = ''
            for text__content_ in child_.childNodes:
                Finish_ += text__content_.nodeValue
            self.Finish = Finish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Duration':
            Duration_ = ''
            for text__content_ in child_.childNodes:
                Duration_ += text__content_.nodeValue
            self.Duration = Duration_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DurationFormat':
            DurationFormat_ = ''
            for text__content_ in child_.childNodes:
                DurationFormat_ += text__content_.nodeValue
            self.DurationFormat = DurationFormat_
            self.validate_DurationFormat(self.DurationFormat)    # validate type DurationFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Work':
            Work_ = ''
            for text__content_ in child_.childNodes:
                Work_ += text__content_.nodeValue
            self.Work = Work_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Stop':
            Stop_ = ''
            for text__content_ in child_.childNodes:
                Stop_ += text__content_.nodeValue
            self.Stop = Stop_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Resume':
            Resume_ = ''
            for text__content_ in child_.childNodes:
                Resume_ += text__content_.nodeValue
            self.Resume = Resume_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ResumeValid':
            ResumeValid_ = ''
            for text__content_ in child_.childNodes:
                ResumeValid_ += text__content_.nodeValue
            self.ResumeValid = ResumeValid_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EffortDriven':
            EffortDriven_ = ''
            for text__content_ in child_.childNodes:
                EffortDriven_ += text__content_.nodeValue
            self.EffortDriven = EffortDriven_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Recurring':
            Recurring_ = ''
            for text__content_ in child_.childNodes:
                Recurring_ += text__content_.nodeValue
            self.Recurring = Recurring_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OverAllocated':
            OverAllocated_ = ''
            for text__content_ in child_.childNodes:
                OverAllocated_ += text__content_.nodeValue
            self.OverAllocated = OverAllocated_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Estimated':
            Estimated_ = ''
            for text__content_ in child_.childNodes:
                Estimated_ += text__content_.nodeValue
            self.Estimated = Estimated_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Milestone':
            Milestone_ = ''
            for text__content_ in child_.childNodes:
                Milestone_ += text__content_.nodeValue
            self.Milestone = Milestone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Summary':
            Summary_ = ''
            for text__content_ in child_.childNodes:
                Summary_ += text__content_.nodeValue
            self.Summary = Summary_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Critical':
            Critical_ = ''
            for text__content_ in child_.childNodes:
                Critical_ += text__content_.nodeValue
            self.Critical = Critical_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsSubproject':
            IsSubproject_ = ''
            for text__content_ in child_.childNodes:
                IsSubproject_ += text__content_.nodeValue
            self.IsSubproject = IsSubproject_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsSubprojectReadOnly':
            IsSubprojectReadOnly_ = ''
            for text__content_ in child_.childNodes:
                IsSubprojectReadOnly_ += text__content_.nodeValue
            self.IsSubprojectReadOnly = IsSubprojectReadOnly_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'SubprojectName':
            SubprojectName_ = ''
            for text__content_ in child_.childNodes:
                SubprojectName_ += text__content_.nodeValue
            self.SubprojectName = SubprojectName_
            self.validate_SubprojectName(self.SubprojectName)    # validate type SubprojectName
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExternalTask':
            ExternalTask_ = ''
            for text__content_ in child_.childNodes:
                ExternalTask_ += text__content_.nodeValue
            self.ExternalTask = ExternalTask_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExternalTaskProject':
            ExternalTaskProject_ = ''
            for text__content_ in child_.childNodes:
                ExternalTaskProject_ += text__content_.nodeValue
            self.ExternalTaskProject = ExternalTaskProject_
            self.validate_ExternalTaskProject(self.ExternalTaskProject)    # validate type ExternalTaskProject
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EarlyStart':
            EarlyStart_ = ''
            for text__content_ in child_.childNodes:
                EarlyStart_ += text__content_.nodeValue
            self.EarlyStart = EarlyStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EarlyFinish':
            EarlyFinish_ = ''
            for text__content_ in child_.childNodes:
                EarlyFinish_ += text__content_.nodeValue
            self.EarlyFinish = EarlyFinish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LateStart':
            LateStart_ = ''
            for text__content_ in child_.childNodes:
                LateStart_ += text__content_.nodeValue
            self.LateStart = LateStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LateFinish':
            LateFinish_ = ''
            for text__content_ in child_.childNodes:
                LateFinish_ += text__content_.nodeValue
            self.LateFinish = LateFinish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StartVariance':
            StartVariance_ = ''
            for text__content_ in child_.childNodes:
                StartVariance_ += text__content_.nodeValue
            self.StartVariance = StartVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FinishVariance':
            FinishVariance_ = ''
            for text__content_ in child_.childNodes:
                FinishVariance_ += text__content_.nodeValue
            self.FinishVariance = FinishVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkVariance':
            WorkVariance_ = ''
            for text__content_ in child_.childNodes:
                WorkVariance_ += text__content_.nodeValue
            self.WorkVariance = WorkVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FreeSlack':
            FreeSlack_ = ''
            for text__content_ in child_.childNodes:
                FreeSlack_ += text__content_.nodeValue
            self.FreeSlack = FreeSlack_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TotalSlack':
            TotalSlack_ = ''
            for text__content_ in child_.childNodes:
                TotalSlack_ += text__content_.nodeValue
            self.TotalSlack = TotalSlack_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FixedCost':
            FixedCost_ = ''
            for text__content_ in child_.childNodes:
                FixedCost_ += text__content_.nodeValue
            self.FixedCost = FixedCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FixedCostAccrual':
            FixedCostAccrual_ = ''
            for text__content_ in child_.childNodes:
                FixedCostAccrual_ += text__content_.nodeValue
            self.FixedCostAccrual = FixedCostAccrual_
            self.validate_FixedCostAccrual(self.FixedCostAccrual)    # validate type FixedCostAccrual
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PercentComplete':
            PercentComplete_ = ''
            for text__content_ in child_.childNodes:
                PercentComplete_ += text__content_.nodeValue
            self.PercentComplete = PercentComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PercentWorkComplete':
            PercentWorkComplete_ = ''
            for text__content_ in child_.childNodes:
                PercentWorkComplete_ += text__content_.nodeValue
            self.PercentWorkComplete = PercentWorkComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Cost':
            Cost_ = ''
            for text__content_ in child_.childNodes:
                Cost_ += text__content_.nodeValue
            self.Cost = Cost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeCost':
            OvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                OvertimeCost_ += text__content_.nodeValue
            self.OvertimeCost = OvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeWork':
            OvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                OvertimeWork_ += text__content_.nodeValue
            self.OvertimeWork = OvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualStart':
            ActualStart_ = ''
            for text__content_ in child_.childNodes:
                ActualStart_ += text__content_.nodeValue
            self.ActualStart = ActualStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualFinish':
            ActualFinish_ = ''
            for text__content_ in child_.childNodes:
                ActualFinish_ += text__content_.nodeValue
            self.ActualFinish = ActualFinish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualDuration':
            ActualDuration_ = ''
            for text__content_ in child_.childNodes:
                ActualDuration_ += text__content_.nodeValue
            self.ActualDuration = ActualDuration_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualCost':
            ActualCost_ = ''
            for text__content_ in child_.childNodes:
                ActualCost_ += text__content_.nodeValue
            self.ActualCost = ActualCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeCost':
            ActualOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeCost_ += text__content_.nodeValue
            self.ActualOvertimeCost = ActualOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWork':
            ActualWork_ = ''
            for text__content_ in child_.childNodes:
                ActualWork_ += text__content_.nodeValue
            self.ActualWork = ActualWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWork':
            ActualOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWork_ += text__content_.nodeValue
            self.ActualOvertimeWork = ActualOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RegularWork':
            RegularWork_ = ''
            for text__content_ in child_.childNodes:
                RegularWork_ += text__content_.nodeValue
            self.RegularWork = RegularWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingDuration':
            RemainingDuration_ = ''
            for text__content_ in child_.childNodes:
                RemainingDuration_ += text__content_.nodeValue
            self.RemainingDuration = RemainingDuration_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingCost':
            RemainingCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingCost_ += text__content_.nodeValue
            self.RemainingCost = RemainingCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingWork':
            RemainingWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingWork_ += text__content_.nodeValue
            self.RemainingWork = RemainingWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeCost':
            RemainingOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeCost_ += text__content_.nodeValue
            self.RemainingOvertimeCost = RemainingOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeWork':
            RemainingOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeWork_ += text__content_.nodeValue
            self.RemainingOvertimeWork = RemainingOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ACWP':
            ACWP_ = ''
            for text__content_ in child_.childNodes:
                ACWP_ += text__content_.nodeValue
            self.ACWP = ACWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CV':
            CV_ = ''
            for text__content_ in child_.childNodes:
                CV_ += text__content_.nodeValue
            self.CV = CV_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ConstraintType':
            ConstraintType_ = ''
            for text__content_ in child_.childNodes:
                ConstraintType_ += text__content_.nodeValue
            self.ConstraintType = ConstraintType_
            self.validate_ConstraintType(self.ConstraintType)    # validate type ConstraintType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CalendarUID':
            CalendarUID_ = ''
            for text__content_ in child_.childNodes:
                CalendarUID_ += text__content_.nodeValue
            self.CalendarUID = CalendarUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ConstraintDate':
            ConstraintDate_ = ''
            for text__content_ in child_.childNodes:
                ConstraintDate_ += text__content_.nodeValue
            self.ConstraintDate = ConstraintDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Deadline':
            Deadline_ = ''
            for text__content_ in child_.childNodes:
                Deadline_ += text__content_.nodeValue
            self.Deadline = Deadline_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelAssignments':
            LevelAssignments_ = ''
            for text__content_ in child_.childNodes:
                LevelAssignments_ += text__content_.nodeValue
            self.LevelAssignments = LevelAssignments_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelingCanSplit':
            LevelingCanSplit_ = ''
            for text__content_ in child_.childNodes:
                LevelingCanSplit_ += text__content_.nodeValue
            self.LevelingCanSplit = LevelingCanSplit_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelingDelay':
            LevelingDelay_ = ''
            for text__content_ in child_.childNodes:
                LevelingDelay_ += text__content_.nodeValue
            self.LevelingDelay = LevelingDelay_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelingDelayFormat':
            LevelingDelayFormat_ = ''
            for text__content_ in child_.childNodes:
                LevelingDelayFormat_ += text__content_.nodeValue
            self.LevelingDelayFormat = LevelingDelayFormat_
            self.validate_LevelingDelayFormat(self.LevelingDelayFormat)    # validate type LevelingDelayFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PreLeveledStart':
            PreLeveledStart_ = ''
            for text__content_ in child_.childNodes:
                PreLeveledStart_ += text__content_.nodeValue
            self.PreLeveledStart = PreLeveledStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PreLeveledFinish':
            PreLeveledFinish_ = ''
            for text__content_ in child_.childNodes:
                PreLeveledFinish_ += text__content_.nodeValue
            self.PreLeveledFinish = PreLeveledFinish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Hyperlink':
            Hyperlink_ = ''
            for text__content_ in child_.childNodes:
                Hyperlink_ += text__content_.nodeValue
            self.Hyperlink = Hyperlink_
            self.validate_Hyperlink(self.Hyperlink)    # validate type Hyperlink
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkAddress':
            HyperlinkAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkAddress_ += text__content_.nodeValue
            self.HyperlinkAddress = HyperlinkAddress_
            self.validate_HyperlinkAddress(self.HyperlinkAddress)    # validate type HyperlinkAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkSubAddress':
            HyperlinkSubAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkSubAddress_ += text__content_.nodeValue
            self.HyperlinkSubAddress = HyperlinkSubAddress_
            self.validate_HyperlinkSubAddress(self.HyperlinkSubAddress)    # validate type HyperlinkSubAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IgnoreResourceCalendar':
            IgnoreResourceCalendar_ = ''
            for text__content_ in child_.childNodes:
                IgnoreResourceCalendar_ += text__content_.nodeValue
            self.IgnoreResourceCalendar = IgnoreResourceCalendar_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Notes':
            Notes_ = ''
            for text__content_ in child_.childNodes:
                Notes_ += text__content_.nodeValue
            self.Notes = Notes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HideBar':
            HideBar_ = ''
            for text__content_ in child_.childNodes:
                HideBar_ += text__content_.nodeValue
            self.HideBar = HideBar_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Rollup':
            Rollup_ = ''
            for text__content_ in child_.childNodes:
                Rollup_ += text__content_.nodeValue
            self.Rollup = Rollup_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWS':
            BCWS_ = ''
            for text__content_ in child_.childNodes:
                BCWS_ += text__content_.nodeValue
            self.BCWS = BCWS_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWP':
            BCWP_ = ''
            for text__content_ in child_.childNodes:
                BCWP_ += text__content_.nodeValue
            self.BCWP = BCWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PhysicalPercentComplete':
            PhysicalPercentComplete_ = ''
            for text__content_ in child_.childNodes:
                PhysicalPercentComplete_ += text__content_.nodeValue
            self.PhysicalPercentComplete = PhysicalPercentComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EarnedValueMethod':
            EarnedValueMethod_ = ''
            for text__content_ in child_.childNodes:
                EarnedValueMethod_ += text__content_.nodeValue
            self.EarnedValueMethod = EarnedValueMethod_
            self.validate_EarnedValueMethod(self.EarnedValueMethod)    # validate type EarnedValueMethod
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PredecessorLink':
            obj_ = PredecessorLink.factory()
            obj_.build(child_)
            self.PredecessorLink.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWorkProtected':
            ActualWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualWorkProtected_ += text__content_.nodeValue
            self.ActualWorkProtected = ActualWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWorkProtected':
            ActualOvertimeWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWorkProtected_ += text__content_.nodeValue
            self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedAttribute':
            obj_ = ExtendedAttributeInstance.factory()
            obj_.build(child_)
            self.ExtendedAttribute.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Baseline':
            obj_ = Baseline.factory()
            obj_.build(child_)
            self.Baseline.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineCode':
            obj_ = OutlineCode.factory()
            obj_.build(child_)
            self.OutlineCode.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TimephasedData':
            obj_ = TimephasedDataType.factory()
            obj_.build(child_)
            self.TimephasedData.append(obj_)
# end class Task


class Contact(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Contact.subclass:
            return Contact.subclass(*args_, **kwargs_)
        else:
            return Contact(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Contact', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Contact')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Contact'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Contact'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Contact'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Contact


class OutlineNumber(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if OutlineNumber.subclass:
            return OutlineNumber.subclass(*args_, **kwargs_)
        else:
            return OutlineNumber(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='OutlineNumber', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='OutlineNumber')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='OutlineNumber'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='OutlineNumber'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='OutlineNumber'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class OutlineNumber


class SubprojectName(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if SubprojectName.subclass:
            return SubprojectName.subclass(*args_, **kwargs_)
        else:
            return SubprojectName(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='SubprojectName', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='SubprojectName')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='SubprojectName'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='SubprojectName'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='SubprojectName'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class SubprojectName


class ExternalTaskProject(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ExternalTaskProject.subclass:
            return ExternalTaskProject.subclass(*args_, **kwargs_)
        else:
            return ExternalTaskProject(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ExternalTaskProject', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ExternalTaskProject')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ExternalTaskProject'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ExternalTaskProject'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ExternalTaskProject'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class ExternalTaskProject


class FixedCostAccrual(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if FixedCostAccrual.subclass:
            return FixedCostAccrual.subclass(*args_, **kwargs_)
        else:
            return FixedCostAccrual(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='FixedCostAccrual', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='FixedCostAccrual')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='FixedCostAccrual'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='FixedCostAccrual'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='FixedCostAccrual'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class FixedCostAccrual


class ConstraintType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ConstraintType.subclass:
            return ConstraintType.subclass(*args_, **kwargs_)
        else:
            return ConstraintType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ConstraintType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ConstraintType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ConstraintType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ConstraintType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ConstraintType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class ConstraintType


class LevelingDelayFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if LevelingDelayFormat.subclass:
            return LevelingDelayFormat.subclass(*args_, **kwargs_)
        else:
            return LevelingDelayFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='LevelingDelayFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='LevelingDelayFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='LevelingDelayFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='LevelingDelayFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='LevelingDelayFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class LevelingDelayFormat


class Hyperlink(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Hyperlink.subclass:
            return Hyperlink.subclass(*args_, **kwargs_)
        else:
            return Hyperlink(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Hyperlink', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Hyperlink')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Hyperlink'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Hyperlink'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Hyperlink'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Hyperlink


class HyperlinkAddress(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if HyperlinkAddress.subclass:
            return HyperlinkAddress.subclass(*args_, **kwargs_)
        else:
            return HyperlinkAddress(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='HyperlinkAddress', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='HyperlinkAddress')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='HyperlinkAddress'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='HyperlinkAddress'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='HyperlinkAddress'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class HyperlinkAddress


class HyperlinkSubAddress(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if HyperlinkSubAddress.subclass:
            return HyperlinkSubAddress.subclass(*args_, **kwargs_)
        else:
            return HyperlinkSubAddress(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='HyperlinkSubAddress', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='HyperlinkSubAddress')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='HyperlinkSubAddress'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='HyperlinkSubAddress'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='HyperlinkSubAddress'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class HyperlinkSubAddress


class PredecessorLink(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, PredecessorUID=None, Type=None, CrossProject=None, CrossProjectName=None, LinkLag=None, LagFormat=None):
        self.PredecessorUID = PredecessorUID
        self.Type = Type
        self.CrossProject = CrossProject
        self.CrossProjectName = CrossProjectName
        self.LinkLag = LinkLag
        self.LagFormat = LagFormat
    def factory(*args_, **kwargs_):
        if PredecessorLink.subclass:
            return PredecessorLink.subclass(*args_, **kwargs_)
        else:
            return PredecessorLink(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_PredecessorUID(self): return self.PredecessorUID
    def set_PredecessorUID(self, PredecessorUID): self.PredecessorUID = PredecessorUID
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_CrossProject(self): return self.CrossProject
    def set_CrossProject(self, CrossProject): self.CrossProject = CrossProject
    def get_CrossProjectName(self): return self.CrossProjectName
    def set_CrossProjectName(self, CrossProjectName): self.CrossProjectName = CrossProjectName
    def get_LinkLag(self): return self.LinkLag
    def set_LinkLag(self, LinkLag): self.LinkLag = LinkLag
    def get_LagFormat(self): return self.LagFormat
    def set_LagFormat(self, LagFormat): self.LagFormat = LagFormat
    def validate_LagFormat(self, value):
        # Validate type LagFormat, a restriction on xsd:integer.
        pass
    def export(self, outfile, level, namespace_='', name_='PredecessorLink', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='PredecessorLink')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='PredecessorLink'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='PredecessorLink'):
        if self.PredecessorUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sPredecessorUID>%s</%sPredecessorUID>\n' % (namespace_, self.format_string(quote_xml(self.PredecessorUID), input_name='PredecessorUID'), namespace_))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.CrossProject is not None:
            showIndent(outfile, level)
            outfile.write('<%sCrossProject>%s</%sCrossProject>\n' % (namespace_, self.format_string(quote_xml(self.CrossProject), input_name='CrossProject'), namespace_))
        if self.CrossProjectName is not None:
            showIndent(outfile, level)
            outfile.write('<%sCrossProjectName>%s</%sCrossProjectName>\n' % (namespace_, self.format_string(quote_xml(self.CrossProjectName), input_name='CrossProjectName'), namespace_))
        if self.LinkLag is not None:
            showIndent(outfile, level)
            outfile.write('<%sLinkLag>%s</%sLinkLag>\n' % (namespace_, self.format_string(quote_xml(self.LinkLag), input_name='LinkLag'), namespace_))
        if self.LagFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sLagFormat>%s</%sLagFormat>\n' % (namespace_, self.format_string(quote_xml(self.LagFormat), input_name='LagFormat'), namespace_))
    def hasContent_(self):
        if (
            self.PredecessorUID is not None or
            self.Type is not None or
            self.CrossProject is not None or
            self.CrossProjectName is not None or
            self.LinkLag is not None or
            self.LagFormat is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='PredecessorLink'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.PredecessorUID is not None:
            showIndent(outfile, level)
            outfile.write('PredecessorUID=%s,\n' % quote_python(self.PredecessorUID))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.CrossProject is not None:
            showIndent(outfile, level)
            outfile.write('CrossProject=%s,\n' % quote_python(self.CrossProject))
        if self.CrossProjectName is not None:
            showIndent(outfile, level)
            outfile.write('CrossProjectName=%s,\n' % quote_python(self.CrossProjectName))
        if self.LinkLag is not None:
            showIndent(outfile, level)
            outfile.write('LinkLag=%s,\n' % quote_python(self.LinkLag))
        if self.LagFormat is not None:
            showIndent(outfile, level)
            outfile.write('LagFormat=%s,\n' % quote_python(self.LagFormat))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PredecessorUID':
            PredecessorUID_ = ''
            for text__content_ in child_.childNodes:
                PredecessorUID_ += text__content_.nodeValue
            self.PredecessorUID = PredecessorUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CrossProject':
            CrossProject_ = ''
            for text__content_ in child_.childNodes:
                CrossProject_ += text__content_.nodeValue
            self.CrossProject = CrossProject_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CrossProjectName':
            CrossProjectName_ = ''
            for text__content_ in child_.childNodes:
                CrossProjectName_ += text__content_.nodeValue
            self.CrossProjectName = CrossProjectName_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LinkLag':
            LinkLag_ = ''
            for text__content_ in child_.childNodes:
                LinkLag_ += text__content_.nodeValue
            self.LinkLag = LinkLag_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LagFormat':
            LagFormat_ = ''
            for text__content_ in child_.childNodes:
                LagFormat_ += text__content_.nodeValue
            self.LagFormat = LagFormat_
            self.validate_LagFormat(self.LagFormat)    # validate type LagFormat
# end class PredecessorLink


class LagFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if LagFormat.subclass:
            return LagFormat.subclass(*args_, **kwargs_)
        else:
            return LagFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='LagFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='LagFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='LagFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='LagFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='LagFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class LagFormat


class Baseline(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, TimephasedData=None, Number=None, Interim='false', Start=None, Finish=None, Duration=None, DurationFormat=None, EstimatedDuration=None, Work=None, Cost=None, BCWS=None, BCWP=None):
        if TimephasedData is None:
            self.TimephasedData = []
        else:
            self.TimephasedData = TimephasedData
        self.Number = Number
        self.Interim = Interim
        self.Start = Start
        self.Finish = Finish
        self.Duration = Duration
        self.DurationFormat = DurationFormat
        self.EstimatedDuration = EstimatedDuration
        self.Work = Work
        self.Cost = Cost
        self.BCWS = BCWS
        self.BCWP = BCWP
    def factory(*args_, **kwargs_):
        if Baseline.subclass:
            return Baseline.subclass(*args_, **kwargs_)
        else:
            return Baseline(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_TimephasedData(self): return self.TimephasedData
    def set_TimephasedData(self, TimephasedData): self.TimephasedData = TimephasedData
    def add_TimephasedData(self, value): self.TimephasedData.append(value)
    def insert_TimephasedData(self, index, value): self.TimephasedData[index] = value
    def get_Number(self): return self.Number
    def set_Number(self, Number): self.Number = Number
    def get_Interim(self): return self.Interim
    def set_Interim(self, Interim): self.Interim = Interim
    def get_Start(self): return self.Start
    def set_Start(self, Start): self.Start = Start
    def get_Finish(self): return self.Finish
    def set_Finish(self, Finish): self.Finish = Finish
    def get_Duration(self): return self.Duration
    def set_Duration(self, Duration): self.Duration = Duration
    def get_DurationFormat(self): return self.DurationFormat
    def set_DurationFormat(self, DurationFormat): self.DurationFormat = DurationFormat
    def validate_DurationFormat(self, value):
        # Validate type DurationFormat, a restriction on xsd:integer.
        pass
    def get_EstimatedDuration(self): return self.EstimatedDuration
    def set_EstimatedDuration(self, EstimatedDuration): self.EstimatedDuration = EstimatedDuration
    def get_Work(self): return self.Work
    def set_Work(self, Work): self.Work = Work
    def get_Cost(self): return self.Cost
    def set_Cost(self, Cost): self.Cost = Cost
    def get_BCWS(self): return self.BCWS
    def set_BCWS(self, BCWS): self.BCWS = BCWS
    def get_BCWP(self): return self.BCWP
    def set_BCWP(self, BCWP): self.BCWP = BCWP
    def export(self, outfile, level, namespace_='', name_='Baseline', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Baseline')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Baseline'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Baseline'):
        for TimephasedData_ in self.TimephasedData:
            TimephasedData_.export(outfile, level, namespace_, name_='TimephasedData')
        if self.Number is not None:
            showIndent(outfile, level)
            outfile.write('<%sNumber>%s</%sNumber>\n' % (namespace_, self.format_string(quote_xml(self.Number), input_name='Number'), namespace_))
        if self.Interim is not None:
            showIndent(outfile, level)
            outfile.write('<%sInterim>%s</%sInterim>\n' % (namespace_, self.format_string(quote_xml(self.Interim), input_name='Interim'), namespace_))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('<%sStart>%s</%sStart>\n' % (namespace_, self.format_string(quote_xml(self.Start), input_name='Start'), namespace_))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinish>%s</%sFinish>\n' % (namespace_, self.format_string(quote_xml(self.Finish), input_name='Finish'), namespace_))
        if self.Duration is not None:
            showIndent(outfile, level)
            outfile.write('<%sDuration>%s</%sDuration>\n' % (namespace_, self.format_string(quote_xml(self.Duration), input_name='Duration'), namespace_))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sDurationFormat>%s</%sDurationFormat>\n' % (namespace_, self.format_string(quote_xml(self.DurationFormat), input_name='DurationFormat'), namespace_))
        if self.EstimatedDuration is not None:
            showIndent(outfile, level)
            outfile.write('<%sEstimatedDuration>%s</%sEstimatedDuration>\n' % (namespace_, self.format_string(quote_xml(self.EstimatedDuration), input_name='EstimatedDuration'), namespace_))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('<%sWork>%s</%sWork>\n' % (namespace_, self.format_string(quote_xml(self.Work), input_name='Work'), namespace_))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('<%sCost>%s</%sCost>\n' % (namespace_, self.format_string(quote_xml(self.Cost), input_name='Cost'), namespace_))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWS>%s</%sBCWS>\n' % (namespace_, self.format_string(quote_xml(self.BCWS), input_name='BCWS'), namespace_))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWP>%s</%sBCWP>\n' % (namespace_, self.format_string(quote_xml(self.BCWP), input_name='BCWP'), namespace_))
    def hasContent_(self):
        if (
            self.TimephasedData or
            self.Number is not None or
            self.Interim is not None or
            self.Start is not None or
            self.Finish is not None or
            self.Duration is not None or
            self.DurationFormat is not None or
            self.EstimatedDuration is not None or
            self.Work is not None or
            self.Cost is not None or
            self.BCWS is not None or
            self.BCWP is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Baseline'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('TimephasedData=[\n')
        level += 1
        for TimephasedData_ in self.TimephasedData:
            showIndent(outfile, level)
            outfile.write('model_.TimephasedDataType(\n')
            TimephasedData_.exportLiteral(outfile, level, name_='TimephasedDataType')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.Number is not None:
            showIndent(outfile, level)
            outfile.write('Number=%s,\n' % quote_python(self.Number))
        if self.Interim is not None:
            showIndent(outfile, level)
            outfile.write('Interim=%s,\n' % quote_python(self.Interim))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('Start=%s,\n' % quote_python(self.Start))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('Finish=%s,\n' % quote_python(self.Finish))
        if self.Duration is not None:
            showIndent(outfile, level)
            outfile.write('Duration=%s,\n' % quote_python(self.Duration))
        if self.DurationFormat is not None:
            showIndent(outfile, level)
            outfile.write('DurationFormat=%s,\n' % quote_python(self.DurationFormat))
        if self.EstimatedDuration is not None:
            showIndent(outfile, level)
            outfile.write('EstimatedDuration=%s,\n' % quote_python(self.EstimatedDuration))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('Work=%s,\n' % quote_python(self.Work))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('Cost=%s,\n' % quote_python(self.Cost))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('BCWS=%s,\n' % quote_python(self.BCWS))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('BCWP=%s,\n' % quote_python(self.BCWP))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TimephasedData':
            obj_ = TimephasedDataType.factory()
            obj_.build(child_)
            self.TimephasedData.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Number':
            Number_ = ''
            for text__content_ in child_.childNodes:
                Number_ += text__content_.nodeValue
            self.Number = Number_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Interim':
            Interim_ = ''
            for text__content_ in child_.childNodes:
                Interim_ += text__content_.nodeValue
            self.Interim = Interim_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Start':
            Start_ = ''
            for text__content_ in child_.childNodes:
                Start_ += text__content_.nodeValue
            self.Start = Start_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Finish':
            Finish_ = ''
            for text__content_ in child_.childNodes:
                Finish_ += text__content_.nodeValue
            self.Finish = Finish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Duration':
            Duration_ = ''
            for text__content_ in child_.childNodes:
                Duration_ += text__content_.nodeValue
            self.Duration = Duration_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'DurationFormat':
            DurationFormat_ = ''
            for text__content_ in child_.childNodes:
                DurationFormat_ += text__content_.nodeValue
            self.DurationFormat = DurationFormat_
            self.validate_DurationFormat(self.DurationFormat)    # validate type DurationFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EstimatedDuration':
            EstimatedDuration_ = ''
            for text__content_ in child_.childNodes:
                EstimatedDuration_ += text__content_.nodeValue
            self.EstimatedDuration = EstimatedDuration_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Work':
            Work_ = ''
            for text__content_ in child_.childNodes:
                Work_ += text__content_.nodeValue
            self.Work = Work_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Cost':
            Cost_ = ''
            for text__content_ in child_.childNodes:
                Cost_ += text__content_.nodeValue
            self.Cost = Cost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWS':
            BCWS_ = ''
            for text__content_ in child_.childNodes:
                BCWS_ += text__content_.nodeValue
            self.BCWS = BCWS_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWP':
            BCWP_ = ''
            for text__content_ in child_.childNodes:
                BCWP_ += text__content_.nodeValue
            self.BCWP = BCWP_
# end class Baseline


class Resources(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Resource=None):
        if Resource is None:
            self.Resource = []
        else:
            self.Resource = Resource
    def factory(*args_, **kwargs_):
        if Resources.subclass:
            return Resources.subclass(*args_, **kwargs_)
        else:
            return Resources(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Resource(self): return self.Resource
    def set_Resource(self, Resource): self.Resource = Resource
    def add_Resource(self, value): self.Resource.append(value)
    def insert_Resource(self, index, value): self.Resource[index] = value
    def export(self, outfile, level, namespace_='', name_='Resources', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Resources')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Resources'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Resources'):
        for Resource_ in self.Resource:
            Resource_.export(outfile, level, namespace_, name_='Resource')
    def hasContent_(self):
        if (
            self.Resource
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Resources'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Resource=[\n')
        level += 1
        for Resource_ in self.Resource:
            showIndent(outfile, level)
            outfile.write('model_.Resource(\n')
            Resource_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Resource':
            obj_ = Resource.factory()
            obj_.build(child_)
            self.Resource.append(obj_)
# end class Resources


class Resource(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, UID=None, ID=None, Name=None, Type=None, IsNull=None, Initials=None, Phonetics=None, NTAccount=None, MaterialLabel=None, Code=None, Group=None, WorkGroup=None, EmailAddress=None, Hyperlink=None, HyperlinkAddress=None, HyperlinkSubAddress=None, MaxUnits='1.0', PeakUnits=None, OverAllocated=None, AvailableFrom=None, AvailableTo=None, Start=None, Finish=None, CanLevel=None, AccrueAt=None, Work=None, RegularWork=None, OvertimeWork=None, ActualWork=None, RemainingWork=None, ActualOvertimeWork=None, RemainingOvertimeWork=None, PercentWorkComplete=None, StandardRate=None, StandardRateFormat=None, Cost=None, OvertimeRate=None, OvertimeRateFormat=None, OvertimeCost=None, CostPerUse=None, ActualCost=None, ActualOvertimeCost=None, RemainingCost=None, RemainingOvertimeCost=None, WorkVariance=None, CostVariance=None, SV=None, CV=None, ACWP=None, CalendarUID=None, Notes=None, BCWS=None, BCWP=None, IsGeneric=None, IsInactive=None, IsEnterprise=None, BookingType=None, ActualWorkProtected=None, ActualOvertimeWorkProtected=None, ActiveDirectoryGUID=None, CreationDate=None, ExtendedAttribute=None, Baseline=None, OutlineCode=None, AvailabilityPeriods=None, Rates=None, TimephasedData=None):
        self.UID = UID
        self.ID = ID
        self.Name = Name
        self.Type = Type
        self.IsNull = IsNull
        self.Initials = Initials
        self.Phonetics = Phonetics
        self.NTAccount = NTAccount
        self.MaterialLabel = MaterialLabel
        self.Code = Code
        self.Group = Group
        self.WorkGroup = WorkGroup
        self.EmailAddress = EmailAddress
        self.Hyperlink = Hyperlink
        self.HyperlinkAddress = HyperlinkAddress
        self.HyperlinkSubAddress = HyperlinkSubAddress
        self.MaxUnits = MaxUnits
        self.PeakUnits = PeakUnits
        self.OverAllocated = OverAllocated
        self.AvailableFrom = AvailableFrom
        self.AvailableTo = AvailableTo
        self.Start = Start
        self.Finish = Finish
        self.CanLevel = CanLevel
        self.AccrueAt = AccrueAt
        self.Work = Work
        self.RegularWork = RegularWork
        self.OvertimeWork = OvertimeWork
        self.ActualWork = ActualWork
        self.RemainingWork = RemainingWork
        self.ActualOvertimeWork = ActualOvertimeWork
        self.RemainingOvertimeWork = RemainingOvertimeWork
        self.PercentWorkComplete = PercentWorkComplete
        self.StandardRate = StandardRate
        self.StandardRateFormat = StandardRateFormat
        self.Cost = Cost
        self.OvertimeRate = OvertimeRate
        self.OvertimeRateFormat = OvertimeRateFormat
        self.OvertimeCost = OvertimeCost
        self.CostPerUse = CostPerUse
        self.ActualCost = ActualCost
        self.ActualOvertimeCost = ActualOvertimeCost
        self.RemainingCost = RemainingCost
        self.RemainingOvertimeCost = RemainingOvertimeCost
        self.WorkVariance = WorkVariance
        self.CostVariance = CostVariance
        self.SV = SV
        self.CV = CV
        self.ACWP = ACWP
        self.CalendarUID = CalendarUID
        self.Notes = Notes
        self.BCWS = BCWS
        self.BCWP = BCWP
        self.IsGeneric = IsGeneric
        self.IsInactive = IsInactive
        self.IsEnterprise = IsEnterprise
        self.BookingType = BookingType
        self.ActualWorkProtected = ActualWorkProtected
        self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
        self.ActiveDirectoryGUID = ActiveDirectoryGUID
        self.CreationDate = CreationDate
        if ExtendedAttribute is None:
            self.ExtendedAttribute = []
        else:
            self.ExtendedAttribute = ExtendedAttribute
        if Baseline is None:
            self.Baseline = []
        else:
            self.Baseline = Baseline
        if OutlineCode is None:
            self.OutlineCode = []
        else:
            self.OutlineCode = OutlineCode
        self.AvailabilityPeriods = AvailabilityPeriods
        self.Rates = Rates
        if TimephasedData is None:
            self.TimephasedData = []
        else:
            self.TimephasedData = TimephasedData
    def factory(*args_, **kwargs_):
        if Resource.subclass:
            return Resource.subclass(*args_, **kwargs_)
        else:
            return Resource(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def get_ID(self): return self.ID
    def set_ID(self, ID): self.ID = ID
    def get_Name(self): return self.Name
    def set_Name(self, Name): self.Name = Name
    def validate_Name(self, value):
        # Validate type Name, a restriction on xsd:string.
        pass
    def get_Type(self): return self.Type
    def set_Type(self, Type): self.Type = Type
    def validate_Type(self, value):
        # Validate type Type, a restriction on xsd:integer.
        pass
    def get_IsNull(self): return self.IsNull
    def set_IsNull(self, IsNull): self.IsNull = IsNull
    def get_Initials(self): return self.Initials
    def set_Initials(self, Initials): self.Initials = Initials
    def validate_Initials(self, value):
        # Validate type Initials, a restriction on xsd:string.
        pass
    def get_Phonetics(self): return self.Phonetics
    def set_Phonetics(self, Phonetics): self.Phonetics = Phonetics
    def validate_Phonetics(self, value):
        # Validate type Phonetics, a restriction on xsd:string.
        pass
    def get_NTAccount(self): return self.NTAccount
    def set_NTAccount(self, NTAccount): self.NTAccount = NTAccount
    def validate_NTAccount(self, value):
        # Validate type NTAccount, a restriction on xsd:string.
        pass
    def get_MaterialLabel(self): return self.MaterialLabel
    def set_MaterialLabel(self, MaterialLabel): self.MaterialLabel = MaterialLabel
    def validate_MaterialLabel(self, value):
        # Validate type MaterialLabel, a restriction on xsd:string.
        pass
    def get_Code(self): return self.Code
    def set_Code(self, Code): self.Code = Code
    def validate_Code(self, value):
        # Validate type Code, a restriction on xsd:string.
        pass
    def get_Group(self): return self.Group
    def set_Group(self, Group): self.Group = Group
    def validate_Group(self, value):
        # Validate type Group, a restriction on xsd:string.
        pass
    def get_WorkGroup(self): return self.WorkGroup
    def set_WorkGroup(self, WorkGroup): self.WorkGroup = WorkGroup
    def validate_WorkGroup(self, value):
        # Validate type WorkGroup, a restriction on xsd:integer.
        pass
    def get_EmailAddress(self): return self.EmailAddress
    def set_EmailAddress(self, EmailAddress): self.EmailAddress = EmailAddress
    def validate_EmailAddress(self, value):
        # Validate type EmailAddress, a restriction on xsd:string.
        pass
    def get_Hyperlink(self): return self.Hyperlink
    def set_Hyperlink(self, Hyperlink): self.Hyperlink = Hyperlink
    def validate_Hyperlink(self, value):
        # Validate type Hyperlink, a restriction on xsd:string.
        pass
    def get_HyperlinkAddress(self): return self.HyperlinkAddress
    def set_HyperlinkAddress(self, HyperlinkAddress): self.HyperlinkAddress = HyperlinkAddress
    def validate_HyperlinkAddress(self, value):
        # Validate type HyperlinkAddress, a restriction on xsd:string.
        pass
    def get_HyperlinkSubAddress(self): return self.HyperlinkSubAddress
    def set_HyperlinkSubAddress(self, HyperlinkSubAddress): self.HyperlinkSubAddress = HyperlinkSubAddress
    def validate_HyperlinkSubAddress(self, value):
        # Validate type HyperlinkSubAddress, a restriction on xsd:string.
        pass
    def get_MaxUnits(self): return self.MaxUnits
    def set_MaxUnits(self, MaxUnits): self.MaxUnits = MaxUnits
    def get_PeakUnits(self): return self.PeakUnits
    def set_PeakUnits(self, PeakUnits): self.PeakUnits = PeakUnits
    def get_OverAllocated(self): return self.OverAllocated
    def set_OverAllocated(self, OverAllocated): self.OverAllocated = OverAllocated
    def get_AvailableFrom(self): return self.AvailableFrom
    def set_AvailableFrom(self, AvailableFrom): self.AvailableFrom = AvailableFrom
    def get_AvailableTo(self): return self.AvailableTo
    def set_AvailableTo(self, AvailableTo): self.AvailableTo = AvailableTo
    def get_Start(self): return self.Start
    def set_Start(self, Start): self.Start = Start
    def get_Finish(self): return self.Finish
    def set_Finish(self, Finish): self.Finish = Finish
    def get_CanLevel(self): return self.CanLevel
    def set_CanLevel(self, CanLevel): self.CanLevel = CanLevel
    def get_AccrueAt(self): return self.AccrueAt
    def set_AccrueAt(self, AccrueAt): self.AccrueAt = AccrueAt
    def validate_AccrueAt(self, value):
        # Validate type AccrueAt, a restriction on xsd:integer.
        pass
    def get_Work(self): return self.Work
    def set_Work(self, Work): self.Work = Work
    def get_RegularWork(self): return self.RegularWork
    def set_RegularWork(self, RegularWork): self.RegularWork = RegularWork
    def get_OvertimeWork(self): return self.OvertimeWork
    def set_OvertimeWork(self, OvertimeWork): self.OvertimeWork = OvertimeWork
    def get_ActualWork(self): return self.ActualWork
    def set_ActualWork(self, ActualWork): self.ActualWork = ActualWork
    def get_RemainingWork(self): return self.RemainingWork
    def set_RemainingWork(self, RemainingWork): self.RemainingWork = RemainingWork
    def get_ActualOvertimeWork(self): return self.ActualOvertimeWork
    def set_ActualOvertimeWork(self, ActualOvertimeWork): self.ActualOvertimeWork = ActualOvertimeWork
    def get_RemainingOvertimeWork(self): return self.RemainingOvertimeWork
    def set_RemainingOvertimeWork(self, RemainingOvertimeWork): self.RemainingOvertimeWork = RemainingOvertimeWork
    def get_PercentWorkComplete(self): return self.PercentWorkComplete
    def set_PercentWorkComplete(self, PercentWorkComplete): self.PercentWorkComplete = PercentWorkComplete
    def get_StandardRate(self): return self.StandardRate
    def set_StandardRate(self, StandardRate): self.StandardRate = StandardRate
    def get_StandardRateFormat(self): return self.StandardRateFormat
    def set_StandardRateFormat(self, StandardRateFormat): self.StandardRateFormat = StandardRateFormat
    def validate_StandardRateFormat(self, value):
        # Validate type StandardRateFormat, a restriction on xsd:integer.
        pass
    def get_Cost(self): return self.Cost
    def set_Cost(self, Cost): self.Cost = Cost
    def get_OvertimeRate(self): return self.OvertimeRate
    def set_OvertimeRate(self, OvertimeRate): self.OvertimeRate = OvertimeRate
    def get_OvertimeRateFormat(self): return self.OvertimeRateFormat
    def set_OvertimeRateFormat(self, OvertimeRateFormat): self.OvertimeRateFormat = OvertimeRateFormat
    def validate_OvertimeRateFormat(self, value):
        # Validate type OvertimeRateFormat, a restriction on xsd:integer.
        pass
    def get_OvertimeCost(self): return self.OvertimeCost
    def set_OvertimeCost(self, OvertimeCost): self.OvertimeCost = OvertimeCost
    def get_CostPerUse(self): return self.CostPerUse
    def set_CostPerUse(self, CostPerUse): self.CostPerUse = CostPerUse
    def get_ActualCost(self): return self.ActualCost
    def set_ActualCost(self, ActualCost): self.ActualCost = ActualCost
    def get_ActualOvertimeCost(self): return self.ActualOvertimeCost
    def set_ActualOvertimeCost(self, ActualOvertimeCost): self.ActualOvertimeCost = ActualOvertimeCost
    def get_RemainingCost(self): return self.RemainingCost
    def set_RemainingCost(self, RemainingCost): self.RemainingCost = RemainingCost
    def get_RemainingOvertimeCost(self): return self.RemainingOvertimeCost
    def set_RemainingOvertimeCost(self, RemainingOvertimeCost): self.RemainingOvertimeCost = RemainingOvertimeCost
    def get_WorkVariance(self): return self.WorkVariance
    def set_WorkVariance(self, WorkVariance): self.WorkVariance = WorkVariance
    def get_CostVariance(self): return self.CostVariance
    def set_CostVariance(self, CostVariance): self.CostVariance = CostVariance
    def get_SV(self): return self.SV
    def set_SV(self, SV): self.SV = SV
    def get_CV(self): return self.CV
    def set_CV(self, CV): self.CV = CV
    def get_ACWP(self): return self.ACWP
    def set_ACWP(self, ACWP): self.ACWP = ACWP
    def get_CalendarUID(self): return self.CalendarUID
    def set_CalendarUID(self, CalendarUID): self.CalendarUID = CalendarUID
    def get_Notes(self): return self.Notes
    def set_Notes(self, Notes): self.Notes = Notes
    def get_BCWS(self): return self.BCWS
    def set_BCWS(self, BCWS): self.BCWS = BCWS
    def get_BCWP(self): return self.BCWP
    def set_BCWP(self, BCWP): self.BCWP = BCWP
    def get_IsGeneric(self): return self.IsGeneric
    def set_IsGeneric(self, IsGeneric): self.IsGeneric = IsGeneric
    def get_IsInactive(self): return self.IsInactive
    def set_IsInactive(self, IsInactive): self.IsInactive = IsInactive
    def get_IsEnterprise(self): return self.IsEnterprise
    def set_IsEnterprise(self, IsEnterprise): self.IsEnterprise = IsEnterprise
    def get_BookingType(self): return self.BookingType
    def set_BookingType(self, BookingType): self.BookingType = BookingType
    def validate_BookingType(self, value):
        # Validate type BookingType, a restriction on xsd:integer.
        pass
    def get_ActualWorkProtected(self): return self.ActualWorkProtected
    def set_ActualWorkProtected(self, ActualWorkProtected): self.ActualWorkProtected = ActualWorkProtected
    def get_ActualOvertimeWorkProtected(self): return self.ActualOvertimeWorkProtected
    def set_ActualOvertimeWorkProtected(self, ActualOvertimeWorkProtected): self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
    def get_ActiveDirectoryGUID(self): return self.ActiveDirectoryGUID
    def set_ActiveDirectoryGUID(self, ActiveDirectoryGUID): self.ActiveDirectoryGUID = ActiveDirectoryGUID
    def validate_ActiveDirectoryGUID(self, value):
        # Validate type ActiveDirectoryGUID, a restriction on xsd:string.
        pass
    def get_CreationDate(self): return self.CreationDate
    def set_CreationDate(self, CreationDate): self.CreationDate = CreationDate
    def get_ExtendedAttribute(self): return self.ExtendedAttribute
    def set_ExtendedAttribute(self, ExtendedAttribute): self.ExtendedAttribute = ExtendedAttribute
    def add_ExtendedAttribute(self, value): self.ExtendedAttribute.append(value)
    def insert_ExtendedAttribute(self, index, value): self.ExtendedAttribute[index] = value
    def get_Baseline(self): return self.Baseline
    def set_Baseline(self, Baseline): self.Baseline = Baseline
    def add_Baseline(self, value): self.Baseline.append(value)
    def insert_Baseline(self, index, value): self.Baseline[index] = value
    def get_OutlineCode(self): return self.OutlineCode
    def set_OutlineCode(self, OutlineCode): self.OutlineCode = OutlineCode
    def add_OutlineCode(self, value): self.OutlineCode.append(value)
    def insert_OutlineCode(self, index, value): self.OutlineCode[index] = value
    def get_AvailabilityPeriods(self): return self.AvailabilityPeriods
    def set_AvailabilityPeriods(self, AvailabilityPeriods): self.AvailabilityPeriods = AvailabilityPeriods
    def get_Rates(self): return self.Rates
    def set_Rates(self, Rates): self.Rates = Rates
    def get_TimephasedData(self): return self.TimephasedData
    def set_TimephasedData(self, TimephasedData): self.TimephasedData = TimephasedData
    def add_TimephasedData(self, value): self.TimephasedData.append(value)
    def insert_TimephasedData(self, index, value): self.TimephasedData[index] = value
    def export(self, outfile, level, namespace_='', name_='Resource', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Resource')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Resource'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Resource'):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.ID is not None:
            showIndent(outfile, level)
            outfile.write('<%sID>%s</%sID>\n' % (namespace_, self.format_string(quote_xml(self.ID), input_name='ID'), namespace_))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('<%sName>%s</%sName>\n' % (namespace_, self.format_string(quote_xml(self.Name), input_name='Name'), namespace_))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('<%sType>%s</%sType>\n' % (namespace_, self.format_string(quote_xml(self.Type), input_name='Type'), namespace_))
        if self.IsNull is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsNull>%s</%sIsNull>\n' % (namespace_, self.format_string(quote_xml(self.IsNull), input_name='IsNull'), namespace_))
        if self.Initials is not None:
            showIndent(outfile, level)
            outfile.write('<%sInitials>%s</%sInitials>\n' % (namespace_, self.format_string(quote_xml(self.Initials), input_name='Initials'), namespace_))
        if self.Phonetics is not None:
            showIndent(outfile, level)
            outfile.write('<%sPhonetics>%s</%sPhonetics>\n' % (namespace_, self.format_string(quote_xml(self.Phonetics), input_name='Phonetics'), namespace_))
        if self.NTAccount is not None:
            showIndent(outfile, level)
            outfile.write('<%sNTAccount>%s</%sNTAccount>\n' % (namespace_, self.format_string(quote_xml(self.NTAccount), input_name='NTAccount'), namespace_))
        if self.MaterialLabel is not None:
            showIndent(outfile, level)
            outfile.write('<%sMaterialLabel>%s</%sMaterialLabel>\n' % (namespace_, self.format_string(quote_xml(self.MaterialLabel), input_name='MaterialLabel'), namespace_))
        if self.Code is not None:
            showIndent(outfile, level)
            outfile.write('<%sCode>%s</%sCode>\n' % (namespace_, self.format_string(quote_xml(self.Code), input_name='Code'), namespace_))
        if self.Group is not None:
            showIndent(outfile, level)
            outfile.write('<%sGroup>%s</%sGroup>\n' % (namespace_, self.format_string(quote_xml(self.Group), input_name='Group'), namespace_))
        if self.WorkGroup is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkGroup>%s</%sWorkGroup>\n' % (namespace_, self.format_string(quote_xml(self.WorkGroup), input_name='WorkGroup'), namespace_))
        if self.EmailAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sEmailAddress>%s</%sEmailAddress>\n' % (namespace_, self.format_string(quote_xml(self.EmailAddress), input_name='EmailAddress'), namespace_))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlink>%s</%sHyperlink>\n' % (namespace_, self.format_string(quote_xml(self.Hyperlink), input_name='Hyperlink'), namespace_))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkAddress>%s</%sHyperlinkAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkAddress), input_name='HyperlinkAddress'), namespace_))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkSubAddress>%s</%sHyperlinkSubAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkSubAddress), input_name='HyperlinkSubAddress'), namespace_))
        if self.MaxUnits is not None:
            showIndent(outfile, level)
            outfile.write('<%sMaxUnits>%s</%sMaxUnits>\n' % (namespace_, self.format_string(quote_xml(self.MaxUnits), input_name='MaxUnits'), namespace_))
        if self.PeakUnits is not None:
            showIndent(outfile, level)
            outfile.write('<%sPeakUnits>%s</%sPeakUnits>\n' % (namespace_, self.format_string(quote_xml(self.PeakUnits), input_name='PeakUnits'), namespace_))
        if self.OverAllocated is not None:
            showIndent(outfile, level)
            outfile.write('<%sOverAllocated>%s</%sOverAllocated>\n' % (namespace_, self.format_string(quote_xml(self.OverAllocated), input_name='OverAllocated'), namespace_))
        if self.AvailableFrom is not None:
            showIndent(outfile, level)
            outfile.write('<%sAvailableFrom>%s</%sAvailableFrom>\n' % (namespace_, self.format_string(quote_xml(self.AvailableFrom), input_name='AvailableFrom'), namespace_))
        if self.AvailableTo is not None:
            showIndent(outfile, level)
            outfile.write('<%sAvailableTo>%s</%sAvailableTo>\n' % (namespace_, self.format_string(quote_xml(self.AvailableTo), input_name='AvailableTo'), namespace_))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('<%sStart>%s</%sStart>\n' % (namespace_, self.format_string(quote_xml(self.Start), input_name='Start'), namespace_))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinish>%s</%sFinish>\n' % (namespace_, self.format_string(quote_xml(self.Finish), input_name='Finish'), namespace_))
        if self.CanLevel is not None:
            showIndent(outfile, level)
            outfile.write('<%sCanLevel>%s</%sCanLevel>\n' % (namespace_, self.format_string(quote_xml(self.CanLevel), input_name='CanLevel'), namespace_))
        if self.AccrueAt is not None:
            showIndent(outfile, level)
            outfile.write('<%sAccrueAt>%s</%sAccrueAt>\n' % (namespace_, self.format_string(quote_xml(self.AccrueAt), input_name='AccrueAt'), namespace_))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('<%sWork>%s</%sWork>\n' % (namespace_, self.format_string(quote_xml(self.Work), input_name='Work'), namespace_))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRegularWork>%s</%sRegularWork>\n' % (namespace_, self.format_string(quote_xml(self.RegularWork), input_name='RegularWork'), namespace_))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeWork>%s</%sOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeWork), input_name='OvertimeWork'), namespace_))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWork>%s</%sActualWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualWork), input_name='ActualWork'), namespace_))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingWork>%s</%sRemainingWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingWork), input_name='RemainingWork'), namespace_))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWork>%s</%sActualOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWork), input_name='ActualOvertimeWork'), namespace_))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeWork>%s</%sRemainingOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeWork), input_name='RemainingOvertimeWork'), namespace_))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sPercentWorkComplete>%s</%sPercentWorkComplete>\n' % (namespace_, self.format_string(quote_xml(self.PercentWorkComplete), input_name='PercentWorkComplete'), namespace_))
        if self.StandardRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sStandardRate>%s</%sStandardRate>\n' % (namespace_, self.format_string(quote_xml(self.StandardRate), input_name='StandardRate'), namespace_))
        if self.StandardRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sStandardRateFormat>%s</%sStandardRateFormat>\n' % (namespace_, self.format_string(quote_xml(self.StandardRateFormat), input_name='StandardRateFormat'), namespace_))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('<%sCost>%s</%sCost>\n' % (namespace_, self.format_string(quote_xml(self.Cost), input_name='Cost'), namespace_))
        if self.OvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeRate>%s</%sOvertimeRate>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeRate), input_name='OvertimeRate'), namespace_))
        if self.OvertimeRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeRateFormat>%s</%sOvertimeRateFormat>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeRateFormat), input_name='OvertimeRateFormat'), namespace_))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeCost>%s</%sOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeCost), input_name='OvertimeCost'), namespace_))
        if self.CostPerUse is not None:
            showIndent(outfile, level)
            outfile.write('<%sCostPerUse>%s</%sCostPerUse>\n' % (namespace_, self.format_string(quote_xml(self.CostPerUse), input_name='CostPerUse'), namespace_))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualCost>%s</%sActualCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualCost), input_name='ActualCost'), namespace_))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeCost>%s</%sActualOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeCost), input_name='ActualOvertimeCost'), namespace_))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingCost>%s</%sRemainingCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingCost), input_name='RemainingCost'), namespace_))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeCost>%s</%sRemainingOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeCost), input_name='RemainingOvertimeCost'), namespace_))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkVariance>%s</%sWorkVariance>\n' % (namespace_, self.format_string(quote_xml(self.WorkVariance), input_name='WorkVariance'), namespace_))
        if self.CostVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sCostVariance>%s</%sCostVariance>\n' % (namespace_, self.format_string(quote_xml(self.CostVariance), input_name='CostVariance'), namespace_))
        if self.SV is not None:
            showIndent(outfile, level)
            outfile.write('<%sSV>%s</%sSV>\n' % (namespace_, self.format_string(quote_xml(self.SV), input_name='SV'), namespace_))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('<%sCV>%s</%sCV>\n' % (namespace_, self.format_string(quote_xml(self.CV), input_name='CV'), namespace_))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sACWP>%s</%sACWP>\n' % (namespace_, self.format_string(quote_xml(self.ACWP), input_name='ACWP'), namespace_))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sCalendarUID>%s</%sCalendarUID>\n' % (namespace_, self.format_string(quote_xml(self.CalendarUID), input_name='CalendarUID'), namespace_))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('<%sNotes>%s</%sNotes>\n' % (namespace_, self.format_string(quote_xml(self.Notes), input_name='Notes'), namespace_))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWS>%s</%sBCWS>\n' % (namespace_, self.format_string(quote_xml(self.BCWS), input_name='BCWS'), namespace_))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWP>%s</%sBCWP>\n' % (namespace_, self.format_string(quote_xml(self.BCWP), input_name='BCWP'), namespace_))
        if self.IsGeneric is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsGeneric>%s</%sIsGeneric>\n' % (namespace_, self.format_string(quote_xml(self.IsGeneric), input_name='IsGeneric'), namespace_))
        if self.IsInactive is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsInactive>%s</%sIsInactive>\n' % (namespace_, self.format_string(quote_xml(self.IsInactive), input_name='IsInactive'), namespace_))
        if self.IsEnterprise is not None:
            showIndent(outfile, level)
            outfile.write('<%sIsEnterprise>%s</%sIsEnterprise>\n' % (namespace_, self.format_string(quote_xml(self.IsEnterprise), input_name='IsEnterprise'), namespace_))
        if self.BookingType is not None:
            showIndent(outfile, level)
            outfile.write('<%sBookingType>%s</%sBookingType>\n' % (namespace_, self.format_string(quote_xml(self.BookingType), input_name='BookingType'), namespace_))
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWorkProtected>%s</%sActualWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualWorkProtected), input_name='ActualWorkProtected'), namespace_))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWorkProtected>%s</%sActualOvertimeWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWorkProtected), input_name='ActualOvertimeWorkProtected'), namespace_))
        if self.ActiveDirectoryGUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sActiveDirectoryGUID>%s</%sActiveDirectoryGUID>\n' % (namespace_, self.format_string(quote_xml(self.ActiveDirectoryGUID), input_name='ActiveDirectoryGUID'), namespace_))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sCreationDate>%s</%sCreationDate>\n' % (namespace_, self.format_string(quote_xml(self.CreationDate), input_name='CreationDate'), namespace_))
        for ExtendedAttribute_ in self.ExtendedAttribute:
            ExtendedAttribute_.export(outfile, level, namespace_, name_='ExtendedAttribute')
        for Baseline_ in self.Baseline:
            Baseline_.export(outfile, level, namespace_, name_='Baseline')
        for OutlineCode_ in self.OutlineCode:
            OutlineCode_.export(outfile, level, namespace_, name_='OutlineCode')
        if self.AvailabilityPeriods:
            self.AvailabilityPeriods.export(outfile, level, namespace_, name_='AvailabilityPeriods')
        if self.Rates:
            self.Rates.export(outfile, level, namespace_, name_='Rates')
        for TimephasedData_ in self.TimephasedData:
            TimephasedData_.export(outfile, level, namespace_, name_='TimephasedData')
    def hasContent_(self):
        if (
            self.UID is not None or
            self.ID is not None or
            self.Name is not None or
            self.Type is not None or
            self.IsNull is not None or
            self.Initials is not None or
            self.Phonetics is not None or
            self.NTAccount is not None or
            self.MaterialLabel is not None or
            self.Code is not None or
            self.Group is not None or
            self.WorkGroup is not None or
            self.EmailAddress is not None or
            self.Hyperlink is not None or
            self.HyperlinkAddress is not None or
            self.HyperlinkSubAddress is not None or
            self.MaxUnits is not None or
            self.PeakUnits is not None or
            self.OverAllocated is not None or
            self.AvailableFrom is not None or
            self.AvailableTo is not None or
            self.Start is not None or
            self.Finish is not None or
            self.CanLevel is not None or
            self.AccrueAt is not None or
            self.Work is not None or
            self.RegularWork is not None or
            self.OvertimeWork is not None or
            self.ActualWork is not None or
            self.RemainingWork is not None or
            self.ActualOvertimeWork is not None or
            self.RemainingOvertimeWork is not None or
            self.PercentWorkComplete is not None or
            self.StandardRate is not None or
            self.StandardRateFormat is not None or
            self.Cost is not None or
            self.OvertimeRate is not None or
            self.OvertimeRateFormat is not None or
            self.OvertimeCost is not None or
            self.CostPerUse is not None or
            self.ActualCost is not None or
            self.ActualOvertimeCost is not None or
            self.RemainingCost is not None or
            self.RemainingOvertimeCost is not None or
            self.WorkVariance is not None or
            self.CostVariance is not None or
            self.SV is not None or
            self.CV is not None or
            self.ACWP is not None or
            self.CalendarUID is not None or
            self.Notes is not None or
            self.BCWS is not None or
            self.BCWP is not None or
            self.IsGeneric is not None or
            self.IsInactive is not None or
            self.IsEnterprise is not None or
            self.BookingType is not None or
            self.ActualWorkProtected is not None or
            self.ActualOvertimeWorkProtected is not None or
            self.ActiveDirectoryGUID is not None or
            self.CreationDate is not None or
            self.ExtendedAttribute or
            self.Baseline or
            self.OutlineCode or
            self.AvailabilityPeriods is not None or
            self.Rates is not None or
            self.TimephasedData
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Resource'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.ID is not None:
            showIndent(outfile, level)
            outfile.write('ID=%s,\n' % quote_python(self.ID))
        if self.Name is not None:
            showIndent(outfile, level)
            outfile.write('Name=%s,\n' % quote_python(self.Name))
        if self.Type is not None:
            showIndent(outfile, level)
            outfile.write('Type=%s,\n' % quote_python(self.Type))
        if self.IsNull is not None:
            showIndent(outfile, level)
            outfile.write('IsNull=%s,\n' % quote_python(self.IsNull))
        if self.Initials is not None:
            showIndent(outfile, level)
            outfile.write('Initials=%s,\n' % quote_python(self.Initials))
        if self.Phonetics is not None:
            showIndent(outfile, level)
            outfile.write('Phonetics=%s,\n' % quote_python(self.Phonetics))
        if self.NTAccount is not None:
            showIndent(outfile, level)
            outfile.write('NTAccount=%s,\n' % quote_python(self.NTAccount))
        if self.MaterialLabel is not None:
            showIndent(outfile, level)
            outfile.write('MaterialLabel=%s,\n' % quote_python(self.MaterialLabel))
        if self.Code is not None:
            showIndent(outfile, level)
            outfile.write('Code=%s,\n' % quote_python(self.Code))
        if self.Group is not None:
            showIndent(outfile, level)
            outfile.write('Group=%s,\n' % quote_python(self.Group))
        if self.WorkGroup is not None:
            showIndent(outfile, level)
            outfile.write('WorkGroup=%s,\n' % quote_python(self.WorkGroup))
        if self.EmailAddress is not None:
            showIndent(outfile, level)
            outfile.write('EmailAddress=%s,\n' % quote_python(self.EmailAddress))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('Hyperlink=%s,\n' % quote_python(self.Hyperlink))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkAddress=%s,\n' % quote_python(self.HyperlinkAddress))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkSubAddress=%s,\n' % quote_python(self.HyperlinkSubAddress))
        if self.MaxUnits is not None:
            showIndent(outfile, level)
            outfile.write('MaxUnits=%s,\n' % quote_python(self.MaxUnits))
        if self.PeakUnits is not None:
            showIndent(outfile, level)
            outfile.write('PeakUnits=%s,\n' % quote_python(self.PeakUnits))
        if self.OverAllocated is not None:
            showIndent(outfile, level)
            outfile.write('OverAllocated=%s,\n' % quote_python(self.OverAllocated))
        if self.AvailableFrom is not None:
            showIndent(outfile, level)
            outfile.write('AvailableFrom=%s,\n' % quote_python(self.AvailableFrom))
        if self.AvailableTo is not None:
            showIndent(outfile, level)
            outfile.write('AvailableTo=%s,\n' % quote_python(self.AvailableTo))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('Start=%s,\n' % quote_python(self.Start))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('Finish=%s,\n' % quote_python(self.Finish))
        if self.CanLevel is not None:
            showIndent(outfile, level)
            outfile.write('CanLevel=%s,\n' % quote_python(self.CanLevel))
        if self.AccrueAt is not None:
            showIndent(outfile, level)
            outfile.write('AccrueAt=%s,\n' % quote_python(self.AccrueAt))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('Work=%s,\n' % quote_python(self.Work))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('RegularWork=%s,\n' % quote_python(self.RegularWork))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeWork=%s,\n' % quote_python(self.OvertimeWork))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualWork=%s,\n' % quote_python(self.ActualWork))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingWork=%s,\n' % quote_python(self.RemainingWork))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWork=%s,\n' % quote_python(self.ActualOvertimeWork))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeWork=%s,\n' % quote_python(self.RemainingOvertimeWork))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('PercentWorkComplete=%s,\n' % quote_python(self.PercentWorkComplete))
        if self.StandardRate is not None:
            showIndent(outfile, level)
            outfile.write('StandardRate=%s,\n' % quote_python(self.StandardRate))
        if self.StandardRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('StandardRateFormat=%s,\n' % quote_python(self.StandardRateFormat))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('Cost=%s,\n' % quote_python(self.Cost))
        if self.OvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeRate=%s,\n' % quote_python(self.OvertimeRate))
        if self.OvertimeRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeRateFormat=%s,\n' % quote_python(self.OvertimeRateFormat))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeCost=%s,\n' % quote_python(self.OvertimeCost))
        if self.CostPerUse is not None:
            showIndent(outfile, level)
            outfile.write('CostPerUse=%s,\n' % quote_python(self.CostPerUse))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualCost=%s,\n' % quote_python(self.ActualCost))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeCost=%s,\n' % quote_python(self.ActualOvertimeCost))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingCost=%s,\n' % quote_python(self.RemainingCost))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeCost=%s,\n' % quote_python(self.RemainingOvertimeCost))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('WorkVariance=%s,\n' % quote_python(self.WorkVariance))
        if self.CostVariance is not None:
            showIndent(outfile, level)
            outfile.write('CostVariance=%s,\n' % quote_python(self.CostVariance))
        if self.SV is not None:
            showIndent(outfile, level)
            outfile.write('SV=%s,\n' % quote_python(self.SV))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('CV=%s,\n' % quote_python(self.CV))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('ACWP=%s,\n' % quote_python(self.ACWP))
        if self.CalendarUID is not None:
            showIndent(outfile, level)
            outfile.write('CalendarUID=%s,\n' % quote_python(self.CalendarUID))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('Notes=%s,\n' % quote_python(self.Notes))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('BCWS=%s,\n' % quote_python(self.BCWS))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('BCWP=%s,\n' % quote_python(self.BCWP))
        if self.IsGeneric is not None:
            showIndent(outfile, level)
            outfile.write('IsGeneric=%s,\n' % quote_python(self.IsGeneric))
        if self.IsInactive is not None:
            showIndent(outfile, level)
            outfile.write('IsInactive=%s,\n' % quote_python(self.IsInactive))
        if self.IsEnterprise is not None:
            showIndent(outfile, level)
            outfile.write('IsEnterprise=%s,\n' % quote_python(self.IsEnterprise))
        if self.BookingType is not None:
            showIndent(outfile, level)
            outfile.write('BookingType=%s,\n' % quote_python(self.BookingType))
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualWorkProtected=%s,\n' % quote_python(self.ActualWorkProtected))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWorkProtected=%s,\n' % quote_python(self.ActualOvertimeWorkProtected))
        if self.ActiveDirectoryGUID is not None:
            showIndent(outfile, level)
            outfile.write('ActiveDirectoryGUID=%s,\n' % quote_python(self.ActiveDirectoryGUID))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('CreationDate=%s,\n' % quote_python(self.CreationDate))
        showIndent(outfile, level)
        outfile.write('ExtendedAttribute=[\n')
        level += 1
        for ExtendedAttribute_ in self.ExtendedAttribute:
            showIndent(outfile, level)
            outfile.write('model_.ExtendedAttribute(\n')
            ExtendedAttribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Baseline=[\n')
        level += 1
        for Baseline_ in self.Baseline:
            showIndent(outfile, level)
            outfile.write('model_.Baseline(\n')
            Baseline_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('OutlineCode=[\n')
        level += 1
        for OutlineCode_ in self.OutlineCode:
            showIndent(outfile, level)
            outfile.write('model_.OutlineCode(\n')
            OutlineCode_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        if self.AvailabilityPeriods is not None:
            showIndent(outfile, level)
            outfile.write('AvailabilityPeriods=model_.AvailabilityPeriods(\n')
            self.AvailabilityPeriods.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        if self.Rates is not None:
            showIndent(outfile, level)
            outfile.write('Rates=model_.Rates(\n')
            self.Rates.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        showIndent(outfile, level)
        outfile.write('TimephasedData=[\n')
        level += 1
        for TimephasedData_ in self.TimephasedData:
            showIndent(outfile, level)
            outfile.write('model_.TimephasedDataType(\n')
            TimephasedData_.exportLiteral(outfile, level, name_='TimephasedDataType')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ID':
            ID_ = ''
            for text__content_ in child_.childNodes:
                ID_ += text__content_.nodeValue
            self.ID = ID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Name':
            Name_ = ''
            for text__content_ in child_.childNodes:
                Name_ += text__content_.nodeValue
            self.Name = Name_
            self.validate_Name(self.Name)    # validate type Name
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Type':
            Type_ = ''
            for text__content_ in child_.childNodes:
                Type_ += text__content_.nodeValue
            self.Type = Type_
            self.validate_Type(self.Type)    # validate type Type
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsNull':
            IsNull_ = ''
            for text__content_ in child_.childNodes:
                IsNull_ += text__content_.nodeValue
            self.IsNull = IsNull_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Initials':
            Initials_ = ''
            for text__content_ in child_.childNodes:
                Initials_ += text__content_.nodeValue
            self.Initials = Initials_
            self.validate_Initials(self.Initials)    # validate type Initials
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Phonetics':
            Phonetics_ = ''
            for text__content_ in child_.childNodes:
                Phonetics_ += text__content_.nodeValue
            self.Phonetics = Phonetics_
            self.validate_Phonetics(self.Phonetics)    # validate type Phonetics
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'NTAccount':
            NTAccount_ = ''
            for text__content_ in child_.childNodes:
                NTAccount_ += text__content_.nodeValue
            self.NTAccount = NTAccount_
            self.validate_NTAccount(self.NTAccount)    # validate type NTAccount
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MaterialLabel':
            MaterialLabel_ = ''
            for text__content_ in child_.childNodes:
                MaterialLabel_ += text__content_.nodeValue
            self.MaterialLabel = MaterialLabel_
            self.validate_MaterialLabel(self.MaterialLabel)    # validate type MaterialLabel
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Code':
            Code_ = ''
            for text__content_ in child_.childNodes:
                Code_ += text__content_.nodeValue
            self.Code = Code_
            self.validate_Code(self.Code)    # validate type Code
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Group':
            Group_ = ''
            for text__content_ in child_.childNodes:
                Group_ += text__content_.nodeValue
            self.Group = Group_
            self.validate_Group(self.Group)    # validate type Group
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkGroup':
            WorkGroup_ = ''
            for text__content_ in child_.childNodes:
                WorkGroup_ += text__content_.nodeValue
            self.WorkGroup = WorkGroup_
            self.validate_WorkGroup(self.WorkGroup)    # validate type WorkGroup
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'EmailAddress':
            EmailAddress_ = ''
            for text__content_ in child_.childNodes:
                EmailAddress_ += text__content_.nodeValue
            self.EmailAddress = EmailAddress_
            self.validate_EmailAddress(self.EmailAddress)    # validate type EmailAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Hyperlink':
            Hyperlink_ = ''
            for text__content_ in child_.childNodes:
                Hyperlink_ += text__content_.nodeValue
            self.Hyperlink = Hyperlink_
            self.validate_Hyperlink(self.Hyperlink)    # validate type Hyperlink
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkAddress':
            HyperlinkAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkAddress_ += text__content_.nodeValue
            self.HyperlinkAddress = HyperlinkAddress_
            self.validate_HyperlinkAddress(self.HyperlinkAddress)    # validate type HyperlinkAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkSubAddress':
            HyperlinkSubAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkSubAddress_ += text__content_.nodeValue
            self.HyperlinkSubAddress = HyperlinkSubAddress_
            self.validate_HyperlinkSubAddress(self.HyperlinkSubAddress)    # validate type HyperlinkSubAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'MaxUnits':
            MaxUnits_ = ''
            for text__content_ in child_.childNodes:
                MaxUnits_ += text__content_.nodeValue
            self.MaxUnits = MaxUnits_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PeakUnits':
            PeakUnits_ = ''
            for text__content_ in child_.childNodes:
                PeakUnits_ += text__content_.nodeValue
            self.PeakUnits = PeakUnits_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OverAllocated':
            OverAllocated_ = ''
            for text__content_ in child_.childNodes:
                OverAllocated_ += text__content_.nodeValue
            self.OverAllocated = OverAllocated_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailableFrom':
            AvailableFrom_ = ''
            for text__content_ in child_.childNodes:
                AvailableFrom_ += text__content_.nodeValue
            self.AvailableFrom = AvailableFrom_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailableTo':
            AvailableTo_ = ''
            for text__content_ in child_.childNodes:
                AvailableTo_ += text__content_.nodeValue
            self.AvailableTo = AvailableTo_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Start':
            Start_ = ''
            for text__content_ in child_.childNodes:
                Start_ += text__content_.nodeValue
            self.Start = Start_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Finish':
            Finish_ = ''
            for text__content_ in child_.childNodes:
                Finish_ += text__content_.nodeValue
            self.Finish = Finish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CanLevel':
            CanLevel_ = ''
            for text__content_ in child_.childNodes:
                CanLevel_ += text__content_.nodeValue
            self.CanLevel = CanLevel_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AccrueAt':
            AccrueAt_ = ''
            for text__content_ in child_.childNodes:
                AccrueAt_ += text__content_.nodeValue
            self.AccrueAt = AccrueAt_
            self.validate_AccrueAt(self.AccrueAt)    # validate type AccrueAt
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Work':
            Work_ = ''
            for text__content_ in child_.childNodes:
                Work_ += text__content_.nodeValue
            self.Work = Work_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RegularWork':
            RegularWork_ = ''
            for text__content_ in child_.childNodes:
                RegularWork_ += text__content_.nodeValue
            self.RegularWork = RegularWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeWork':
            OvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                OvertimeWork_ += text__content_.nodeValue
            self.OvertimeWork = OvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWork':
            ActualWork_ = ''
            for text__content_ in child_.childNodes:
                ActualWork_ += text__content_.nodeValue
            self.ActualWork = ActualWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingWork':
            RemainingWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingWork_ += text__content_.nodeValue
            self.RemainingWork = RemainingWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWork':
            ActualOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWork_ += text__content_.nodeValue
            self.ActualOvertimeWork = ActualOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeWork':
            RemainingOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeWork_ += text__content_.nodeValue
            self.RemainingOvertimeWork = RemainingOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PercentWorkComplete':
            PercentWorkComplete_ = ''
            for text__content_ in child_.childNodes:
                PercentWorkComplete_ += text__content_.nodeValue
            self.PercentWorkComplete = PercentWorkComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StandardRate':
            StandardRate_ = ''
            for text__content_ in child_.childNodes:
                StandardRate_ += text__content_.nodeValue
            self.StandardRate = StandardRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StandardRateFormat':
            StandardRateFormat_ = ''
            for text__content_ in child_.childNodes:
                StandardRateFormat_ += text__content_.nodeValue
            self.StandardRateFormat = StandardRateFormat_
            self.validate_StandardRateFormat(self.StandardRateFormat)    # validate type StandardRateFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Cost':
            Cost_ = ''
            for text__content_ in child_.childNodes:
                Cost_ += text__content_.nodeValue
            self.Cost = Cost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeRate':
            OvertimeRate_ = ''
            for text__content_ in child_.childNodes:
                OvertimeRate_ += text__content_.nodeValue
            self.OvertimeRate = OvertimeRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeRateFormat':
            OvertimeRateFormat_ = ''
            for text__content_ in child_.childNodes:
                OvertimeRateFormat_ += text__content_.nodeValue
            self.OvertimeRateFormat = OvertimeRateFormat_
            self.validate_OvertimeRateFormat(self.OvertimeRateFormat)    # validate type OvertimeRateFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeCost':
            OvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                OvertimeCost_ += text__content_.nodeValue
            self.OvertimeCost = OvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CostPerUse':
            CostPerUse_ = ''
            for text__content_ in child_.childNodes:
                CostPerUse_ += text__content_.nodeValue
            self.CostPerUse = CostPerUse_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualCost':
            ActualCost_ = ''
            for text__content_ in child_.childNodes:
                ActualCost_ += text__content_.nodeValue
            self.ActualCost = ActualCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeCost':
            ActualOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeCost_ += text__content_.nodeValue
            self.ActualOvertimeCost = ActualOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingCost':
            RemainingCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingCost_ += text__content_.nodeValue
            self.RemainingCost = RemainingCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeCost':
            RemainingOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeCost_ += text__content_.nodeValue
            self.RemainingOvertimeCost = RemainingOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkVariance':
            WorkVariance_ = ''
            for text__content_ in child_.childNodes:
                WorkVariance_ += text__content_.nodeValue
            self.WorkVariance = WorkVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CostVariance':
            CostVariance_ = ''
            for text__content_ in child_.childNodes:
                CostVariance_ += text__content_.nodeValue
            self.CostVariance = CostVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'SV':
            SV_ = ''
            for text__content_ in child_.childNodes:
                SV_ += text__content_.nodeValue
            self.SV = SV_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CV':
            CV_ = ''
            for text__content_ in child_.childNodes:
                CV_ += text__content_.nodeValue
            self.CV = CV_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ACWP':
            ACWP_ = ''
            for text__content_ in child_.childNodes:
                ACWP_ += text__content_.nodeValue
            self.ACWP = ACWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CalendarUID':
            CalendarUID_ = ''
            for text__content_ in child_.childNodes:
                CalendarUID_ += text__content_.nodeValue
            self.CalendarUID = CalendarUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Notes':
            Notes_ = ''
            for text__content_ in child_.childNodes:
                Notes_ += text__content_.nodeValue
            self.Notes = Notes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWS':
            BCWS_ = ''
            for text__content_ in child_.childNodes:
                BCWS_ += text__content_.nodeValue
            self.BCWS = BCWS_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWP':
            BCWP_ = ''
            for text__content_ in child_.childNodes:
                BCWP_ += text__content_.nodeValue
            self.BCWP = BCWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsGeneric':
            IsGeneric_ = ''
            for text__content_ in child_.childNodes:
                IsGeneric_ += text__content_.nodeValue
            self.IsGeneric = IsGeneric_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsInactive':
            IsInactive_ = ''
            for text__content_ in child_.childNodes:
                IsInactive_ += text__content_.nodeValue
            self.IsInactive = IsInactive_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'IsEnterprise':
            IsEnterprise_ = ''
            for text__content_ in child_.childNodes:
                IsEnterprise_ += text__content_.nodeValue
            self.IsEnterprise = IsEnterprise_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BookingType':
            BookingType_ = ''
            for text__content_ in child_.childNodes:
                BookingType_ += text__content_.nodeValue
            self.BookingType = BookingType_
            self.validate_BookingType(self.BookingType)    # validate type BookingType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWorkProtected':
            ActualWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualWorkProtected_ += text__content_.nodeValue
            self.ActualWorkProtected = ActualWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWorkProtected':
            ActualOvertimeWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWorkProtected_ += text__content_.nodeValue
            self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActiveDirectoryGUID':
            ActiveDirectoryGUID_ = ''
            for text__content_ in child_.childNodes:
                ActiveDirectoryGUID_ += text__content_.nodeValue
            self.ActiveDirectoryGUID = ActiveDirectoryGUID_
            self.validate_ActiveDirectoryGUID(self.ActiveDirectoryGUID)    # validate type ActiveDirectoryGUID
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CreationDate':
            CreationDate_ = ''
            for text__content_ in child_.childNodes:
                CreationDate_ += text__content_.nodeValue
            self.CreationDate = CreationDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedAttribute':
            obj_ = ExtendedAttribute.factory()
            obj_.build(child_)
            self.ExtendedAttribute.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Baseline':
            obj_ = Baseline.factory()
            obj_.build(child_)
            self.Baseline.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OutlineCode':
            obj_ = OutlineCode.factory()
            obj_.build(child_)
            self.OutlineCode.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailabilityPeriods':
            obj_ = AvailabilityPeriods.factory()
            obj_.build(child_)
            self.set_AvailabilityPeriods(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Rates':
            obj_ = Rates.factory()
            obj_.build(child_)
            self.set_Rates(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TimephasedData':
            obj_ = TimephasedDataType.factory()
            obj_.build(child_)
            self.TimephasedData.append(obj_)
# end class Resource


class Initials(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Initials.subclass:
            return Initials.subclass(*args_, **kwargs_)
        else:
            return Initials(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Initials', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Initials')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Initials'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Initials'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Initials'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Initials


class Phonetics(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Phonetics.subclass:
            return Phonetics.subclass(*args_, **kwargs_)
        else:
            return Phonetics(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Phonetics', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Phonetics')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Phonetics'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Phonetics'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Phonetics'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Phonetics


class NTAccount(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if NTAccount.subclass:
            return NTAccount.subclass(*args_, **kwargs_)
        else:
            return NTAccount(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='NTAccount', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='NTAccount')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='NTAccount'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='NTAccount'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='NTAccount'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class NTAccount


class MaterialLabel(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if MaterialLabel.subclass:
            return MaterialLabel.subclass(*args_, **kwargs_)
        else:
            return MaterialLabel(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='MaterialLabel', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='MaterialLabel')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='MaterialLabel'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='MaterialLabel'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='MaterialLabel'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class MaterialLabel


class Code(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Code.subclass:
            return Code.subclass(*args_, **kwargs_)
        else:
            return Code(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Code', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Code')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Code'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Code'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Code'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Code


class Group(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if Group.subclass:
            return Group.subclass(*args_, **kwargs_)
        else:
            return Group(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='Group', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Group')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Group'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Group'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Group'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class Group


class WorkGroup(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if WorkGroup.subclass:
            return WorkGroup.subclass(*args_, **kwargs_)
        else:
            return WorkGroup(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='WorkGroup', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WorkGroup')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WorkGroup'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WorkGroup'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WorkGroup'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class WorkGroup


class EmailAddress(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if EmailAddress.subclass:
            return EmailAddress.subclass(*args_, **kwargs_)
        else:
            return EmailAddress(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='EmailAddress', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='EmailAddress')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='EmailAddress'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='EmailAddress'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='EmailAddress'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class EmailAddress


class AccrueAt(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if AccrueAt.subclass:
            return AccrueAt.subclass(*args_, **kwargs_)
        else:
            return AccrueAt(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='AccrueAt', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='AccrueAt')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='AccrueAt'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='AccrueAt'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='AccrueAt'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class AccrueAt


class StandardRateFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if StandardRateFormat.subclass:
            return StandardRateFormat.subclass(*args_, **kwargs_)
        else:
            return StandardRateFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='StandardRateFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='StandardRateFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='StandardRateFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='StandardRateFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='StandardRateFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class StandardRateFormat


class OvertimeRateFormat(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if OvertimeRateFormat.subclass:
            return OvertimeRateFormat.subclass(*args_, **kwargs_)
        else:
            return OvertimeRateFormat(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='OvertimeRateFormat', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='OvertimeRateFormat')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='OvertimeRateFormat'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='OvertimeRateFormat'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='OvertimeRateFormat'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class OvertimeRateFormat


class BookingType(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if BookingType.subclass:
            return BookingType.subclass(*args_, **kwargs_)
        else:
            return BookingType(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='BookingType', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='BookingType')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='BookingType'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='BookingType'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='BookingType'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class BookingType


class ActiveDirectoryGUID(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if ActiveDirectoryGUID.subclass:
            return ActiveDirectoryGUID.subclass(*args_, **kwargs_)
        else:
            return ActiveDirectoryGUID(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='ActiveDirectoryGUID', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='ActiveDirectoryGUID')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='ActiveDirectoryGUID'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='ActiveDirectoryGUID'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='ActiveDirectoryGUID'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class ActiveDirectoryGUID


class AvailabilityPeriods(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, AvailabilityPeriod=None):
        if AvailabilityPeriod is None:
            self.AvailabilityPeriod = []
        else:
            self.AvailabilityPeriod = AvailabilityPeriod
    def factory(*args_, **kwargs_):
        if AvailabilityPeriods.subclass:
            return AvailabilityPeriods.subclass(*args_, **kwargs_)
        else:
            return AvailabilityPeriods(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_AvailabilityPeriod(self): return self.AvailabilityPeriod
    def set_AvailabilityPeriod(self, AvailabilityPeriod): self.AvailabilityPeriod = AvailabilityPeriod
    def add_AvailabilityPeriod(self, value): self.AvailabilityPeriod.append(value)
    def insert_AvailabilityPeriod(self, index, value): self.AvailabilityPeriod[index] = value
    def export(self, outfile, level, namespace_='', name_='AvailabilityPeriods', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='AvailabilityPeriods')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='AvailabilityPeriods'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='AvailabilityPeriods'):
        for AvailabilityPeriod_ in self.AvailabilityPeriod:
            AvailabilityPeriod_.export(outfile, level, namespace_, name_='AvailabilityPeriod')
    def hasContent_(self):
        if (
            self.AvailabilityPeriod
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='AvailabilityPeriods'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('AvailabilityPeriod=[\n')
        level += 1
        for AvailabilityPeriod_ in self.AvailabilityPeriod:
            showIndent(outfile, level)
            outfile.write('model_.AvailabilityPeriod(\n')
            AvailabilityPeriod_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailabilityPeriod':
            obj_ = AvailabilityPeriod.factory()
            obj_.build(child_)
            self.AvailabilityPeriod.append(obj_)
# end class AvailabilityPeriods


class AvailabilityPeriod(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, AvailableFrom=None, AvailableTo=None, AvailableUnits=None):
        self.AvailableFrom = AvailableFrom
        self.AvailableTo = AvailableTo
        self.AvailableUnits = AvailableUnits
    def factory(*args_, **kwargs_):
        if AvailabilityPeriod.subclass:
            return AvailabilityPeriod.subclass(*args_, **kwargs_)
        else:
            return AvailabilityPeriod(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_AvailableFrom(self): return self.AvailableFrom
    def set_AvailableFrom(self, AvailableFrom): self.AvailableFrom = AvailableFrom
    def get_AvailableTo(self): return self.AvailableTo
    def set_AvailableTo(self, AvailableTo): self.AvailableTo = AvailableTo
    def get_AvailableUnits(self): return self.AvailableUnits
    def set_AvailableUnits(self, AvailableUnits): self.AvailableUnits = AvailableUnits
    def export(self, outfile, level, namespace_='', name_='AvailabilityPeriod', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='AvailabilityPeriod')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='AvailabilityPeriod'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='AvailabilityPeriod'):
        if self.AvailableFrom is not None:
            showIndent(outfile, level)
            outfile.write('<%sAvailableFrom>%s</%sAvailableFrom>\n' % (namespace_, self.format_string(quote_xml(self.AvailableFrom), input_name='AvailableFrom'), namespace_))
        if self.AvailableTo is not None:
            showIndent(outfile, level)
            outfile.write('<%sAvailableTo>%s</%sAvailableTo>\n' % (namespace_, self.format_string(quote_xml(self.AvailableTo), input_name='AvailableTo'), namespace_))
        if self.AvailableUnits is not None:
            showIndent(outfile, level)
            outfile.write('<%sAvailableUnits>%s</%sAvailableUnits>\n' % (namespace_, self.format_string(quote_xml(self.AvailableUnits), input_name='AvailableUnits'), namespace_))
    def hasContent_(self):
        if (
            self.AvailableFrom is not None or
            self.AvailableTo is not None or
            self.AvailableUnits is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='AvailabilityPeriod'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.AvailableFrom is not None:
            showIndent(outfile, level)
            outfile.write('AvailableFrom=%s,\n' % quote_python(self.AvailableFrom))
        if self.AvailableTo is not None:
            showIndent(outfile, level)
            outfile.write('AvailableTo=%s,\n' % quote_python(self.AvailableTo))
        if self.AvailableUnits is not None:
            showIndent(outfile, level)
            outfile.write('AvailableUnits=%s,\n' % quote_python(self.AvailableUnits))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailableFrom':
            AvailableFrom_ = ''
            for text__content_ in child_.childNodes:
                AvailableFrom_ += text__content_.nodeValue
            self.AvailableFrom = AvailableFrom_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailableTo':
            AvailableTo_ = ''
            for text__content_ in child_.childNodes:
                AvailableTo_ += text__content_.nodeValue
            self.AvailableTo = AvailableTo_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'AvailableUnits':
            AvailableUnits_ = ''
            for text__content_ in child_.childNodes:
                AvailableUnits_ += text__content_.nodeValue
            self.AvailableUnits = AvailableUnits_
# end class AvailabilityPeriod


class Rates(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Rate=None):
        if Rate is None:
            self.Rate = []
        else:
            self.Rate = Rate
    def factory(*args_, **kwargs_):
        if Rates.subclass:
            return Rates.subclass(*args_, **kwargs_)
        else:
            return Rates(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Rate(self): return self.Rate
    def set_Rate(self, Rate): self.Rate = Rate
    def add_Rate(self, value): self.Rate.append(value)
    def insert_Rate(self, index, value): self.Rate[index] = value
    def export(self, outfile, level, namespace_='', name_='Rates', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Rates')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Rates'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Rates'):
        for Rate_ in self.Rate:
            Rate_.export(outfile, level, namespace_, name_='Rate')
    def hasContent_(self):
        if (
            self.Rate
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Rates'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Rate=[\n')
        level += 1
        for Rate_ in self.Rate:
            showIndent(outfile, level)
            outfile.write('model_.Rate(\n')
            Rate_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Rate':
            obj_ = Rate.factory()
            obj_.build(child_)
            self.Rate.append(obj_)
# end class Rates


class Rate(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, RatesFrom=None, RatesTo=None, RateTable=None, StandardRate=None, StandardRateFormat=None, OvertimeRate=None, OvertimeRateFormat=None, CostPerUse=None):
        self.RatesFrom = RatesFrom
        self.RatesTo = RatesTo
        self.RateTable = RateTable
        self.StandardRate = StandardRate
        self.StandardRateFormat = StandardRateFormat
        self.OvertimeRate = OvertimeRate
        self.OvertimeRateFormat = OvertimeRateFormat
        self.CostPerUse = CostPerUse
    def factory(*args_, **kwargs_):
        if Rate.subclass:
            return Rate.subclass(*args_, **kwargs_)
        else:
            return Rate(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_RatesFrom(self): return self.RatesFrom
    def set_RatesFrom(self, RatesFrom): self.RatesFrom = RatesFrom
    def get_RatesTo(self): return self.RatesTo
    def set_RatesTo(self, RatesTo): self.RatesTo = RatesTo
    def get_RateTable(self): return self.RateTable
    def set_RateTable(self, RateTable): self.RateTable = RateTable
    def validate_RateTable(self, value):
        # Validate type RateTable, a restriction on xsd:integer.
        pass
    def get_StandardRate(self): return self.StandardRate
    def set_StandardRate(self, StandardRate): self.StandardRate = StandardRate
    def get_StandardRateFormat(self): return self.StandardRateFormat
    def set_StandardRateFormat(self, StandardRateFormat): self.StandardRateFormat = StandardRateFormat
    def validate_StandardRateFormat(self, value):
        # Validate type StandardRateFormat, a restriction on xsd:integer.
        pass
    def get_OvertimeRate(self): return self.OvertimeRate
    def set_OvertimeRate(self, OvertimeRate): self.OvertimeRate = OvertimeRate
    def get_OvertimeRateFormat(self): return self.OvertimeRateFormat
    def set_OvertimeRateFormat(self, OvertimeRateFormat): self.OvertimeRateFormat = OvertimeRateFormat
    def validate_OvertimeRateFormat(self, value):
        # Validate type OvertimeRateFormat, a restriction on xsd:integer.
        pass
    def get_CostPerUse(self): return self.CostPerUse
    def set_CostPerUse(self, CostPerUse): self.CostPerUse = CostPerUse
    def export(self, outfile, level, namespace_='', name_='Rate', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Rate')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Rate'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Rate'):
        if self.RatesFrom is not None:
            showIndent(outfile, level)
            outfile.write('<%sRatesFrom>%s</%sRatesFrom>\n' % (namespace_, self.format_string(quote_xml(self.RatesFrom), input_name='RatesFrom'), namespace_))
        if self.RatesTo is not None:
            showIndent(outfile, level)
            outfile.write('<%sRatesTo>%s</%sRatesTo>\n' % (namespace_, self.format_string(quote_xml(self.RatesTo), input_name='RatesTo'), namespace_))
        if self.RateTable is not None:
            showIndent(outfile, level)
            outfile.write('<%sRateTable>%s</%sRateTable>\n' % (namespace_, self.format_string(quote_xml(self.RateTable), input_name='RateTable'), namespace_))
        if self.StandardRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sStandardRate>%s</%sStandardRate>\n' % (namespace_, self.format_string(quote_xml(self.StandardRate), input_name='StandardRate'), namespace_))
        if self.StandardRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sStandardRateFormat>%s</%sStandardRateFormat>\n' % (namespace_, self.format_string(quote_xml(self.StandardRateFormat), input_name='StandardRateFormat'), namespace_))
        if self.OvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeRate>%s</%sOvertimeRate>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeRate), input_name='OvertimeRate'), namespace_))
        if self.OvertimeRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeRateFormat>%s</%sOvertimeRateFormat>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeRateFormat), input_name='OvertimeRateFormat'), namespace_))
        if self.CostPerUse is not None:
            showIndent(outfile, level)
            outfile.write('<%sCostPerUse>%s</%sCostPerUse>\n' % (namespace_, self.format_string(quote_xml(self.CostPerUse), input_name='CostPerUse'), namespace_))
    def hasContent_(self):
        if (
            self.RatesFrom is not None or
            self.RatesTo is not None or
            self.RateTable is not None or
            self.StandardRate is not None or
            self.StandardRateFormat is not None or
            self.OvertimeRate is not None or
            self.OvertimeRateFormat is not None or
            self.CostPerUse is not None
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Rate'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.RatesFrom is not None:
            showIndent(outfile, level)
            outfile.write('RatesFrom=%s,\n' % quote_python(self.RatesFrom))
        if self.RatesTo is not None:
            showIndent(outfile, level)
            outfile.write('RatesTo=%s,\n' % quote_python(self.RatesTo))
        if self.RateTable is not None:
            showIndent(outfile, level)
            outfile.write('RateTable=%s,\n' % quote_python(self.RateTable))
        if self.StandardRate is not None:
            showIndent(outfile, level)
            outfile.write('StandardRate=%s,\n' % quote_python(self.StandardRate))
        if self.StandardRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('StandardRateFormat=%s,\n' % quote_python(self.StandardRateFormat))
        if self.OvertimeRate is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeRate=%s,\n' % quote_python(self.OvertimeRate))
        if self.OvertimeRateFormat is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeRateFormat=%s,\n' % quote_python(self.OvertimeRateFormat))
        if self.CostPerUse is not None:
            showIndent(outfile, level)
            outfile.write('CostPerUse=%s,\n' % quote_python(self.CostPerUse))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RatesFrom':
            RatesFrom_ = ''
            for text__content_ in child_.childNodes:
                RatesFrom_ += text__content_.nodeValue
            self.RatesFrom = RatesFrom_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RatesTo':
            RatesTo_ = ''
            for text__content_ in child_.childNodes:
                RatesTo_ += text__content_.nodeValue
            self.RatesTo = RatesTo_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RateTable':
            RateTable_ = ''
            for text__content_ in child_.childNodes:
                RateTable_ += text__content_.nodeValue
            self.RateTable = RateTable_
            self.validate_RateTable(self.RateTable)    # validate type RateTable
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StandardRate':
            StandardRate_ = ''
            for text__content_ in child_.childNodes:
                StandardRate_ += text__content_.nodeValue
            self.StandardRate = StandardRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StandardRateFormat':
            StandardRateFormat_ = ''
            for text__content_ in child_.childNodes:
                StandardRateFormat_ += text__content_.nodeValue
            self.StandardRateFormat = StandardRateFormat_
            self.validate_StandardRateFormat(self.StandardRateFormat)    # validate type StandardRateFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeRate':
            OvertimeRate_ = ''
            for text__content_ in child_.childNodes:
                OvertimeRate_ += text__content_.nodeValue
            self.OvertimeRate = OvertimeRate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeRateFormat':
            OvertimeRateFormat_ = ''
            for text__content_ in child_.childNodes:
                OvertimeRateFormat_ += text__content_.nodeValue
            self.OvertimeRateFormat = OvertimeRateFormat_
            self.validate_OvertimeRateFormat(self.OvertimeRateFormat)    # validate type OvertimeRateFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CostPerUse':
            CostPerUse_ = ''
            for text__content_ in child_.childNodes:
                CostPerUse_ += text__content_.nodeValue
            self.CostPerUse = CostPerUse_
# end class Rate


class RateTable(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if RateTable.subclass:
            return RateTable.subclass(*args_, **kwargs_)
        else:
            return RateTable(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='RateTable', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='RateTable')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='RateTable'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='RateTable'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='RateTable'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class RateTable


class Assignments(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, Assignment=None):
        if Assignment is None:
            self.Assignment = []
        else:
            self.Assignment = Assignment
    def factory(*args_, **kwargs_):
        if Assignments.subclass:
            return Assignments.subclass(*args_, **kwargs_)
        else:
            return Assignments(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_Assignment(self): return self.Assignment
    def set_Assignment(self, Assignment): self.Assignment = Assignment
    def add_Assignment(self, value): self.Assignment.append(value)
    def insert_Assignment(self, index, value): self.Assignment[index] = value
    def export(self, outfile, level, namespace_='', name_='Assignments', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Assignments')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Assignments'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Assignments'):
        for Assignment_ in self.Assignment:
            Assignment_.export(outfile, level, namespace_, name_='Assignment')
    def hasContent_(self):
        if (
            self.Assignment
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Assignments'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('Assignment=[\n')
        level += 1
        for Assignment_ in self.Assignment:
            showIndent(outfile, level)
            outfile.write('model_.Assignment(\n')
            Assignment_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Assignment':
            obj_ = Assignment.factory()
            obj_.build(child_)
            self.Assignment.append(obj_)
# end class Assignments


class Assignment(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, UID=None, TaskUID=None, ResourceUID=None, PercentWorkComplete=None, ActualCost=None, ActualFinish=None, ActualOvertimeCost=None, ActualOvertimeWork=None, ActualStart=None, ActualWork=None, ACWP=None, Confirmed=None, Cost=None, CostRateTable=None, CostVariance=None, CV=None, Delay=None, Finish=None, FinishVariance=None, Hyperlink=None, HyperlinkAddress=None, HyperlinkSubAddress=None, WorkVariance=None, HasFixedRateUnits=None, FixedMaterial=None, LevelingDelay=None, LevelingDelayFormat=None, LinkedFields=None, Milestone=None, Notes=None, Overallocated=None, OvertimeCost=None, OvertimeWork=None, RegularWork=None, RemainingCost=None, RemainingOvertimeCost=None, RemainingOvertimeWork=None, RemainingWork=None, ResponsePending=None, Start=None, Stop=None, Resume=None, StartVariance=None, Units=None, UpdateNeeded=None, VAC=None, Work=None, WorkContour=None, BCWS=None, BCWP=None, BookingType=None, ActualWorkProtected=None, ActualOvertimeWorkProtected=None, CreationDate=None, ExtendedAttribute=None, Baseline=None, TimephasedData=None):
        self.UID = UID
        self.TaskUID = TaskUID
        self.ResourceUID = ResourceUID
        self.PercentWorkComplete = PercentWorkComplete
        self.ActualCost = ActualCost
        self.ActualFinish = ActualFinish
        self.ActualOvertimeCost = ActualOvertimeCost
        self.ActualOvertimeWork = ActualOvertimeWork
        self.ActualStart = ActualStart
        self.ActualWork = ActualWork
        self.ACWP = ACWP
        self.Confirmed = Confirmed
        self.Cost = Cost
        self.CostRateTable = CostRateTable
        self.CostVariance = CostVariance
        self.CV = CV
        self.Delay = Delay
        self.Finish = Finish
        self.FinishVariance = FinishVariance
        self.Hyperlink = Hyperlink
        self.HyperlinkAddress = HyperlinkAddress
        self.HyperlinkSubAddress = HyperlinkSubAddress
        self.WorkVariance = WorkVariance
        self.HasFixedRateUnits = HasFixedRateUnits
        self.FixedMaterial = FixedMaterial
        self.LevelingDelay = LevelingDelay
        self.LevelingDelayFormat = LevelingDelayFormat
        self.LinkedFields = LinkedFields
        self.Milestone = Milestone
        self.Notes = Notes
        self.Overallocated = Overallocated
        self.OvertimeCost = OvertimeCost
        self.OvertimeWork = OvertimeWork
        self.RegularWork = RegularWork
        self.RemainingCost = RemainingCost
        self.RemainingOvertimeCost = RemainingOvertimeCost
        self.RemainingOvertimeWork = RemainingOvertimeWork
        self.RemainingWork = RemainingWork
        self.ResponsePending = ResponsePending
        self.Start = Start
        self.Stop = Stop
        self.Resume = Resume
        self.StartVariance = StartVariance
        self.Units = Units
        self.UpdateNeeded = UpdateNeeded
        self.VAC = VAC
        self.Work = Work
        self.WorkContour = WorkContour
        self.BCWS = BCWS
        self.BCWP = BCWP
        self.BookingType = BookingType
        self.ActualWorkProtected = ActualWorkProtected
        self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
        self.CreationDate = CreationDate
        if ExtendedAttribute is None:
            self.ExtendedAttribute = []
        else:
            self.ExtendedAttribute = ExtendedAttribute
        if Baseline is None:
            self.Baseline = []
        else:
            self.Baseline = Baseline
        if TimephasedData is None:
            self.TimephasedData = []
        else:
            self.TimephasedData = TimephasedData
    def factory(*args_, **kwargs_):
        if Assignment.subclass:
            return Assignment.subclass(*args_, **kwargs_)
        else:
            return Assignment(*args_, **kwargs_)
    factory = staticmethod(factory)
    def get_UID(self): return self.UID
    def set_UID(self, UID): self.UID = UID
    def get_TaskUID(self): return self.TaskUID
    def set_TaskUID(self, TaskUID): self.TaskUID = TaskUID
    def get_ResourceUID(self): return self.ResourceUID
    def set_ResourceUID(self, ResourceUID): self.ResourceUID = ResourceUID
    def get_PercentWorkComplete(self): return self.PercentWorkComplete
    def set_PercentWorkComplete(self, PercentWorkComplete): self.PercentWorkComplete = PercentWorkComplete
    def get_ActualCost(self): return self.ActualCost
    def set_ActualCost(self, ActualCost): self.ActualCost = ActualCost
    def get_ActualFinish(self): return self.ActualFinish
    def set_ActualFinish(self, ActualFinish): self.ActualFinish = ActualFinish
    def get_ActualOvertimeCost(self): return self.ActualOvertimeCost
    def set_ActualOvertimeCost(self, ActualOvertimeCost): self.ActualOvertimeCost = ActualOvertimeCost
    def get_ActualOvertimeWork(self): return self.ActualOvertimeWork
    def set_ActualOvertimeWork(self, ActualOvertimeWork): self.ActualOvertimeWork = ActualOvertimeWork
    def get_ActualStart(self): return self.ActualStart
    def set_ActualStart(self, ActualStart): self.ActualStart = ActualStart
    def get_ActualWork(self): return self.ActualWork
    def set_ActualWork(self, ActualWork): self.ActualWork = ActualWork
    def get_ACWP(self): return self.ACWP
    def set_ACWP(self, ACWP): self.ACWP = ACWP
    def get_Confirmed(self): return self.Confirmed
    def set_Confirmed(self, Confirmed): self.Confirmed = Confirmed
    def get_Cost(self): return self.Cost
    def set_Cost(self, Cost): self.Cost = Cost
    def get_CostRateTable(self): return self.CostRateTable
    def set_CostRateTable(self, CostRateTable): self.CostRateTable = CostRateTable
    def validate_CostRateTable(self, value):
        # Validate type CostRateTable, a restriction on xsd:integer.
        pass
    def get_CostVariance(self): return self.CostVariance
    def set_CostVariance(self, CostVariance): self.CostVariance = CostVariance
    def get_CV(self): return self.CV
    def set_CV(self, CV): self.CV = CV
    def get_Delay(self): return self.Delay
    def set_Delay(self, Delay): self.Delay = Delay
    def get_Finish(self): return self.Finish
    def set_Finish(self, Finish): self.Finish = Finish
    def get_FinishVariance(self): return self.FinishVariance
    def set_FinishVariance(self, FinishVariance): self.FinishVariance = FinishVariance
    def get_Hyperlink(self): return self.Hyperlink
    def set_Hyperlink(self, Hyperlink): self.Hyperlink = Hyperlink
    def validate_Hyperlink(self, value):
        # Validate type Hyperlink, a restriction on xsd:string.
        pass
    def get_HyperlinkAddress(self): return self.HyperlinkAddress
    def set_HyperlinkAddress(self, HyperlinkAddress): self.HyperlinkAddress = HyperlinkAddress
    def validate_HyperlinkAddress(self, value):
        # Validate type HyperlinkAddress, a restriction on xsd:string.
        pass
    def get_HyperlinkSubAddress(self): return self.HyperlinkSubAddress
    def set_HyperlinkSubAddress(self, HyperlinkSubAddress): self.HyperlinkSubAddress = HyperlinkSubAddress
    def validate_HyperlinkSubAddress(self, value):
        # Validate type HyperlinkSubAddress, a restriction on xsd:string.
        pass
    def get_WorkVariance(self): return self.WorkVariance
    def set_WorkVariance(self, WorkVariance): self.WorkVariance = WorkVariance
    def get_HasFixedRateUnits(self): return self.HasFixedRateUnits
    def set_HasFixedRateUnits(self, HasFixedRateUnits): self.HasFixedRateUnits = HasFixedRateUnits
    def get_FixedMaterial(self): return self.FixedMaterial
    def set_FixedMaterial(self, FixedMaterial): self.FixedMaterial = FixedMaterial
    def get_LevelingDelay(self): return self.LevelingDelay
    def set_LevelingDelay(self, LevelingDelay): self.LevelingDelay = LevelingDelay
    def get_LevelingDelayFormat(self): return self.LevelingDelayFormat
    def set_LevelingDelayFormat(self, LevelingDelayFormat): self.LevelingDelayFormat = LevelingDelayFormat
    def validate_LevelingDelayFormat(self, value):
        # Validate type LevelingDelayFormat, a restriction on xsd:integer.
        pass
    def get_LinkedFields(self): return self.LinkedFields
    def set_LinkedFields(self, LinkedFields): self.LinkedFields = LinkedFields
    def get_Milestone(self): return self.Milestone
    def set_Milestone(self, Milestone): self.Milestone = Milestone
    def get_Notes(self): return self.Notes
    def set_Notes(self, Notes): self.Notes = Notes
    def get_Overallocated(self): return self.Overallocated
    def set_Overallocated(self, Overallocated): self.Overallocated = Overallocated
    def get_OvertimeCost(self): return self.OvertimeCost
    def set_OvertimeCost(self, OvertimeCost): self.OvertimeCost = OvertimeCost
    def get_OvertimeWork(self): return self.OvertimeWork
    def set_OvertimeWork(self, OvertimeWork): self.OvertimeWork = OvertimeWork
    def get_RegularWork(self): return self.RegularWork
    def set_RegularWork(self, RegularWork): self.RegularWork = RegularWork
    def get_RemainingCost(self): return self.RemainingCost
    def set_RemainingCost(self, RemainingCost): self.RemainingCost = RemainingCost
    def get_RemainingOvertimeCost(self): return self.RemainingOvertimeCost
    def set_RemainingOvertimeCost(self, RemainingOvertimeCost): self.RemainingOvertimeCost = RemainingOvertimeCost
    def get_RemainingOvertimeWork(self): return self.RemainingOvertimeWork
    def set_RemainingOvertimeWork(self, RemainingOvertimeWork): self.RemainingOvertimeWork = RemainingOvertimeWork
    def get_RemainingWork(self): return self.RemainingWork
    def set_RemainingWork(self, RemainingWork): self.RemainingWork = RemainingWork
    def get_ResponsePending(self): return self.ResponsePending
    def set_ResponsePending(self, ResponsePending): self.ResponsePending = ResponsePending
    def get_Start(self): return self.Start
    def set_Start(self, Start): self.Start = Start
    def get_Stop(self): return self.Stop
    def set_Stop(self, Stop): self.Stop = Stop
    def get_Resume(self): return self.Resume
    def set_Resume(self, Resume): self.Resume = Resume
    def get_StartVariance(self): return self.StartVariance
    def set_StartVariance(self, StartVariance): self.StartVariance = StartVariance
    def get_Units(self): return self.Units
    def set_Units(self, Units): self.Units = Units
    def get_UpdateNeeded(self): return self.UpdateNeeded
    def set_UpdateNeeded(self, UpdateNeeded): self.UpdateNeeded = UpdateNeeded
    def get_VAC(self): return self.VAC
    def set_VAC(self, VAC): self.VAC = VAC
    def get_Work(self): return self.Work
    def set_Work(self, Work): self.Work = Work
    def get_WorkContour(self): return self.WorkContour
    def set_WorkContour(self, WorkContour): self.WorkContour = WorkContour
    def validate_WorkContour(self, value):
        # Validate type WorkContour, a restriction on xsd:integer.
        pass
    def get_BCWS(self): return self.BCWS
    def set_BCWS(self, BCWS): self.BCWS = BCWS
    def get_BCWP(self): return self.BCWP
    def set_BCWP(self, BCWP): self.BCWP = BCWP
    def get_BookingType(self): return self.BookingType
    def set_BookingType(self, BookingType): self.BookingType = BookingType
    def validate_BookingType(self, value):
        # Validate type BookingType, a restriction on xsd:integer.
        pass
    def get_ActualWorkProtected(self): return self.ActualWorkProtected
    def set_ActualWorkProtected(self, ActualWorkProtected): self.ActualWorkProtected = ActualWorkProtected
    def get_ActualOvertimeWorkProtected(self): return self.ActualOvertimeWorkProtected
    def set_ActualOvertimeWorkProtected(self, ActualOvertimeWorkProtected): self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected
    def get_CreationDate(self): return self.CreationDate
    def set_CreationDate(self, CreationDate): self.CreationDate = CreationDate
    def get_ExtendedAttribute(self): return self.ExtendedAttribute
    def set_ExtendedAttribute(self, ExtendedAttribute): self.ExtendedAttribute = ExtendedAttribute
    def add_ExtendedAttribute(self, value): self.ExtendedAttribute.append(value)
    def insert_ExtendedAttribute(self, index, value): self.ExtendedAttribute[index] = value
    def get_Baseline(self): return self.Baseline
    def set_Baseline(self, Baseline): self.Baseline = Baseline
    def add_Baseline(self, value): self.Baseline.append(value)
    def insert_Baseline(self, index, value): self.Baseline[index] = value
    def get_TimephasedData(self): return self.TimephasedData
    def set_TimephasedData(self, TimephasedData): self.TimephasedData = TimephasedData
    def add_TimephasedData(self, value): self.TimephasedData.append(value)
    def insert_TimephasedData(self, index, value): self.TimephasedData[index] = value
    def export(self, outfile, level, namespace_='', name_='Assignment', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='Assignment')
        if self.hasContent_():
            outfile.write('>\n')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            showIndent(outfile, level)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='Assignment'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='Assignment'):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('<%sUID>%s</%sUID>\n' % (namespace_, self.format_string(quote_xml(self.UID), input_name='UID'), namespace_))
        if self.TaskUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sTaskUID>%s</%sTaskUID>\n' % (namespace_, self.format_string(quote_xml(self.TaskUID), input_name='TaskUID'), namespace_))
        if self.ResourceUID is not None:
            showIndent(outfile, level)
            outfile.write('<%sResourceUID>%s</%sResourceUID>\n' % (namespace_, self.format_string(quote_xml(self.ResourceUID), input_name='ResourceUID'), namespace_))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('<%sPercentWorkComplete>%s</%sPercentWorkComplete>\n' % (namespace_, self.format_string(quote_xml(self.PercentWorkComplete), input_name='PercentWorkComplete'), namespace_))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualCost>%s</%sActualCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualCost), input_name='ActualCost'), namespace_))
        if self.ActualFinish is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualFinish>%s</%sActualFinish>\n' % (namespace_, self.format_string(quote_xml(self.ActualFinish), input_name='ActualFinish'), namespace_))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeCost>%s</%sActualOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeCost), input_name='ActualOvertimeCost'), namespace_))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWork>%s</%sActualOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWork), input_name='ActualOvertimeWork'), namespace_))
        if self.ActualStart is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualStart>%s</%sActualStart>\n' % (namespace_, self.format_string(quote_xml(self.ActualStart), input_name='ActualStart'), namespace_))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWork>%s</%sActualWork>\n' % (namespace_, self.format_string(quote_xml(self.ActualWork), input_name='ActualWork'), namespace_))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sACWP>%s</%sACWP>\n' % (namespace_, self.format_string(quote_xml(self.ACWP), input_name='ACWP'), namespace_))
        if self.Confirmed is not None:
            showIndent(outfile, level)
            outfile.write('<%sConfirmed>%s</%sConfirmed>\n' % (namespace_, self.format_string(quote_xml(self.Confirmed), input_name='Confirmed'), namespace_))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('<%sCost>%s</%sCost>\n' % (namespace_, self.format_string(quote_xml(self.Cost), input_name='Cost'), namespace_))
        if self.CostRateTable is not None:
            showIndent(outfile, level)
            outfile.write('<%sCostRateTable>%s</%sCostRateTable>\n' % (namespace_, self.format_string(quote_xml(self.CostRateTable), input_name='CostRateTable'), namespace_))
        if self.CostVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sCostVariance>%s</%sCostVariance>\n' % (namespace_, self.format_string(quote_xml(self.CostVariance), input_name='CostVariance'), namespace_))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('<%sCV>%s</%sCV>\n' % (namespace_, self.format_string(quote_xml(self.CV), input_name='CV'), namespace_))
        if self.Delay is not None:
            showIndent(outfile, level)
            outfile.write('<%sDelay>%s</%sDelay>\n' % (namespace_, self.format_string(quote_xml(self.Delay), input_name='Delay'), namespace_))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinish>%s</%sFinish>\n' % (namespace_, self.format_string(quote_xml(self.Finish), input_name='Finish'), namespace_))
        if self.FinishVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sFinishVariance>%s</%sFinishVariance>\n' % (namespace_, self.format_string(quote_xml(self.FinishVariance), input_name='FinishVariance'), namespace_))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlink>%s</%sHyperlink>\n' % (namespace_, self.format_string(quote_xml(self.Hyperlink), input_name='Hyperlink'), namespace_))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkAddress>%s</%sHyperlinkAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkAddress), input_name='HyperlinkAddress'), namespace_))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('<%sHyperlinkSubAddress>%s</%sHyperlinkSubAddress>\n' % (namespace_, self.format_string(quote_xml(self.HyperlinkSubAddress), input_name='HyperlinkSubAddress'), namespace_))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkVariance>%s</%sWorkVariance>\n' % (namespace_, self.format_string(quote_xml(self.WorkVariance), input_name='WorkVariance'), namespace_))
        if self.HasFixedRateUnits is not None:
            showIndent(outfile, level)
            outfile.write('<%sHasFixedRateUnits>%s</%sHasFixedRateUnits>\n' % (namespace_, self.format_string(quote_xml(self.HasFixedRateUnits), input_name='HasFixedRateUnits'), namespace_))
        if self.FixedMaterial is not None:
            showIndent(outfile, level)
            outfile.write('<%sFixedMaterial>%s</%sFixedMaterial>\n' % (namespace_, self.format_string(quote_xml(self.FixedMaterial), input_name='FixedMaterial'), namespace_))
        if self.LevelingDelay is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelingDelay>%s</%sLevelingDelay>\n' % (namespace_, self.format_string(quote_xml(self.LevelingDelay), input_name='LevelingDelay'), namespace_))
        if self.LevelingDelayFormat is not None:
            showIndent(outfile, level)
            outfile.write('<%sLevelingDelayFormat>%s</%sLevelingDelayFormat>\n' % (namespace_, self.format_string(quote_xml(self.LevelingDelayFormat), input_name='LevelingDelayFormat'), namespace_))
        if self.LinkedFields is not None:
            showIndent(outfile, level)
            outfile.write('<%sLinkedFields>%s</%sLinkedFields>\n' % (namespace_, self.format_string(quote_xml(self.LinkedFields), input_name='LinkedFields'), namespace_))
        if self.Milestone is not None:
            showIndent(outfile, level)
            outfile.write('<%sMilestone>%s</%sMilestone>\n' % (namespace_, self.format_string(quote_xml(self.Milestone), input_name='Milestone'), namespace_))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('<%sNotes>%s</%sNotes>\n' % (namespace_, self.format_string(quote_xml(self.Notes), input_name='Notes'), namespace_))
        if self.Overallocated is not None:
            showIndent(outfile, level)
            outfile.write('<%sOverallocated>%s</%sOverallocated>\n' % (namespace_, self.format_string(quote_xml(self.Overallocated), input_name='Overallocated'), namespace_))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeCost>%s</%sOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeCost), input_name='OvertimeCost'), namespace_))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sOvertimeWork>%s</%sOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.OvertimeWork), input_name='OvertimeWork'), namespace_))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRegularWork>%s</%sRegularWork>\n' % (namespace_, self.format_string(quote_xml(self.RegularWork), input_name='RegularWork'), namespace_))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingCost>%s</%sRemainingCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingCost), input_name='RemainingCost'), namespace_))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeCost>%s</%sRemainingOvertimeCost>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeCost), input_name='RemainingOvertimeCost'), namespace_))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingOvertimeWork>%s</%sRemainingOvertimeWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingOvertimeWork), input_name='RemainingOvertimeWork'), namespace_))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('<%sRemainingWork>%s</%sRemainingWork>\n' % (namespace_, self.format_string(quote_xml(self.RemainingWork), input_name='RemainingWork'), namespace_))
        if self.ResponsePending is not None:
            showIndent(outfile, level)
            outfile.write('<%sResponsePending>%s</%sResponsePending>\n' % (namespace_, self.format_string(quote_xml(self.ResponsePending), input_name='ResponsePending'), namespace_))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('<%sStart>%s</%sStart>\n' % (namespace_, self.format_string(quote_xml(self.Start), input_name='Start'), namespace_))
        if self.Stop is not None:
            showIndent(outfile, level)
            outfile.write('<%sStop>%s</%sStop>\n' % (namespace_, self.format_string(quote_xml(self.Stop), input_name='Stop'), namespace_))
        if self.Resume is not None:
            showIndent(outfile, level)
            outfile.write('<%sResume>%s</%sResume>\n' % (namespace_, self.format_string(quote_xml(self.Resume), input_name='Resume'), namespace_))
        if self.StartVariance is not None:
            showIndent(outfile, level)
            outfile.write('<%sStartVariance>%s</%sStartVariance>\n' % (namespace_, self.format_string(quote_xml(self.StartVariance), input_name='StartVariance'), namespace_))
        if self.Units is not None:
            showIndent(outfile, level)
            outfile.write('<%sUnits>%s</%sUnits>\n' % (namespace_, self.format_string(quote_xml(self.Units), input_name='Units'), namespace_))
        if self.UpdateNeeded is not None:
            showIndent(outfile, level)
            outfile.write('<%sUpdateNeeded>%s</%sUpdateNeeded>\n' % (namespace_, self.format_string(quote_xml(self.UpdateNeeded), input_name='UpdateNeeded'), namespace_))
        if self.VAC is not None:
            showIndent(outfile, level)
            outfile.write('<%sVAC>%s</%sVAC>\n' % (namespace_, self.format_string(quote_xml(self.VAC), input_name='VAC'), namespace_))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('<%sWork>%s</%sWork>\n' % (namespace_, self.format_string(quote_xml(self.Work), input_name='Work'), namespace_))
        if self.WorkContour is not None:
            showIndent(outfile, level)
            outfile.write('<%sWorkContour>%s</%sWorkContour>\n' % (namespace_, self.format_string(quote_xml(self.WorkContour), input_name='WorkContour'), namespace_))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWS>%s</%sBCWS>\n' % (namespace_, self.format_string(quote_xml(self.BCWS), input_name='BCWS'), namespace_))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('<%sBCWP>%s</%sBCWP>\n' % (namespace_, self.format_string(quote_xml(self.BCWP), input_name='BCWP'), namespace_))
        if self.BookingType is not None:
            showIndent(outfile, level)
            outfile.write('<%sBookingType>%s</%sBookingType>\n' % (namespace_, self.format_string(quote_xml(self.BookingType), input_name='BookingType'), namespace_))
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualWorkProtected>%s</%sActualWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualWorkProtected), input_name='ActualWorkProtected'), namespace_))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('<%sActualOvertimeWorkProtected>%s</%sActualOvertimeWorkProtected>\n' % (namespace_, self.format_string(quote_xml(self.ActualOvertimeWorkProtected), input_name='ActualOvertimeWorkProtected'), namespace_))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('<%sCreationDate>%s</%sCreationDate>\n' % (namespace_, self.format_string(quote_xml(self.CreationDate), input_name='CreationDate'), namespace_))
        for ExtendedAttribute_ in self.ExtendedAttribute:
            ExtendedAttribute_.export(outfile, level, namespace_, name_='ExtendedAttribute')
        for Baseline_ in self.Baseline:
            Baseline_.export(outfile, level, namespace_, name_='Baseline')
        for TimephasedData_ in self.TimephasedData:
            TimephasedData_.export(outfile, level, namespace_, name_='TimephasedData')
    def hasContent_(self):
        if (
            self.UID is not None or
            self.TaskUID is not None or
            self.ResourceUID is not None or
            self.PercentWorkComplete is not None or
            self.ActualCost is not None or
            self.ActualFinish is not None or
            self.ActualOvertimeCost is not None or
            self.ActualOvertimeWork is not None or
            self.ActualStart is not None or
            self.ActualWork is not None or
            self.ACWP is not None or
            self.Confirmed is not None or
            self.Cost is not None or
            self.CostRateTable is not None or
            self.CostVariance is not None or
            self.CV is not None or
            self.Delay is not None or
            self.Finish is not None or
            self.FinishVariance is not None or
            self.Hyperlink is not None or
            self.HyperlinkAddress is not None or
            self.HyperlinkSubAddress is not None or
            self.WorkVariance is not None or
            self.HasFixedRateUnits is not None or
            self.FixedMaterial is not None or
            self.LevelingDelay is not None or
            self.LevelingDelayFormat is not None or
            self.LinkedFields is not None or
            self.Milestone is not None or
            self.Notes is not None or
            self.Overallocated is not None or
            self.OvertimeCost is not None or
            self.OvertimeWork is not None or
            self.RegularWork is not None or
            self.RemainingCost is not None or
            self.RemainingOvertimeCost is not None or
            self.RemainingOvertimeWork is not None or
            self.RemainingWork is not None or
            self.ResponsePending is not None or
            self.Start is not None or
            self.Stop is not None or
            self.Resume is not None or
            self.StartVariance is not None or
            self.Units is not None or
            self.UpdateNeeded is not None or
            self.VAC is not None or
            self.Work is not None or
            self.WorkContour is not None or
            self.BCWS is not None or
            self.BCWP is not None or
            self.BookingType is not None or
            self.ActualWorkProtected is not None or
            self.ActualOvertimeWorkProtected is not None or
            self.CreationDate is not None or
            self.ExtendedAttribute or
            self.Baseline or
            self.TimephasedData
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='Assignment'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        if self.UID is not None:
            showIndent(outfile, level)
            outfile.write('UID=%s,\n' % quote_python(self.UID))
        if self.TaskUID is not None:
            showIndent(outfile, level)
            outfile.write('TaskUID=%s,\n' % quote_python(self.TaskUID))
        if self.ResourceUID is not None:
            showIndent(outfile, level)
            outfile.write('ResourceUID=%s,\n' % quote_python(self.ResourceUID))
        if self.PercentWorkComplete is not None:
            showIndent(outfile, level)
            outfile.write('PercentWorkComplete=%s,\n' % quote_python(self.PercentWorkComplete))
        if self.ActualCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualCost=%s,\n' % quote_python(self.ActualCost))
        if self.ActualFinish is not None:
            showIndent(outfile, level)
            outfile.write('ActualFinish=%s,\n' % quote_python(self.ActualFinish))
        if self.ActualOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeCost=%s,\n' % quote_python(self.ActualOvertimeCost))
        if self.ActualOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWork=%s,\n' % quote_python(self.ActualOvertimeWork))
        if self.ActualStart is not None:
            showIndent(outfile, level)
            outfile.write('ActualStart=%s,\n' % quote_python(self.ActualStart))
        if self.ActualWork is not None:
            showIndent(outfile, level)
            outfile.write('ActualWork=%s,\n' % quote_python(self.ActualWork))
        if self.ACWP is not None:
            showIndent(outfile, level)
            outfile.write('ACWP=%s,\n' % quote_python(self.ACWP))
        if self.Confirmed is not None:
            showIndent(outfile, level)
            outfile.write('Confirmed=%s,\n' % quote_python(self.Confirmed))
        if self.Cost is not None:
            showIndent(outfile, level)
            outfile.write('Cost=%s,\n' % quote_python(self.Cost))
        if self.CostRateTable is not None:
            showIndent(outfile, level)
            outfile.write('CostRateTable=%s,\n' % quote_python(self.CostRateTable))
        if self.CostVariance is not None:
            showIndent(outfile, level)
            outfile.write('CostVariance=%s,\n' % quote_python(self.CostVariance))
        if self.CV is not None:
            showIndent(outfile, level)
            outfile.write('CV=%s,\n' % quote_python(self.CV))
        if self.Delay is not None:
            showIndent(outfile, level)
            outfile.write('Delay=%s,\n' % quote_python(self.Delay))
        if self.Finish is not None:
            showIndent(outfile, level)
            outfile.write('Finish=%s,\n' % quote_python(self.Finish))
        if self.FinishVariance is not None:
            showIndent(outfile, level)
            outfile.write('FinishVariance=%s,\n' % quote_python(self.FinishVariance))
        if self.Hyperlink is not None:
            showIndent(outfile, level)
            outfile.write('Hyperlink=%s,\n' % quote_python(self.Hyperlink))
        if self.HyperlinkAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkAddress=%s,\n' % quote_python(self.HyperlinkAddress))
        if self.HyperlinkSubAddress is not None:
            showIndent(outfile, level)
            outfile.write('HyperlinkSubAddress=%s,\n' % quote_python(self.HyperlinkSubAddress))
        if self.WorkVariance is not None:
            showIndent(outfile, level)
            outfile.write('WorkVariance=%s,\n' % quote_python(self.WorkVariance))
        if self.HasFixedRateUnits is not None:
            showIndent(outfile, level)
            outfile.write('HasFixedRateUnits=%s,\n' % quote_python(self.HasFixedRateUnits))
        if self.FixedMaterial is not None:
            showIndent(outfile, level)
            outfile.write('FixedMaterial=%s,\n' % quote_python(self.FixedMaterial))
        if self.LevelingDelay is not None:
            showIndent(outfile, level)
            outfile.write('LevelingDelay=%s,\n' % quote_python(self.LevelingDelay))
        if self.LevelingDelayFormat is not None:
            showIndent(outfile, level)
            outfile.write('LevelingDelayFormat=%s,\n' % quote_python(self.LevelingDelayFormat))
        if self.LinkedFields is not None:
            showIndent(outfile, level)
            outfile.write('LinkedFields=%s,\n' % quote_python(self.LinkedFields))
        if self.Milestone is not None:
            showIndent(outfile, level)
            outfile.write('Milestone=%s,\n' % quote_python(self.Milestone))
        if self.Notes is not None:
            showIndent(outfile, level)
            outfile.write('Notes=%s,\n' % quote_python(self.Notes))
        if self.Overallocated is not None:
            showIndent(outfile, level)
            outfile.write('Overallocated=%s,\n' % quote_python(self.Overallocated))
        if self.OvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeCost=%s,\n' % quote_python(self.OvertimeCost))
        if self.OvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('OvertimeWork=%s,\n' % quote_python(self.OvertimeWork))
        if self.RegularWork is not None:
            showIndent(outfile, level)
            outfile.write('RegularWork=%s,\n' % quote_python(self.RegularWork))
        if self.RemainingCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingCost=%s,\n' % quote_python(self.RemainingCost))
        if self.RemainingOvertimeCost is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeCost=%s,\n' % quote_python(self.RemainingOvertimeCost))
        if self.RemainingOvertimeWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingOvertimeWork=%s,\n' % quote_python(self.RemainingOvertimeWork))
        if self.RemainingWork is not None:
            showIndent(outfile, level)
            outfile.write('RemainingWork=%s,\n' % quote_python(self.RemainingWork))
        if self.ResponsePending is not None:
            showIndent(outfile, level)
            outfile.write('ResponsePending=%s,\n' % quote_python(self.ResponsePending))
        if self.Start is not None:
            showIndent(outfile, level)
            outfile.write('Start=%s,\n' % quote_python(self.Start))
        if self.Stop is not None:
            showIndent(outfile, level)
            outfile.write('Stop=%s,\n' % quote_python(self.Stop))
        if self.Resume is not None:
            showIndent(outfile, level)
            outfile.write('Resume=%s,\n' % quote_python(self.Resume))
        if self.StartVariance is not None:
            showIndent(outfile, level)
            outfile.write('StartVariance=%s,\n' % quote_python(self.StartVariance))
        if self.Units is not None:
            showIndent(outfile, level)
            outfile.write('Units=%s,\n' % quote_python(self.Units))
        if self.UpdateNeeded is not None:
            showIndent(outfile, level)
            outfile.write('UpdateNeeded=%s,\n' % quote_python(self.UpdateNeeded))
        if self.VAC is not None:
            showIndent(outfile, level)
            outfile.write('VAC=%s,\n' % quote_python(self.VAC))
        if self.Work is not None:
            showIndent(outfile, level)
            outfile.write('Work=%s,\n' % quote_python(self.Work))
        if self.WorkContour is not None:
            showIndent(outfile, level)
            outfile.write('WorkContour=%s,\n' % quote_python(self.WorkContour))
        if self.BCWS is not None:
            showIndent(outfile, level)
            outfile.write('BCWS=%s,\n' % quote_python(self.BCWS))
        if self.BCWP is not None:
            showIndent(outfile, level)
            outfile.write('BCWP=%s,\n' % quote_python(self.BCWP))
        if self.BookingType is not None:
            showIndent(outfile, level)
            outfile.write('BookingType=%s,\n' % quote_python(self.BookingType))
        if self.ActualWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualWorkProtected=%s,\n' % quote_python(self.ActualWorkProtected))
        if self.ActualOvertimeWorkProtected is not None:
            showIndent(outfile, level)
            outfile.write('ActualOvertimeWorkProtected=%s,\n' % quote_python(self.ActualOvertimeWorkProtected))
        if self.CreationDate is not None:
            showIndent(outfile, level)
            outfile.write('CreationDate=%s,\n' % quote_python(self.CreationDate))
        showIndent(outfile, level)
        outfile.write('ExtendedAttribute=[\n')
        level += 1
        for ExtendedAttribute_ in self.ExtendedAttribute:
            showIndent(outfile, level)
            outfile.write('model_.ExtendedAttribute(\n')
            ExtendedAttribute_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('Baseline=[\n')
        level += 1
        for Baseline_ in self.Baseline:
            showIndent(outfile, level)
            outfile.write('model_.Baseline(\n')
            Baseline_.exportLiteral(outfile, level)
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
        showIndent(outfile, level)
        outfile.write('TimephasedData=[\n')
        level += 1
        for TimephasedData_ in self.TimephasedData:
            showIndent(outfile, level)
            outfile.write('model_.TimephasedDataType(\n')
            TimephasedData_.exportLiteral(outfile, level, name_='TimephasedDataType')
            showIndent(outfile, level)
            outfile.write('),\n')
        level -= 1
        showIndent(outfile, level)
        outfile.write('],\n')
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        if child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UID':
            UID_ = ''
            for text__content_ in child_.childNodes:
                UID_ += text__content_.nodeValue
            self.UID = UID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TaskUID':
            TaskUID_ = ''
            for text__content_ in child_.childNodes:
                TaskUID_ += text__content_.nodeValue
            self.TaskUID = TaskUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ResourceUID':
            ResourceUID_ = ''
            for text__content_ in child_.childNodes:
                ResourceUID_ += text__content_.nodeValue
            self.ResourceUID = ResourceUID_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'PercentWorkComplete':
            PercentWorkComplete_ = ''
            for text__content_ in child_.childNodes:
                PercentWorkComplete_ += text__content_.nodeValue
            self.PercentWorkComplete = PercentWorkComplete_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualCost':
            ActualCost_ = ''
            for text__content_ in child_.childNodes:
                ActualCost_ += text__content_.nodeValue
            self.ActualCost = ActualCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualFinish':
            ActualFinish_ = ''
            for text__content_ in child_.childNodes:
                ActualFinish_ += text__content_.nodeValue
            self.ActualFinish = ActualFinish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeCost':
            ActualOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeCost_ += text__content_.nodeValue
            self.ActualOvertimeCost = ActualOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWork':
            ActualOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWork_ += text__content_.nodeValue
            self.ActualOvertimeWork = ActualOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualStart':
            ActualStart_ = ''
            for text__content_ in child_.childNodes:
                ActualStart_ += text__content_.nodeValue
            self.ActualStart = ActualStart_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWork':
            ActualWork_ = ''
            for text__content_ in child_.childNodes:
                ActualWork_ += text__content_.nodeValue
            self.ActualWork = ActualWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ACWP':
            ACWP_ = ''
            for text__content_ in child_.childNodes:
                ACWP_ += text__content_.nodeValue
            self.ACWP = ACWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Confirmed':
            Confirmed_ = ''
            for text__content_ in child_.childNodes:
                Confirmed_ += text__content_.nodeValue
            self.Confirmed = Confirmed_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Cost':
            Cost_ = ''
            for text__content_ in child_.childNodes:
                Cost_ += text__content_.nodeValue
            self.Cost = Cost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CostRateTable':
            CostRateTable_ = ''
            for text__content_ in child_.childNodes:
                CostRateTable_ += text__content_.nodeValue
            self.CostRateTable = CostRateTable_
            self.validate_CostRateTable(self.CostRateTable)    # validate type CostRateTable
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CostVariance':
            CostVariance_ = ''
            for text__content_ in child_.childNodes:
                CostVariance_ += text__content_.nodeValue
            self.CostVariance = CostVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CV':
            CV_ = ''
            for text__content_ in child_.childNodes:
                CV_ += text__content_.nodeValue
            self.CV = CV_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Delay':
            Delay_ = ''
            for text__content_ in child_.childNodes:
                Delay_ += text__content_.nodeValue
            self.Delay = Delay_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Finish':
            Finish_ = ''
            for text__content_ in child_.childNodes:
                Finish_ += text__content_.nodeValue
            self.Finish = Finish_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FinishVariance':
            FinishVariance_ = ''
            for text__content_ in child_.childNodes:
                FinishVariance_ += text__content_.nodeValue
            self.FinishVariance = FinishVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Hyperlink':
            Hyperlink_ = ''
            for text__content_ in child_.childNodes:
                Hyperlink_ += text__content_.nodeValue
            self.Hyperlink = Hyperlink_
            self.validate_Hyperlink(self.Hyperlink)    # validate type Hyperlink
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkAddress':
            HyperlinkAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkAddress_ += text__content_.nodeValue
            self.HyperlinkAddress = HyperlinkAddress_
            self.validate_HyperlinkAddress(self.HyperlinkAddress)    # validate type HyperlinkAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HyperlinkSubAddress':
            HyperlinkSubAddress_ = ''
            for text__content_ in child_.childNodes:
                HyperlinkSubAddress_ += text__content_.nodeValue
            self.HyperlinkSubAddress = HyperlinkSubAddress_
            self.validate_HyperlinkSubAddress(self.HyperlinkSubAddress)    # validate type HyperlinkSubAddress
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkVariance':
            WorkVariance_ = ''
            for text__content_ in child_.childNodes:
                WorkVariance_ += text__content_.nodeValue
            self.WorkVariance = WorkVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'HasFixedRateUnits':
            HasFixedRateUnits_ = ''
            for text__content_ in child_.childNodes:
                HasFixedRateUnits_ += text__content_.nodeValue
            self.HasFixedRateUnits = HasFixedRateUnits_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'FixedMaterial':
            FixedMaterial_ = ''
            for text__content_ in child_.childNodes:
                FixedMaterial_ += text__content_.nodeValue
            self.FixedMaterial = FixedMaterial_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelingDelay':
            LevelingDelay_ = ''
            for text__content_ in child_.childNodes:
                LevelingDelay_ += text__content_.nodeValue
            self.LevelingDelay = LevelingDelay_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LevelingDelayFormat':
            LevelingDelayFormat_ = ''
            for text__content_ in child_.childNodes:
                LevelingDelayFormat_ += text__content_.nodeValue
            self.LevelingDelayFormat = LevelingDelayFormat_
            self.validate_LevelingDelayFormat(self.LevelingDelayFormat)    # validate type LevelingDelayFormat
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'LinkedFields':
            LinkedFields_ = ''
            for text__content_ in child_.childNodes:
                LinkedFields_ += text__content_.nodeValue
            self.LinkedFields = LinkedFields_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Milestone':
            Milestone_ = ''
            for text__content_ in child_.childNodes:
                Milestone_ += text__content_.nodeValue
            self.Milestone = Milestone_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Notes':
            Notes_ = ''
            for text__content_ in child_.childNodes:
                Notes_ += text__content_.nodeValue
            self.Notes = Notes_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Overallocated':
            Overallocated_ = ''
            for text__content_ in child_.childNodes:
                Overallocated_ += text__content_.nodeValue
            self.Overallocated = Overallocated_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeCost':
            OvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                OvertimeCost_ += text__content_.nodeValue
            self.OvertimeCost = OvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'OvertimeWork':
            OvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                OvertimeWork_ += text__content_.nodeValue
            self.OvertimeWork = OvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RegularWork':
            RegularWork_ = ''
            for text__content_ in child_.childNodes:
                RegularWork_ += text__content_.nodeValue
            self.RegularWork = RegularWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingCost':
            RemainingCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingCost_ += text__content_.nodeValue
            self.RemainingCost = RemainingCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeCost':
            RemainingOvertimeCost_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeCost_ += text__content_.nodeValue
            self.RemainingOvertimeCost = RemainingOvertimeCost_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingOvertimeWork':
            RemainingOvertimeWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingOvertimeWork_ += text__content_.nodeValue
            self.RemainingOvertimeWork = RemainingOvertimeWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'RemainingWork':
            RemainingWork_ = ''
            for text__content_ in child_.childNodes:
                RemainingWork_ += text__content_.nodeValue
            self.RemainingWork = RemainingWork_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ResponsePending':
            ResponsePending_ = ''
            for text__content_ in child_.childNodes:
                ResponsePending_ += text__content_.nodeValue
            self.ResponsePending = ResponsePending_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Start':
            Start_ = ''
            for text__content_ in child_.childNodes:
                Start_ += text__content_.nodeValue
            self.Start = Start_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Stop':
            Stop_ = ''
            for text__content_ in child_.childNodes:
                Stop_ += text__content_.nodeValue
            self.Stop = Stop_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Resume':
            Resume_ = ''
            for text__content_ in child_.childNodes:
                Resume_ += text__content_.nodeValue
            self.Resume = Resume_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'StartVariance':
            StartVariance_ = ''
            for text__content_ in child_.childNodes:
                StartVariance_ += text__content_.nodeValue
            self.StartVariance = StartVariance_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Units':
            Units_ = ''
            for text__content_ in child_.childNodes:
                Units_ += text__content_.nodeValue
            self.Units = Units_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'UpdateNeeded':
            UpdateNeeded_ = ''
            for text__content_ in child_.childNodes:
                UpdateNeeded_ += text__content_.nodeValue
            self.UpdateNeeded = UpdateNeeded_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'VAC':
            VAC_ = ''
            for text__content_ in child_.childNodes:
                VAC_ += text__content_.nodeValue
            self.VAC = VAC_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Work':
            Work_ = ''
            for text__content_ in child_.childNodes:
                Work_ += text__content_.nodeValue
            self.Work = Work_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'WorkContour':
            WorkContour_ = ''
            for text__content_ in child_.childNodes:
                WorkContour_ += text__content_.nodeValue
            self.WorkContour = WorkContour_
            self.validate_WorkContour(self.WorkContour)    # validate type WorkContour
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWS':
            BCWS_ = ''
            for text__content_ in child_.childNodes:
                BCWS_ += text__content_.nodeValue
            self.BCWS = BCWS_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BCWP':
            BCWP_ = ''
            for text__content_ in child_.childNodes:
                BCWP_ += text__content_.nodeValue
            self.BCWP = BCWP_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'BookingType':
            BookingType_ = ''
            for text__content_ in child_.childNodes:
                BookingType_ += text__content_.nodeValue
            self.BookingType = BookingType_
            self.validate_BookingType(self.BookingType)    # validate type BookingType
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualWorkProtected':
            ActualWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualWorkProtected_ += text__content_.nodeValue
            self.ActualWorkProtected = ActualWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ActualOvertimeWorkProtected':
            ActualOvertimeWorkProtected_ = ''
            for text__content_ in child_.childNodes:
                ActualOvertimeWorkProtected_ += text__content_.nodeValue
            self.ActualOvertimeWorkProtected = ActualOvertimeWorkProtected_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'CreationDate':
            CreationDate_ = ''
            for text__content_ in child_.childNodes:
                CreationDate_ += text__content_.nodeValue
            self.CreationDate = CreationDate_
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'ExtendedAttribute':
            obj_ = ExtendedAttribute.factory()
            obj_.build(child_)
            self.ExtendedAttribute.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'Baseline':
            obj_ = Baseline.factory()
            obj_.build(child_)
            self.Baseline.append(obj_)
        elif child_.nodeType == Node.ELEMENT_NODE and \
            nodeName_ == 'TimephasedData':
            obj_ = TimephasedDataType.factory()
            obj_.build(child_)
            self.TimephasedData.append(obj_)
# end class Assignment


class CostRateTable(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if CostRateTable.subclass:
            return CostRateTable.subclass(*args_, **kwargs_)
        else:
            return CostRateTable(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='CostRateTable', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='CostRateTable')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='CostRateTable'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='CostRateTable'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='CostRateTable'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class CostRateTable


class WorkContour(GeneratedsSuper):
    subclass = None
    superclass = None
    def __init__(self, valueOf_=None):
        self.valueOf_ = valueOf_
    def factory(*args_, **kwargs_):
        if WorkContour.subclass:
            return WorkContour.subclass(*args_, **kwargs_)
        else:
            return WorkContour(*args_, **kwargs_)
    factory = staticmethod(factory)
    def getValueOf_(self): return self.valueOf_
    def setValueOf_(self, valueOf_): self.valueOf_ = valueOf_
    def export(self, outfile, level, namespace_='', name_='WorkContour', namespacedef_=''):
        showIndent(outfile, level)
        outfile.write('<%s%s%s' % (namespace_, name_, namespacedef_ and ' ' + namespacedef_ or '', ))
        self.exportAttributes(outfile, level, namespace_, name_='WorkContour')
        if self.hasContent_():
            outfile.write('>')
            self.exportChildren(outfile, level + 1, namespace_, name_)
            outfile.write('</%s%s>\n' % (namespace_, name_))
        else:
            outfile.write('/>\n')
    def exportAttributes(self, outfile, level, namespace_='', name_='WorkContour'):
        pass
    def exportChildren(self, outfile, level, namespace_='', name_='WorkContour'):
        if self.valueOf_.find('![CDATA') > -1:
            value=quote_xml('%s' % self.valueOf_)
            value=value.replace('![CDATA','<![CDATA')
            value=value.replace(']]',']]>')
            outfile.write(value)
        else:
            outfile.write(quote_xml('%s' % self.valueOf_))
    def hasContent_(self):
        if (
            self.valueOf_
            ):
            return True
        else:
            return False
    def exportLiteral(self, outfile, level, name_='WorkContour'):
        level += 1
        self.exportLiteralAttributes(outfile, level, name_)
        if self.hasContent_():
            self.exportLiteralChildren(outfile, level, name_)
    def exportLiteralAttributes(self, outfile, level, name_):
        pass
    def exportLiteralChildren(self, outfile, level, name_):
        showIndent(outfile, level)
        outfile.write('valueOf_ = """%s""",\n' % (self.valueOf_,))
    def build(self, node_):
        attrs = node_.attributes
        self.buildAttributes(attrs)
        self.valueOf_ = ''
        for child_ in node_.childNodes:
            nodeName_ = child_.nodeName.split(':')[-1]
            self.buildChildren(child_, nodeName_)
    def buildAttributes(self, attrs):
        pass
    def buildChildren(self, child_, nodeName_):
        self.valueOf_ = ''
        if child_.nodeType == Node.TEXT_NODE:
            self.valueOf_ += child_.nodeValue
        elif child_.nodeType == Node.CDATA_SECTION_NODE:
            self.valueOf_ += '![CDATA['+child_.nodeValue+']]'
# end class WorkContour


USAGE_TEXT = """
Usage: python <Parser>.py [ -s ] <in_xml_file>
"""

def usage():
    print(USAGE_TEXT)
    sys.exit(1)


def parse(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = Project.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    #sys.stdout.write('<?xml version="1.0" ?>\n')
    #rootObj.export(sys.stdout, 0, name_="Project", 
    #    namespacedef_='')
    return rootObj


def parseString(inString):
    doc = minidom.parseString(inString)
    rootNode = doc.documentElement
    rootObj = Project.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    #sys.stdout.write('<?xml version="1.0" ?>\n')
    #rootObj.export(sys.stdout, 0, name_="Project",
    #    namespacedef_='')
    return rootObj


def parseLiteral(inFileName):
    doc = minidom.parse(inFileName)
    rootNode = doc.documentElement
    rootObj = Project.factory()
    rootObj.build(rootNode)
    # Enable Python to collect the space used by the DOM.
    doc = None
    #sys.stdout.write('#from mspdi_2003_classes import *\n\n')
    #sys.stdout.write('import mspdi_2003_classes as model_\n\n')
    #sys.stdout.write('rootObj = model_.Project(\n')
    #rootObj.exportLiteral(sys.stdout, 0, name_="Project")
    #sys.stdout.write(')\n')
    return rootObj


def main():
    args = sys.argv[1:]
    if len(args) == 1:
        parse(args[0])
    else:
        usage()


if __name__ == '__main__':
    #import pdb; pdb.set_trace()
    main()

